#include-once
;~ #AutoIt3Wrapper_Au3Check_Parameters=-d -w 1 -w 2 -w 3 -w 4 -w 5 -w 6 -w- 7
#AutoIt3Wrapper_Au3Check_Parameters=-q -d -w 1 -w 2 -w 3 -w- 4 -w 5 -w 6 -w- 7
#Tidy_Parameters=/sort_funcs /reel
#AutoIt3Wrapper_Run_Debug_Mode=N
#Au3Stripper_Ignore_Funcs=_QPDF_Shutdown
OnAutoItExitRegister(_QPDF_Shutdown) ; in case the script exit without calling _QPDF_Shutdown()

#Region QuickPDF.au3 - #Include
#include <GUIConstantsEx.au3>
#include <MsgBoxConstants.au3>
#include <FileConstants.au3>
#include <String.au3>
#include <WinAPIFiles.au3>
#include <WinAPI.au3>
#include <File.au3>
#include <math.au3>
#EndRegion QuickPDF.au3 - #Include

#Region QuickPDF.au3 - Functions
#EndRegion QuickPDF.au3 - Functions

#Region QuickPDF.au3 - UDF Header
; #INDEX# =======================================================================================================================
; Title .........: UDF for "Debenu Quick PDF Library"
; AutoIt Version : 3.3.10.2++
; Language ......: English
; Description ...: A collection of functions for Debenu Quick PDF Library
; Author(s) .....: mLipok
; Modified ......:
; ===============================================================================================================================
#cs
	Title:   UDF for "Debenu Quick PDF Library"
	Filename:  QuickPDF.au3
	Description: A collection of functions for Debenu Quick PDF Library
	Author:   mLipok
	Modified:
	Last Update: 2014/05/11
	Requirements:
	AutoIt 3.3.10.2 or higher

	Debenu Quick PDF Library - Commercial or Lite version
	http://www.debenu.com/products/development/debenu-pdf-library/

	Remarks:
	If you want to use the Lite version then you must be aware of its limitations.

	Ultimately, I'm going to create wraped function for all functions available in the Lite version,
	because in this way you will be able to easily use only this set
	(the function name will remind you of the fact of using the Lite version).

	info about:
	Debenu Quick PDF Library Lite version
	http://www.debenu.com/products/development/debenu-pdf-library-lite/

	list of avalaible Function in Lite version you can find in:
	"Debenu Quick PDF Library 11.14 Reference Guide.pdf"

	or a copy of the list on the following:
	"Appendix C: Functions available in the Lite Edition"
	AddImageFromFile
	AddLinkToWeb
	AddStandardFont
	DocumentCount
	DrawQRCode
	DrawImage
	DrawText
	DrawTextBox
	FindImages
	GetInformation
	GetPageBox
	HasFontResources
	ImageCount
	ImageHeight
	ImageWidth
	LastErrorCode
	Linearized
	LoadFromFile
	MergeDocument
	NewDocument
	NewPage
	NormalizePage
	PageCount
	PageHeight
	PageRotation
	PageWidth
	RemoveDocument
	RotatePage
	SaveToFile
	SecurityInfo
	SelectDocument
	SelectedDocument
	SelectFont
	SelectImage
	SelectPage
	SetBaseURL
	SetInformation
	SetMeasurementUnits
	SetOrigin
	SetPageBox
	SetPageDimensions
	SetPageLayout
	SetPageMode
	SetPageSize
	SetTextAlign
	SetTextColor
	SetTextSize
	SetTextUnderline

	Update History:
	===================================================
	2014/04/25
	v0.1 First unoficial version - mLipok
	*
	*
	===================================================
	2014/05/06
	v0.2
	* 	Added: Many new function - mLipok
	* 	Added: Examples - mLipok
	*
	*
	===================================================
	2014/05/14
	v0.3
	*
	*	Removed: examples from QuickPDF.au3 - mLipok
	* 	Added: separate file with examples QuickPDF_Examples.au3 - mLipok
	* 	Added: _QPDF_StartUp() - mLipok
	* 	Added: __QPDF_NewLibraryPath_Commercial() - mLipok
	* 	ADDED: _QPDF_NewLibraryPath_Lite() - mLipok
	* 	Changed: __AddLeadingZeros >> __QPDF_AddLeadingZeros - mLipok
	* 	Changed: CleanUp - mLipok
	*	Changed: _QPdf_ >> _QPDF_ - mLipok
	* 	Changed: Function Header - significantly supplemented - mLipok
	* 	Added: additional comments - mLipok
	* 	Added: new set of enum constants - mLipok
	*
	*	!!!!!!!!!!!!!!! SCRIPT BREAKING CHANGE !!!!!!!!!!!!!!!
	*	Changed: Lite Function renaming - mLipok
	*		to change your script you can use:
	*		ClipPut(StringRegExpReplace(ClipGet(),'(?i)(_QPDF)(_Lite)(_.*?)(\(|\R)','$1$3$2$4'))
	*	Changed: all functions which starts with "_QPDF__" now starts with "_QPDF_"  it means one less "_" - mLipok
	*	Changed: _QPDF_FileSplitEachPage added new Parameters $sPDF_Password (as a second not third so $sDestinationDir is moved to third position - mLipok
	*	Changed: __QPDF_CreateObjectAndUnlock($oQP) change to _QPDF_CreateObjectAndUnlock($oQP) its mean is not internal any more - mLipok
	*
	*
	===================================================
	2014/05/31
	v0.4
	*
	QuickPDF.au3
	*	Changed: in __QPDF_UnlockKey() - Remarks changed - mLipok
	*	Fixed: in _QPDF_StartUp() fixed: 'If Not FileExists($sDLLFile) Then' removed 'Not' - mLipok
	*		because of this process did not work on systems where the library was not registered using regsvr32.exe.
	*	Added: in _QPDF_StartUp() added: return values, but their functionality is not yet implemented and described (be expected to change within a week) - mLipok
	*	Added: new function: _QPDF_PrintPDFFile([$sPDF_FileFullPath = Default[, $sPDFPassword = ''[, $iDuplex = 1 ]]]) - mLipok
	*	Added: new function: _QPDF_MergeFiles($sFirstFileFullPath, $sSecondFileFullPath[, $sOutputFileName = Default]) - mLipok
	*
	QuickPDF_Examples.au3
	*	Added: new example _QPDF_Example_MergeFiles() - mLipok
	*
	*
	===================================================
	2014/05/31
	v0.5
	*
	QuickPDF.au3
	*	FIXED: in _QPDF_PrintPDFFile now printing all pages :) not only the first one :( - mLipok
	*
	*
	===================================================
	2014/07/02
	v0.6
	*
	QuickPDF.au3
	*	Added: #AutoIt3Wrapper_Au3Check_Parameters=-d -w 1 -w 2 -w 3 -w- 4 -w 5 -w 6 -w 7    and script CleanUp - mLipok
	*	Added: new function _QPDF_ExtractTextFromStream() - you can use this function when you have data taken from Blob from SQL databese - mLipok
	*	Added: new parameters __QPDF_NewLibraryPath_Commercial($sLibrary_NewFileFullPath, $sNewClassName, $sNewCLSID, $sNewIID) - mLipok
	*	Changed: #Region renaming - for better usage in SciTE Jump - mLipok
	*	Changed: in _QPDF_MergeFiles() -- litle change in $sOutputFileName = Default - add & '_temp.pdf' instead 'temp.pdf' - mLipok
	*	Changed: _QPDF_LastErrorCode -- Return Value containg description (string) and @error contain LastErrorCode - mLipok
	*	Changed: _QPDF_ExtractTextFromFile    default $iExtractOptions = 7 for detail see here : http://www.quickpdf.org/forum/extractfilepagetext-options-0-and-8_topic2929.html - mLipok
	*	Removed: some MsgBox - mLipok
	*   Fixed: _QPDF_StartUp() - error checking for DllOpen - mLipok
	*
	QuickPDF_Examples.au3
	*	Added: using new function __QPDF_NewLibraryPath_Commercial() - mLipok
	*		for this you need DebenuPDFLibraryAX1015.dll
	*		__QPDF_NewLibraryPath_Commercial(@ScriptDir & '\DebenuPDFLibraryAX1015.dll', 'DebenuPDFLibraryAX1015.PDFLibrary', '{5D4196E9-0A7D-48DC-BD2C-7CD3FE771B38}', '{FA7270CF-D774-4A68-8368-2C3179895E0C}')
	*
	QuickPDF_Calltip_Generator.au3
	*	NEW:  use it to generate au3.QuickPDF.calltips.api - mLipok
	*
	*
	===================================================
	2014/07/02
	v0.6b
	*
	*	Added: new enum: Parameters for DrawTextBox $__eQPDF_DTBOX_VAlign* - mLipok
	*	Changed: enum renamed from $__QPDF_...... to $__eQPDF_...... - mLipok
	*
	*
	===================================================
	2015/05/xx
	v0.6c intermediate version
	*
	*	No documentation - mLipok
	*		https://www.autoitscript.com/forum/topic/160875-debenu-quick-pdf-library-udf/?page=2#comment-1240768
	*
	*
	===================================================
	2015/06/15
	v0.7
	*
	QuickPDF.au3
	*	Added: many code descriptions - mLipok
	*	Added: enums $__eQPDF_ERROR_* for error checking - mLipok
	*	Added: error checking (each function should return @error @extended and ReturnValues ) - mLipok
	*	Added: New function __QPDF_ObjIsValid() - mLipok
	*	Added: New function _QPDF_CreateObjectFromStream() - mLipok
	*	Added: New function _QPDF_Display() - mLipok
	*	Added: New function _QPDF_Display_PDFFile() - mLipok
	*	Added: New function _QPDF_FolderExtractText() - mLipok
	*	Added: New function _QPDF_GetInformation() - mLipok
	*	Added: New function _QPDF_GetInformationEx_Lite() - mLipok
	*	Added: New function _QPDF_GetPageMetricsToString() - mLipok
	*	Added: New function _QPDF_MergeFiles_Lite() - mLipok
	*	Added: New function _QPDF_Page_2in1() - mLipok
	*	Added: New function _QPDF_Page_2in1_File() - mLipok
	*	Added: New function _QPDF_PrintFromStream() - mLipok
	*	Added: New function _QPDF_ReplaceFonts_in_File() - mLipok
	*	Added: New function _QPDF_Rotate_Lite() - mLipok
	*	Added: New function _QPDF_RotateFileLeft_Lite() - mLipok
	*	Added: New function _QPDF_RotateFileRight_Lite() - mLipok
	*	Added: New function _QPDF_SaveAndOpen() - mLipok
	*	Added: New function _QPDF_StringInPDFFile() - mLipok
	*	Added: New function _QPDF_StringInPDFStrem() - mLipok
	*	Added: New function _QPDF_TextToHtml() - mLipok
	*	Added: New function _QPDF_TXT_to_PDF() - mLipok
	*	Added: New function _QPDF_TXT_to_PDF_Lite() - mLipok
	*	Added: New function _QPDF_TXTFile_to_PDFFile() - mLipok
	*	Added: New function _QPDF_UDF_ErrorDescription() - mLipok
	*	Added: New function _QPDF_Html_Font_BackgroundColor() - mLipok
	*	Added: New function _Matrix_Create() - mLipok
	*	Added: New function _Matrix_Move() - mLipok
	*	Added: New function _Matrix_Rotate() - mLipok
	*	Added: New function _Matrix_Skew() - mLipok
	*	Added: New function _Matrix_Zoom() - mLipok
	*	Added: in _QPDF_A4toA5() Function added $oQP.NormalizePage(0) - mLipok
	*	Added: in _QPDF_DrawText_Lite() Function added $oQP.NormalizePage(0) - mLipok
	*	Added: _QPDF_ExtractTextFromFile() return values @Extended = $iTotalPages - mLipok
	*	Added: in _QPDF_PrintPDFFile addded new parameter >>> $sPrinterName - mLipok
	*	Added: __QPDF_NewLibraryPath_Commercial - mLipok
	*	Changed: __QPDF_NewLibraryPath_Commercial() is now Internal Function - mLipok
	*	Changed: __QPDF_UnlockKey() now have only one parameter - mLipok
	*	Changed: _QPDF_CreateObject() rewriten to give complet Error Checking - mLipok
	*	Changed: _QPDF_CreateObjectAndUnlock() rewriten to give complet Error Checking - mLipok
	*	Changed: _QPDF_SetLicenseKey() rewriten to give complet Error Checking - mLipok
	*	Changed: _QPDF_ExtractTextFromStream() use _QPDF_ExtractAllText() - mLipok
	*	Renamed: $__fNotification_QPDF to $__bNotification_QPDF - mLipok
	*	Removed: parameter $sLicenseKey from __QPDF_UnlockKey() function - is not needed as unlock is only for Commercial and License key is checked befor this function is called - mLipok
	*
	*	!!!!!!!!!!!!!!! SCRIPT BREAKING CHANGE !!!!!!!!!!!!!!!
	*	Removed: parameters $sPDF_Password from _QPDF_ExtractAllText() function - as is not needed - mLipok
	*	Changed: $__eQPDF_ERROR_DebenuLicense >> $__eQPDF_ERROR_INVALIDLICENSEKEY - mLipok
	*	Changed: _QPDF_ExtractTextFromFile(.. , $iExtractOptions --> default is 7 previously 8 - mLipok
	*	Changed: _QPDF_NewLibraryPath_Commercial($sDLL_FileFullPath) now have only ONE parameter - mLipok
	*	Changed: _QPDF_RotateFile_Lite($sPDF_FileFullPath[, $iPageRotation = 0]) now have only ONE parameter - mLipok
	*
	*
	===================================================
	2015/08/xx
	v0.8 alpha-1
	*
	QuickPDF.au3
	*	Added: Function:  _QPDF_Arrow() - mLipok
	*	Added: ENUMS: $QPDF_EXT_ - mLipok
	*	Added: ENUMS: $QPDF_RET_DEFAULT = 0, $QPDF_RET_FAILURE = -1 - mLipok
	*
	*	!!!!!!!!!!!!!!! SCRIPT BREAKING CHANGE !!!!!!!!!!!!!!!
	*	Changed: ENUMS:  $__EQPDF_RETURN_ >> $QPDF_RET_ - mLipok
	*	Changed: ENUMS:  $__eQPDF_ERROR_ >> $QPDF_ERR_ - mLipok
	*	Changed: ENUMS:  $QPDF_ERR_ALL_IS_OK >> $QPDF_ERR_OK - mLipok
	*	Renamed: Function: __QPDF_ObjIsValid >> __QPDF_IsValidObject - mLipok
	*	Changed: ENUMS:  $QPDF_RET_  changed concept - ERRORS are < 0 - mLipok
	*			but if you want to check I function return with Succesc you must chceck
	*	Removed: ENUM: $QPDF_RET_OBJCREATE_ERROR - mLipok
	*	Removed: ENUM: $QPDF_RET_INVALID_COMMERCIAL_LICENSE_KEY - mLipok
	*
	*
	===================================================
	2015/11/06
	v0.8 alpha-2
	*
	*	Added: support for QPDFLibrary 12.11 - now is default - mLipok
	*
	*
	===================================================
	2015/11/17
	v0.8 alpha-3
	*
	*	New: Function: _QPDF_PageEnumerator - mLipok
	*	New: Function: _QPDF_Example_ExtractImages - mLipok
	*	Renamed: Enum: $QPDF_ERR_ISLITEINSTEADCOMMERCIAL >> $QPDF_ERR_ISLITE - mLipok
	*	Renamed: Enum: $QPDF_ERR_ISCOMMERCIALINSTEADLITE >> $QPDF_ERR_ISCOMMERCIAL - mLipok
	*	Renamed: Enum: $QPDF_ERR_ISNOTBEBENUOBJECT >> $QPDF_ERR_ISNOTBEBENU - mLipok
	*	Added: support for   DebenuPDFLibraryCPAX1211.dll  - mLipok
	*		http://labs.debenu.com/2015/11/09/debenu-quick-pdf-library-12-11-downloads/
	*		http://www.debenu.com/downloads/installers/debenu_quick_pdf_library_win.zip
	*	Changed: Function: _QPDF_Page_2in1_File - on succes return $sSAVE_FileFullPath - mLipok
	*
	*
	===================================================
	2016/06/13
	v0.8
	*
	* 	Added: support for DebenuPDFLibraryAX1212.dll - Now this is default setting - mLipok
	*	Added: #Au3Stripper_Ignore_Funcs=_QPDF_Shutdown - mLipok
	*	Changed: Refactored (If Then Else EndIf + Return) in many funciton - mLipok
	*
	*
	*
	*

	@LAST CHANGE HERE

#CE
#EndRegion QuickPDF.au3 - UDF Header

#Region QuickPDF.au3 - Global #VARIABLES#

; #VARIABLES# ===================================================================================================================
; $__g<VARNAME>_<UDF>
Global $__hDll_QPDF = 0
Global $__ErrorHandler_QPDF = ''
Global $__bNotification_QPDF = True

; Commercial Library
Global $__sDebenuPDFLibraryAX_FileFullPath = ''
Global $__sClassName_QPDF_Commercial = ''
Global $__sCLSID_Commercial = ''
Global $__sIID_Commercial = ''

; Here we pre set ClassName CLSID and IID
;~ _QPDF_NewLibraryPath_Commercial(@ScriptDir & '\DebenuPDFLibraryAX1211.dll')
;~ _QPDF_NewLibraryPath_Commercial(@ScriptDir & '\DebenuPDFLibraryCPAX1211.dll')
_QPDF_NewLibraryPath_Commercial(@ScriptDir & '\DebenuPDFLibraryAX1212.dll')

; *********  IMPORTANT  *********
; SET YOUR LICENSE KEY in your main script using _QPDF_SetLicenseKey()
; If you not set $__sLicenseKey_QPDF then Lite version be used .
Global $__sLicenseKey_QPDF = ''

; Lite Library:  DebenuPDFLibraryLite1112.dll
;~ Global $__sDebenuPDFLibraryLite_FileFullPath = @ScriptDir & '\DebenuPDFLibraryLite1112.dll'
;~ Global Const $__sClassName_QPDF_Lite = "DebenuPDFLibraryLite1112.PDFLibrary"
;~ Global Const $__sCLSID_Lite = '{3A0BE429-08CE-4183-8A8D-9CB0B00CB5A3}'
;~ Global Const $__sIID_Lite = '{0D585812-AAED-4680-829D-E447A7593E20}'

; Lite Library:  DebenuPDFLibraryLite1114.dll
Global $__sDebenuPDFLibraryLite_FileFullPath = @ScriptDir & '\DebenuPDFLibraryLite1114.dll'
Global Const $__sClassName_QPDF_Lite = 'DebenuPDFLibraryLite1114.PDFLibrary'
Global Const $__sCLSID_Lite = '{23860CC8-15E7-4AA8-931B-791A98001431}'
Global Const $__sIID_Lite = '{F9A0E70D-A4CC-43B7-9007-11362219DB79}'

#EndRegion QuickPDF.au3 - Global #VARIABLES#

#Region QuickPDF.au3 - #CONSTANTS#

; #CONSTANTS# ===================================================================================================================
; $__<UDF>_CONSTANT_<NAME>

; @TODO CHECK EXAMPLES
Const Enum _ ; UDF @Error Lists
		$QPDF_ERR_OK = 0, _
		$QPDF_ERR_GENERAL, _
		$QPDF_ERR_DLLFILENOTEXIST, _
		$QPDF_ERR_DLLINIT, _
		$QPDF_ERR_OBJCREATE, _
		$QPDF_ERR_ISNOTOBJECT, _
		$QPDF_ERR_ISNOTBEBENU, _
		$QPDF_ERR_ISLITE, _
		$QPDF_ERR_ISCOMMERCIAL, _
		$QPDF_ERR_INVALIDLICENSEKEY, _ ; PREVIOUSLY $QPDF_ERR_DEBENULICENSE
		$QPDF_ERR_ISSTILLLOCKED, _
		$QPDF_ERR_STREAMISNOTBINARY, _
		$QPDF_ERR_STREAMCANNOTBELOADED, _
		$QPDF_ERR_WRONGSTYLEPARAMETER, _
		$QPDF_ERR_ENUMCOUNTER

Const Enum _ ; UDF @extended Lists
		$QPDF_EXT_DEFAULT = 0, _
		$QPDF_EXT_ENUMCOUNTER

Const Enum _ ; UDF Return Value List
		$QPDF_RET_FAILURE = -1, _
		$QPDF_RET_DEFAULT, _
		$QPDF_RET_VALID_COMMERCIAL, _
		$QPDF_RET_VALID_LITE, _
		$QPDF_RET_ENUMCOUNTER

; Parameters for DrawTextBox, DrawTextBoxMatrix
Const Enum _
		$__eQPDF_DTBOX_VAlignCenter = 0, _
		$__eQPDF_DTBOX_VAlignTop, _
		$__eQPDF_DTBOX_VAlignBottom, _
		$__eQPDF_DTBOX_VAlignCenterNoWrapping, _
		$__eQPDF_DTBOX_VAlignTopNoWrapping, _
		$__eQPDF_DTBOX_VAlignBottomNoWrapping

; Parameters for SetMeasurementUnits
Const Enum _
		$__eQPDF_MUNITS_Default = 0, _
		$__eQPDF_MUNITS_Milimeters, _
		$__eQPDF_MUNITS_Inches

; Parameters for SetOrigin
Const Enum _
		$__eQPDF_SORIGIN_BottomLeft = 0, _
		$__eQPDF_SORIGIN_TopLeft, _
		$__eQPDF_SORIGIN_TopRight, _
		$__eQPDF_SORIGIN_BottomRight

; Parameters for SetTextAlign
Const Enum _
		$__eQPDF_TEXTALIGN_Left = 0, _
		$__eQPDF_TEXTALIGN_Center, _
		$__eQPDF_TEXTALIGN_Right, _
		$__eQPDF_TEXTALIGN_Justified, _
		$__eQPDF_TEXTALIGN_ForceJustified, _
		$__eQPDF_TEXTALIGN_LastLineJustified

; Parameters for SetTextMode
Const Enum _
		$__eQPDF_TEXTMODE_Filled = 0, _
		$__eQPDF_TEXTMODE_Outline, _
		$__eQPDF_TEXTMODE_FillAndStroke, _
		$__eQPDF_TEXTMODE_Invisible, _
		$__eQPDF_TEXTMODE_FillAndClipping, _
		$__eQPDF_TEXTMODE_StrokeAndClipping, _
		$__eQPDF_TEXTMODE_FillAndStrokeAndClipping, _
		$__eQPDF_TEXTMODE_Clipping

; Parameters for SetTextHighlight
Const Enum _
		$__eQPDF_TEXTHIGHLIGHT_None = 0, _
		$__eQPDF_TEXTHIGHLIGHT_Square, _
		$__eQPDF_TEXTHIGHLIGHT_Rounded

; Parameters for SetTextUnderline
Const Enum _
		$__eQPDF_TEXTUNDERLINE_None = 0, _
		$__eQPDF_TEXTUNDERLINE_Single, _
		$__eQPDF_TEXTUNDERLINE_Double, _
		$__eQPDF_TEXTUNDERLINE_Strikeout, _
		$__eQPDF_TEXTUNDERLINE_Over

; Parameters for SetTableCellBorderWidth
Const Enum _
		$__eQPDF_BORDERINDEX_All = 0, _
		$__eQPDF_BORDERINDEX_Left, _
		$__eQPDF_BORDERINDEX_Top, _
		$__eQPDF_BORDERINDEX_Right, _
		$__eQPDF_BORDERINDEX_Bottom

; Parameters for SetTableCellAlignment
Const Enum _
		$__eQPDF_CELLALIGNMENT_TopLeft = 0, _
		$__eQPDF_CELLALIGNMENT_TopCenter, _
		$__eQPDF_CELLALIGNMENT_TopRight, _
		$__eQPDF_CELLALIGNMENT_MiddleLeft, _
		$__eQPDF_CELLALIGNMENT_MiddleCenter, _
		$__eQPDF_CELLALIGNMENT_MiddleRight, _
		$__eQPDF_CELLALIGNMENT_BottomLeft, _
		$__eQPDF_CELLALIGNMENT_BottomCenter, _
		$__eQPDF_CELLALIGNMENT_BottomRight

; The blank one page document uses a Letter page size which is 8.5 x 11 inches or 215.9 mm x 279.4 mm. The page size can be changed using the SetPageSize
; Parameters for SetPageBox
Const _
		$__eQPDF_A4_WidthInMM = 210, _
		$__eQPDF_A4_HeightInMM = 297, _
		$__eQPDF_A4_WidthInMM_Landscape = 297, _
		$__eQPDF_A4_HeightInMM_Landscape = 210, _
		$__eQPDF_A5_WidthInMM = 148, _
		$__eQPDF_A5_HeightInMM = 210, _
		$__eQPDF_A5_WidthInMM_Landscape = 210, _
		$__eQPDF_A5_HeightInMM_Landscape = 148

; Parameters for SetPageBox, GetPageBox, DASetPageBox, DAGetPageBox
Const Enum _
		$__eQPDF_BOXTYPE_MediaBox = 1, _
		$__eQPDF_BOXTYPE_CropBox, _
		$__eQPDF_BOXTYPE_BleedBox, _
		$__eQPDF_BOXTYPE_TrimBox, _
		$__eQPDF_BOXTYPE_ArtBox

; Parameters for SetPageMode
Const Enum _
		$__eQPDF_PAGEMODE_NormalView = 0, _
		$__eQPDF_PAGEMODE_ShowOutlines, _
		$__eQPDF_PAGEMODE_ShowThumbnails, _
		$__eQPDF_PAGEMODE_FullScreenMode, _
		$__eQPDF_PAGEMODE_OptionalContentGroup, _
		$__eQPDF_PAGEMODE_ShowAttachments

; Parameters for SetPageLayout
Const Enum _
		$__eQPDF_PAGELAYOUT_SinglePage = 0, _
		$__eQPDF_PAGELAYOUT_OneColumn, _
		$__eQPDF_PAGELAYOUT_TwoColumns_Left, _
		$__eQPDF_PAGELAYOUT_TwoColumns_Right, _
		$__eQPDF_PAGELAYOUT_TwoPages_Left, _
		$__eQPDF_PAGELAYOUT_TwoPages_Right, _
		$__eQPDF_PAGELAYOUT_NoPreference

; Parameters for SetInformation, GetInformation
Const Enum _
		$__eQPDF_SETGETINFO_PDFVersion = 0, _
		$__eQPDF_SETGETINFO_Author, _
		$__eQPDF_SETGETINFO_Title, _
		$__eQPDF_SETGETINFO_Subject, _
		$__eQPDF_SETGETINFO_Keywords, _
		$__eQPDF_SETGETINFO_Creator, _
		$__eQPDF_SETGETINFO_Producer, _
		$__eQPDF_SETGETINFO_CreationDate, _
		$__eQPDF_SETGETINFO_ModDate, _
		$__eQPDF_SETGETINFO_XMP

; Parameters for AddStandardFont, SelectFont
Const Enum _
		$__eQPDF_StandardFontID_Courier = 0, _
		$__eQPDF_StandardFontID_CourierBold, _
		$__eQPDF_StandardFontID_CourierBoldOblique, _
		$__eQPDF_StandardFontID_CourierOblique, _
		$__eQPDF_StandardFontID_Helvetica, _
		$__eQPDF_StandardFontID_HelveticaBold, _
		$__eQPDF_StandardFontID_HelveticaBoldOblique, _
		$__eQPDF_StandardFontID_HelveticaOblique, _
		$__eQPDF_StandardFontID_TimesRoman, _
		$__eQPDF_StandardFontID_TimesBold, _
		$__eQPDF_StandardFontID_TimesItalic, _
		$__eQPDF_StandardFontID_TimesBoldItalic, _
		$__eQPDF_StandardFontID_Symbol, _
		$__eQPDF_StandardFontID_ZapfDingbats

; Parameters for SetupCustomPrinter
Const Enum _
		$__eQPDF_SetupCustomPrinter_Setting_PaperSize = 1, _
		$__eQPDF_SetupCustomPrinter_Setting_PaperLength, _
		$__eQPDF_SetupCustomPrinter_Setting_PaperWidth, _
		$__eQPDF_SetupCustomPrinter_Setting_Copies, _
		$__eQPDF_SetupCustomPrinter_Setting_PrintQuality, _
		$__eQPDF_SetupCustomPrinter_Setting_Color, _
		$__eQPDF_SetupCustomPrinter_Setting_Duplex, _
		$__eQPDF_SetupCustomPrinter_Setting_Collate, _
		$__eQPDF_SetupCustomPrinter_Setting_Source, _
		$__eQPDF_SetupCustomPrinter_Setting_MediaType, _
		$__eQPDF_SetupCustomPrinter_Setting_Orientation

Const Enum _
		$__eQPDF_SetupCustomPrinter_Value_PrintQuality_High = 1, _
		$__eQPDF_SetupCustomPrinter_Value_PrintQuality_Medium, _
		$__eQPDF_SetupCustomPrinter_Value_PrintQuality_Low, _
		$__eQPDF_SetupCustomPrinter_Value_PrintQuality_Draft

Const Enum _
		$__eQPDF_SetupCustomPrinter_Value_Color_Monochrome = 1, _
		$__eQPDF_SetupCustomPrinter_Value_Color_Color

Const Enum _
		$__eQPDF_SetupCustomPrinter_Value_Duplex_Simplex = 1, _
		$__eQPDF_SetupCustomPrinter_Value_Duplex_Vertical, _
		$__eQPDF_SetupCustomPrinter_Value_Duplex_Horizontal

Const Enum _
		$__eQPDF_SetupCustomPrinter_Value_Collate_No = 0, _
		$__eQPDF_SetupCustomPrinter_Value_Collate_Yes

Const Enum _
		$__eQPDF_SetupCustomPrinter_Value_MediaType_Standard = 1, _
		$__eQPDF_SetupCustomPrinter_Value_MediaType_Transparency, _
		$__eQPDF_SetupCustomPrinter_Value_MediaType_Glossy

Const Enum _
		$__eQPDF_SetupCustomPrinter_Value_Orientation_Portrait = 1, _
		$__eQPDF_SetupCustomPrinter_Value_Orientation_Landscape

; ===============================================================================================================================
#EndRegion QuickPDF.au3 - #CONSTANTS#

#Region QuickPDF.au3 - #CURRENT#
; REMARK - THIS LIST #CURRENT# is not updated since 2014/07/02 - it means is not complete
; #CURRENT# =====================================================================================================================
; ===============================================================================================================================
; __QPDF_AddLeadingZeros
; __QPDF_UnlockKey
; _QPDF_A4toA5
; _QPDF_AddLinkToWeb_Lite
; _QPDF_AddStandardFont_Lite
; _QPDF_CreateObject
; _QPDF_CreateObjectAndUnlock
; _QPDF_DrawText_Lite
; _QPDF_ErrFunc
; _QPDF_ExtractTextFromFile
; _QPDF_ExtractTextFromStream
; _QPDF_FileGetPageCount
; _QPDF_FileSplitEachPage
; _QPDF_GetInformation_Lite
; _QPDF_LastErrorCode
; _QPDF_LastErrorCode_Lite
; _QPDF_LoadFromFile_Lite
; _QPDF_MergeFiles
; __QPDF_NewLibraryPath_Commercial
; _QPDF_NewLibraryPath_Lite
; _QPDF_NewPage_Lite
; _QPDF_PageCount_Lite
; _QPDF_PrintPDFFile
; _QPDF_RotateFile_Lite
; _QPDF_RotatePage_Lite
; _QPDF_SaveToFile_Lite
; _QPDF_SelectFont_Lite
; _QPDF_SelectPage_Lite
; _QPDF_SetBaseURL_Lite
; _QPDF_SetInformation_Lite
; _QPDF_SetLicenseKey
; _QPDF_SetMeasurementUnits_Lite
; _QPDF_SetOrigin_Lite
; _QPDF_SetPageBox_Lite
; _QPDF_SetPageDimensions_Lite
; _QPDF_SetPageLayout_Lite
; _QPDF_SetPageMode_Lite
; _QPDF_SetPageSize_Lite
; _QPDF_SetTextAlign_Lite
; _QPDF_SetTextColor_Lite
; _QPDF_SetTextSize_Lite
; _QPDF_SetTextUnderline_Lite
; _QPDF_Shutdown
; _QPDF_StartUp
; _QPDF_UseErrorHandler
; ===============================================================================================================================
#EndRegion QuickPDF.au3 - #CURRENT#

#Region QuickPDF.au3 - #INTERNAL#

; #INTERNAL_USE_ONLY# ===========================================================================================================
; Name ..........: __QPDF_AddLeadingZeros
; Description ...:
; Syntax ........: __QPDF_AddLeadingZeros($iDigitToExpand, $iNumberOfDigits)
; Parameters ....: $iDigitToExpand      - An integer value.
;                  $iNumberOfDigits     - An integer value.
; Return values .: TODO
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........: http://www.autoitscript.com/forum/topic/160938-addleadingzeros/
; Example .......: No
; ===============================================================================================================================
Func __QPDF_AddLeadingZeros($iDigitToExpand, $iNumberOfDigits)
	Return StringRight("00000000000000000000000000000000000" & String($iDigitToExpand), $iNumberOfDigits)
EndFunc   ;==>__QPDF_AddLeadingZeros

; #INTERNAL_USE_ONLY# ===========================================================================================================
; Name ..........: __QPDF_IsValidObject
; Description ...: Check if Referenced $oQP object is valid DebenuPDFLibraryAX or DebenuPDFLibraryLite object
; Syntax ........: __QPDF_IsValidObject(Byref $oQP)
; Parameters ....: $oQP                 - [in/out] Reference to a QuickPDF object.
; Return values .: True / False
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func __QPDF_IsValidObject(ByRef $oQP)
	If Not IsObj($oQP) Then Return SetError($QPDF_ERR_ISNOTOBJECT, 0, False)

	If $__sLicenseKey_QPDF = '' Then
		If StringInStr(ObjName($oQP, 2), 'DebenuPDFLibraryLite') > 0 Then
			Return True
		ElseIf StringInStr(ObjName($oQP, 2), 'DebenuPDFLibraryAX') > 0 Then
			Return SetError($QPDF_ERR_ISCOMMERCIAL, 0, False)
		Else
			Return SetError($QPDF_ERR_ISNOTBEBENU, 0, False)
		EndIf
	Else
		If StringInStr(ObjName($oQP, 2), 'DebenuPDFLibraryAX') > 0 Then
			Return True
		ElseIf StringInStr(ObjName($oQP, 2), 'DebenuPDFLibraryLite') > 0 Then
			; @TODO ???
			Return SetError($QPDF_ERR_ISLITE, 0, False)
		Else
			Return SetError($QPDF_ERR_ISNOTBEBENU, 0, False)
		EndIf
	EndIf

EndFunc   ;==>__QPDF_IsValidObject

; ===============================================================================================================================
; #INTERNAL# ====================================================================================================================

; #INTERNAL_USE_ONLY# ===========================================================================================================
; Name ..........: __QPDF_NewLibraryPath_Commercial
; Description ...: You can set a File full path to Commercial library
; Syntax ........: __QPDF_NewLibraryPath_Commercial($sLibrary_NewFileFullPath, $sNewClassName, $sNewCLSID, $sNewIID)
; Parameters ....: $sLibrary_NewFileFullPath- A string value.
;                  $sNewClassName       - A string value.
;                  $sNewCLSID           - A string value. It must be in this format "{GUID}"
;                  $sNewIID             - A string value. It must be in this format "{GUID}"
; Return values .: TODO
; Author ........: mLipok
; Modified ......:
; Remarks .......: You Can register this ddl using regsvr32.exe , and then use ObjName() function to get the needed parameters
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func __QPDF_NewLibraryPath_Commercial($sLibrary_NewFileFullPath, $sNewClassName, $sNewCLSID, $sNewIID)
	If FileExists($sLibrary_NewFileFullPath) Then
		$__sDebenuPDFLibraryAX_FileFullPath = $sLibrary_NewFileFullPath
		$__sClassName_QPDF_Commercial = $sNewClassName
		$__sCLSID_Commercial = $sNewCLSID
		$__sIID_Commercial = $sNewIID
		Return 1
	EndIf
	Return 0
EndFunc   ;==>__QPDF_NewLibraryPath_Commercial

; #INTERNAL_USE_ONLY# ===========================================================================================================
; Name ..........: __QPDF_UnlockKey
; Description ...: Unlock the library. The commercial library must be unlocked by using a license key before it can be used.
; Syntax ........: __QPDF_UnlockKey(Byref $oQP[, $sLicenseKey = Default])
; Parameters ....: $oQP                 - [in/out] Reference to a QuickPDF object.
;                  $sLicenseKey         - [optional] A string value with your license key. Default is Default.
; Return values .: Success: 1 - Properly unlocked with commercial license key.
;                  Failure: 0 - check @error and enums $QPDF_ERR_*
; Author ........: mLipok
; Modified ......:
; Remarks .......: If the value $__sLicenseKey_QPDF is not set (is blank), the functions of this UDF will use try to use library in the Lite version.
; Related .......: http://www.debenu.com/docs/pdf_library_reference/Unlocked.php
; Link ..........: http://www.debenu.com/docs/pdf_library_reference/UnlockKey.php
; Example .......: No
; ===============================================================================================================================
Func __QPDF_UnlockKey(ByRef $oQP)
	If Not __QPDF_IsValidObject($oQP) Then
		Return SetError(@error, @extended, 0)
	ElseIf StringInStr(ObjName($oQP, 2), 'DebenuPDFLibraryLite') > 0 Then
		Return SetError($QPDF_ERR_ISLITE, 0, $QPDF_RET_FAILURE)
	ElseIf $oQP.Unlocked Or $oQP.UnlockKey($__sLicenseKey_QPDF) = 1 Then
		Return SetError($QPDF_ERR_OK, 0, $QPDF_RET_VALID_COMMERCIAL)
	Else
		MsgBox($MB_SYSTEMMODAL, "Information", "Invalid license key." & @CRLF & "Please set your license key by using _QPDF_SetLicenseKey('...') function.")
		Return SetError($QPDF_ERR_INVALIDLICENSEKEY, 0, $QPDF_RET_FAILURE)
	EndIf
EndFunc   ;==>__QPDF_UnlockKey
#EndRegion QuickPDF.au3 - #INTERNAL#

; ===============================================================================================================================
; #CURRENT# =====================================================================================================================

#Region QuickPDF.au3 - #INIT FUNCTION#

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_CreateObject
; Description ...: Create Object for Commercial or Lite Version
; Syntax ........: _QPDF_CreateObject()
; Parameters ....: $oQP                 - [in/out] Reference to a QuickPDF object, or empty string to create .
; Return values .: Success: valid $oQP object
;                  Failure: '' and set @error to non zero - one of enum $QPDF_ERR_*
; Author ........: mLipok
; Modified ......:
; Remarks .......: If you not set $__sLicenseKey_QPDF then DebenuPDFLibraryLite1114.dll will be used (Lite version). SET YOUR LICENSE KEY in your main script using _QPDF_SetLicenseKey()
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _QPDF_CreateObject(ByRef $oQP)
	If __QPDF_IsValidObject($oQP) Then
		Return SetError(@error, @extended, $oQP)

	ElseIf @error = $QPDF_ERR_ISNOTBEBENU Then
		Return SetError(@error, @extended, '')

	Else
		$oQP = Null ; CleanUp - destroy object
		_QPDF_StartUp()
		If @error Then
			Return SetError(@error, 0, 0)
		Else
			If $__sLicenseKey_QPDF = '' Then ; use Lite version
				$oQP = ObjCreate($__sCLSID_Lite, $__sIID_Lite, $__hDll_QPDF) ; $__sClassName_QPDF_Lite
				If @error Then
					Return SetError($QPDF_ERR_OBJCREATE, 3, '')

				Else
					Return SetError(0, 0, $oQP)

				EndIf
			Else
				$oQP = ObjCreate($__sCLSID_Commercial, $__sIID_Commercial, $__hDll_QPDF) ; $__sClassName_QPDF_Commercial
				If @error Then
					Return SetError($QPDF_ERR_OBJCREATE, 4, '')

				Else
					Return SetError($QPDF_ERR_OK, 0, $oQP)

				EndIf
			EndIf
		EndIf
	EndIf
EndFunc   ;==>_QPDF_CreateObject

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_CreateObjectAndUnlock
; Description ...:
; Syntax ........: _QPDF_CreateObjectAndUnlock(Byref $oQP)
; Parameters ....: $oQP                 - [in/out] Reference to a QuickPDF object.
; Return values .:
;                 -1: ObjectCreate Error look in @error for more info and check the enums$QPDF_ERR_* .
;                  0: Invalid Commercial license key - and set @error = $QPDF_ERR_INVALIDLICENSEKEY
;                  1: Properly unlocked with Commercial Keylicense key.
;                  2: Lite version - do not need to unlock.
; Author ........: mLipok
; Modified ......:
; Remarks .......: If you have not set $__sLicenseKey_QPDF then Lite version will be used. SET YOUR LICENSE KEY in your main script using _QPDF_SetLicenseKey()
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _QPDF_CreateObjectAndUnlock(ByRef $oQP)
	_QPDF_CreateObject($oQP)
	If @error Then
		Return SetError(@error, @extended, $QPDF_RET_FAILURE)
	Else
		If $__sLicenseKey_QPDF <> '' Then ; to Unlock , Commercial version should be used
			Local $iResult = __QPDF_UnlockKey($oQP)
			Return SetError(@error, @extended, $iResult)
		Else
			Return SetError(@error, @extended, $QPDF_RET_VALID_LITE)
		EndIf
	EndIf
EndFunc   ;==>_QPDF_CreateObjectAndUnlock

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_CreateObjectFromStream
; Description ...: Create Object from PDF Stream (Variant)
; Syntax ........: _QPDF_CreateObjectFromStream(Byref $oQP, $dPDF_Stream[, $sPDF_Password = ''])
; Parameters ....: $oQP                 - [in/out] Reference to a QuickPDF object.
;                  $dPDF_Stream         - An unknown value.
;                  $sPDF_Password       - [optional] A string value. Default is ''.
; Return values .: TODO
; Author ........: mLipok
; Modified ......:
; Remarks .......: You must pass a reference to your expected object variable
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _QPDF_CreateObjectFromStream(ByRef $oQP, $dPDF_Stream, $sPDF_Password = '')
	If _QPDF_CreateObjectAndUnlock($oQP) <> 1 Then
		Return SetError(@error, @extended, '')
	EndIf

	; chceck if is binary as string, and try to convert from string to binary
	If (Not IsBinary($dPDF_Stream)) And IsString($dPDF_Stream) And StringLeft($dPDF_Stream, 2) = '0x' Then
		$dPDF_Stream = Binary($dPDF_Stream)
	Else
		Return SetError($QPDF_ERR_STREAMISNOTBINARY, 0, 0)
	EndIf

	; last chceck if is binary
	If Not IsBinary($dPDF_Stream) Then
		Return SetError($QPDF_ERR_STREAMISNOTBINARY, 0, 0)

	ElseIf $oQP.LoadFromVariant($dPDF_Stream, $sPDF_Password) = 1 Then
		Return SetError($QPDF_ERR_OK, 0, 1)
	Else
		Return SetError($QPDF_ERR_STREAMCANNOTBELOADED, 0, 0)
	EndIf
EndFunc   ;==>_QPDF_CreateObjectFromStream

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_ErrFunc
; Description ...: AutoIt COM Error Handling Functionality
; Syntax ........: ObjEvent("AutoIt.Error", "_QPDF_ErrFunc")
; Parameters ....: $oError              - An unknown value.
; Return values .: TODO
; Author ........: mLipok
; Modified ......:
; Remarks .......: Use it only if you do not use your own COM Error Handling.
; Related .......: _QPDF_UseErrorHandler
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _QPDF_ErrFunc($oError)
	ConsoleWrite(@ScriptName & " (" & $oError.scriptline & ") : ==> COM Error intercepted !" & @CRLF & _
			@TAB & "err.number is: " & @TAB & @TAB & "0x" & Hex($oError.number) & @CRLF & _
			@TAB & "err.windescription:" & @TAB & $oError.windescription & @CRLF & _
			@TAB & "err.description is: " & @TAB & $oError.description & @CRLF & _
			@TAB & "err.source is: " & @TAB & @TAB & $oError.source & @CRLF & _
			@TAB & "err.helpfile is: " & @TAB & $oError.helpfile & @CRLF & _
			@TAB & "err.helpcontext is: " & @TAB & $oError.helpcontext & @CRLF & _
			@TAB & "err.lastdllerror is: " & @TAB & $oError.lastdllerror & @CRLF & _
			@TAB & "err.scriptline is: " & @TAB & $oError.scriptline & @CRLF & _
			@TAB & "err.retcode is: " & @TAB & "0x" & Hex($oError.retcode) & @CRLF & @CRLF)
EndFunc   ;==>_QPDF_ErrFunc

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_LastErrorCode
; Description ...: Use this function to determine the reason certain functions failed.
; Syntax ........: _QPDF_LastErrorCode(Byref $oQP)
; Parameters ....: $oQP                 - [in/out] Reference to a QuickPDF object.
; Return values .: Description talking about what is the @error number
;    @error .....: Error number described in Debenu Function Reference
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........: http://www.debenu.com/docs/pdf_library_reference/LastErrorCode.php
; Example .......: No
; ===============================================================================================================================
Func _QPDF_LastErrorCode(ByRef $oQP)
	Local $iResultError = $oQP.LastErrorCode()
	Local $sLastErrorDescription
	Switch $iResultError
		Case 101
			$sLastErrorDescription = 'The Strength parameter passed to the Encrypt function was invalid'
		Case 102
			$sLastErrorDescription = 'The Permissions parameter passed to the Encrypt function was invalid. Use the EncodePermissions function to construct a value for this parameter'
		Case 103
			$sLastErrorDescription = 'The Encrypt function was used on a document that was already encrypted'
		Case 104
			$sLastErrorDescription = 'The Encrypt function failed for an unknown reason'
		Case 201
			$sLastErrorDescription = 'The SetInformation function failed because the document is encrypted'
		Case 202
			$sLastErrorDescription = 'The Key parameter passed to the SetInformation function was out of range'
		Case 301
			$sLastErrorDescription = 'An invalid combination of barcode and option was sent to the DrawBarcode function'
		Case 302
			$sLastErrorDescription = 'Non-numeric characters were sent to DrawBarcode using EAN-13'
		Case 303
			$sLastErrorDescription = 'The EAN-13 barcode has an invalid checksum character'
		Case 401
			$sLastErrorDescription = 'Could not open input file'
		Case 402
			$sLastErrorDescription = 'Output file already exists and could not be deleted'
		Case 403
			$sLastErrorDescription = 'Could not open output file'
		Case 404
			$sLastErrorDescription = 'Invalid password'
		Case 405
			$sLastErrorDescription = 'Document is not encrypted'
		Case 406
			$sLastErrorDescription = 'Document is already encrypted'
		Case 407
			$sLastErrorDescription = 'Invalid encryption strength'
		Case 408
			$sLastErrorDescription = 'Invalid permissions'
		Case 409
			$sLastErrorDescription = 'Invalid file structure, file is damaged'
		Case 410
			$sLastErrorDescription = 'One of the input files is encrypted'
		Case 411
			$sLastErrorDescription = 'File not found'
		Case 412
			$sLastErrorDescription = 'Invalid page range list'
		Case 501
			$sLastErrorDescription = 'The specified FileHandle was invalid'
		Case 999
			$sLastErrorDescription = 'The function could not be used because the library is not unlocked'
		Case Else
;~ 			$sLastErrorDescription = 'NOT FOUND INFO FOR $iResultError = ' & $iResultError
			$sLastErrorDescription = ''
	EndSwitch

	If $__bNotification_QPDF Then
		ConsoleWrite('! __QPDF_ErrorNotiffy:' & @CRLF)
		ConsoleWrite('>     $iResultError = ' & $iResultError & @CRLF)
		ConsoleWrite('>     $sLastErrorDescription = ' & $sLastErrorDescription & @CRLF)
	EndIf

	Return SetError($iResultError, $QPDF_EXT_DEFAULT, $sLastErrorDescription)
EndFunc   ;==>_QPDF_LastErrorCode

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_NewLibraryPath_Commercial
; Description ...: Set path to the DLL file
; Syntax ........: _QPDF_NewLibraryPath_Commercial($sDLL_FileFullPath)
; Parameters ....: $sDLL_FileFullPath   - a string value. File full path to the DLL
; Return values .: TODO
; Author ........: mLipok
; Modified ......:
; Remarks .......: You must pass oryginal DLL file name. If you change them, then you must use __QPDF_NewLibraryPath_Commercial
; Related .......: __QPDF_NewLibraryPath_Commercial
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _QPDF_NewLibraryPath_Commercial($sDLL_FileFullPath)
	Select
		Case StringInStr($sDLL_FileFullPath, 'DebenuPDFLibraryAX1015.dll')
			__QPDF_NewLibraryPath_Commercial($sDLL_FileFullPath, 'DebenuPDFLibraryAX1015.PDFLibrary', '{5D4196E9-0A7D-48DC-BD2C-7CD3FE771B38}', '{FA7270CF-D774-4A68-8368-2C3179895E0C}')
		Case StringInStr($sDLL_FileFullPath, 'DebenuPDFLibraryAX1111.dll')
			__QPDF_NewLibraryPath_Commercial($sDLL_FileFullPath, 'DebenuPDFLibraryAX1111.PDFLibrary', '{5D4196E9-0A7D-48DC-BD2C-7CD3FE771B38}', '{FA7270CF-D774-4A68-8368-2C3179895E0C}')
		Case StringInStr($sDLL_FileFullPath, 'DebenuPDFLibraryAX1112.dll')
			__QPDF_NewLibraryPath_Commercial($sDLL_FileFullPath, 'DebenuPDFLibraryAX1112.PDFLibrary', '{AAC7EC02-5945-4ED6-A1E3-2FD000A8A6D2}', '{9CD13D3B-DB99-4D3F-ACAB-20D4F7898967}')
		Case StringInStr($sDLL_FileFullPath, 'DebenuPDFLibraryAX1113.dll')
			__QPDF_NewLibraryPath_Commercial($sDLL_FileFullPath, 'DebenuPDFLibraryAX1113.PDFLibrary', '{C8294415-55ED-4EED-B514-E068ABB93F82}', '{1A9792FE-92A6-4E78-89AC-7B1BDBD86EE2}')
		Case StringInStr($sDLL_FileFullPath, 'DebenuPDFLibraryAX1114.dll')
			__QPDF_NewLibraryPath_Commercial($sDLL_FileFullPath, 'DebenuPDFLibraryAX1114.PDFLibrary', '{334E49CF-BA75-42C6-BF78-8D459E37BF93}', '{40E3B0B9-C98E-42C8-98CD-A91208833679}')
		Case StringInStr($sDLL_FileFullPath, 'DebenuPDFLibraryAX1115.dll')
			__QPDF_NewLibraryPath_Commercial($sDLL_FileFullPath, 'DebenuPDFLibraryAX1115.PDFLibrary', '{07D8A1AA-D36A-49E8-9887-E7EFA803787B}', '{E15526AB-9CCA-4A0F-AEDB-02EA65C34232}')
		Case StringInStr($sDLL_FileFullPath, 'DebenuPDFLibraryAX1211.dll')
			__QPDF_NewLibraryPath_Commercial($sDLL_FileFullPath, 'DebenuPDFLibraryAX1211.PDFLibrary', '{95564F0D-7DB4-4776-8F82-09BCE94D8D27}', '{5E700194-D9E7-4778-9006-B0D82BD427B0}')
		Case StringInStr($sDLL_FileFullPath, 'DebenuPDFLibraryCPAX1211.dll')
			__QPDF_NewLibraryPath_Commercial($sDLL_FileFullPath, 'DebenuPDFLibraryAX1211.PDFLibrary', '{95564F0D-7DB4-4776-8F82-09BCE94D8D27}', '{5E700194-D9E7-4778-9006-B0D82BD427B0}')
		Case StringInStr($sDLL_FileFullPath, 'DebenuPDFLibraryAX1212.dll')
			__QPDF_NewLibraryPath_Commercial($sDLL_FileFullPath, 'DebenuPDFLibraryAX1212.PDFLibrary', '{2A3CADFE-9487-4051-B164-98F88316531B}', '{B82BCA1E-B2F8-4B04-B45E-64DBD4C51B03}')
		Case Else
			MsgBox($MB_SYSTEMMODAL + $MB_OK + $MB_ICONERROR, 'Error', 'Invalid $sDLL_FileFullPath')
	EndSelect
EndFunc   ;==>_QPDF_NewLibraryPath_Commercial

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_SetLicenseKey
; Description ...: Set the License Key number
; Syntax ........: _QPDF_SetLicenseKey($sKey)
; Parameters ....: $sKey                - A string value. Type here your Licence key.
; Return values .: TODO
; Author ........: mLipok
; Modified ......:
; Remarks .......: You must use it before you use any other function from this UDF - but only if you want use commercial library
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _QPDF_SetLicenseKey($sKey)
	If Not IsString($sKey) Then
		$__sLicenseKey_QPDF = ''
		Return SetError($QPDF_ERR_INVALIDLICENSEKEY, 0, False)
	EndIf

	If $sKey = 'ENTER YOUR KEY HERE' Or $sKey = '' Then
		$__sLicenseKey_QPDF = ''
	Else
		$__sLicenseKey_QPDF = $sKey
	EndIf

	Return True

EndFunc   ;==>_QPDF_SetLicenseKey

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_Shutdown
; Description ...: Close the Dll library
; Syntax ........: _QPDF_Shutdown()
; Parameters ....: None
; Return values .: TODO
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _QPDF_Shutdown()
	If $__hDll_QPDF > 0 Then DllClose($__hDll_QPDF)
	$__hDll_QPDF = 0
	OnAutoItExitUnRegister(_QPDF_Shutdown)
EndFunc   ;==>_QPDF_Shutdown

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_StartUp
; Description ...: Open DebenuPDFLibraryAX****.dll  or  DebenuPDFLibraryLite****.dll
; Syntax ........: _QPDF_StartUp()
; Parameters ....: None
; Return values .: TODO
; Author ........: mLipok
; Modified ......:
; Remarks .......: If you not set $__sLicenseKey_QPDF then DebenuPDFLibraryLite****.dll will be used (Lite version). SET YOUR LICENSE KEY in your main script using _QPDF_SetLicenseKey()
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _QPDF_StartUp()
	If $__hDll_QPDF = 0 Then
		Local $sDLLFile
		If $__sLicenseKey_QPDF = '' Then ; use Lite version
			$sDLLFile = $__sDebenuPDFLibraryLite_FileFullPath
		Else
			$sDLLFile = $__sDebenuPDFLibraryAX_FileFullPath
		EndIf

		If Not FileExists($sDLLFile) Then
			MsgBox($MB_SYSTEMMODAL + $MB_OK + $MB_ICONERROR, "Dll Open Error", "Dll file does not exist: " & @CRLF & $sDLLFile)
			Return SetError($QPDF_ERR_DLLFILENOTEXIST, 0, 0)
		EndIf

		$__hDll_QPDF = DllOpen($sDLLFile)
		If $__hDll_QPDF = -1 Then
			MsgBox($MB_SYSTEMMODAL + $MB_OK + $MB_ICONERROR, "Dll Open Error", "Can not open: " & @CRLF & $sDLLFile)
			Return SetError($QPDF_ERR_DLLINIT, 0, 0)
		EndIf

		Return SetError($QPDF_ERR_OK, 0, 1)
	EndIf
EndFunc   ;==>_QPDF_StartUp

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_UDF_ErrorDescription
; Description ...:
; Syntax ........: _QPDF_UDF_ErrorDescription($iUDF_Enumerated_Error, $iExtended_Wrapper)
; Parameters ....: $iUDF_Enumerated_Error- an integer value.
;                  $iExtended_Wrapper   - an integer value.
; Return values .: None
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _QPDF_UDF_ErrorDescription($iUDF_Enumerated_Error, $iExtended_Wrapper)
	Local $sUDF_ErrorDescription = ''
	Switch $iUDF_Enumerated_Error
		Case $QPDF_ERR_OK
			$sUDF_ErrorDescription = 'No error - All is OK'
		Case $QPDF_ERR_DLLFILENOTEXIST
			$sUDF_ErrorDescription = 'DLL File not exist'
		Case $QPDF_ERR_DLLINIT
			$sUDF_ErrorDescription = 'DllOpen - errors'
		Case $QPDF_ERR_OBJCREATE
			$sUDF_ErrorDescription = 'ObjCreate - errors'
		Case $QPDF_ERR_ISNOTOBJECT
			$sUDF_ErrorDescription = 'Referenced variable is not object'
		Case $QPDF_ERR_ISNOTBEBENU
			$sUDF_ErrorDescription = 'Referenced variable is not DebenuPDFLibrary object'
		Case $QPDF_ERR_ISLITE
			$sUDF_ErrorDescription = 'Referenced variable is DebenuPDFLibraryLite object but DebenuPDFLibraryAX was expected'
		Case $QPDF_ERR_ISCOMMERCIAL
			$sUDF_ErrorDescription = 'Referenced variable is DebenuPDFLibraryAX object but DebenuPDFLibraryLite was expected'
		Case $QPDF_ERR_INVALIDLICENSEKEY
			$sUDF_ErrorDescription = 'Invalide license Key'
		Case $QPDF_ERR_ISSTILLLOCKED
			$sUDF_ErrorDescription = 'DebenuPDFLibraryAX object is still locked - unlocked commercial DebenuPDFLibraryAX object was expected'
		Case $QPDF_ERR_STREAMISNOTBINARY
			$sUDF_ErrorDescription = 'Referenced variable is not Binary stream is not '
		Case $QPDF_ERR_STREAMCANNOTBELOADED
			$sUDF_ErrorDescription = 'Referenced Binary stream can not be loaded'
		Case $QPDF_ERR_WRONGSTYLEPARAMETER
			$sUDF_ErrorDescription = 'Wrong style parameter'
		Case $QPDF_ERR_ENUMCOUNTER
			$sUDF_ErrorDescription = '$QPDF_ERR_Counter SHOULD NOT BE USED IN @ERROR RETURN VALUSE'
		Case Else
			$sUDF_ErrorDescription = 'UNKNOW UDF ERROR DESCRIPTION'
	EndSwitch
	If $__bNotification_QPDF Then
		ConsoleWrite('! _QPDF_UDF_ErrorDescription: $QPDF_ERR_*' & @CRLF)
		ConsoleWrite('>     $iUDF_Enumerated_Error = ' & $iUDF_Enumerated_Error & @CRLF)
		ConsoleWrite('>     $sUDF_ErrorDescription = ' & $sUDF_ErrorDescription & @CRLF)
	EndIf
	Return SetError($iUDF_Enumerated_Error, $iExtended_Wrapper, '')
EndFunc   ;==>_QPDF_UDF_ErrorDescription

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_UseErrorHandler
; Description ...: Handles incoming events from the given Object.
; Syntax ........: _QPDF_UseErrorHandler()
; Parameters ....: None
; Return values .: TODO
; Author ........: mLipok
; Modified ......:
; Remarks .......: Use it only if you do not use your own COM Error Handling.
; Related .......: _QPDF_ErrFunc
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _QPDF_UseErrorHandler()
	$__ErrorHandler_QPDF = ObjEvent("AutoIt.Error", "_QPDF_ErrFunc")
EndFunc   ;==>_QPDF_UseErrorHandler
#EndRegion QuickPDF.au3 - #INIT FUNCTION#

#Region QuickPDF.au3 - #FUNCTION#

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_A4toA5
; Description ...: Convert single Page from one A4 page to two A5 Landscape page
; Syntax ........: _QPDF_A4toA5($sPDF_FileFullPath[, $sPDF_Password = ''[, $sPDF_A5_Upper = ''[, $sPDF_A5_Bottom = '']]])
; Parameters ....: $sPDF_FileFullPath         - A string value. PDF file full path.
;                  $sPDF_Password        - [optional] A string value. Default is ''.
;                  $sPDF_A5_Upper       - [optional] A string value. Default is Default. FileFullPath for Upper PDF.
;                  $sPDF_A5_Bottom       - [optional] A string value. Default is Default. FileFullPath for Bottom PDF.
; Return values .: TODO
; Author ........: mLipok
; Modified ......:
; Remarks .......: Password is needed only if PDF File is encrypted.
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _QPDF_A4toA5($sPDF_FileFullPath, $sPDF_Password = '', $sPDF_A5_Upper = Default, $sPDF_A5_Bottom = Default)
	Local $sA5_UpperAndBottom = @ScriptDir & "\A5Format.pdf"
	Local $oQP
	If _QPDF_CreateObjectAndUnlock($oQP) = 1 Then
		$oQP.LoadFromFile($sPDF_FileFullPath, $sPDF_Password) ;
		Local $iIDMainDocument = $oQP.SelectedDocument()

		$oQP.NewDocument()

		$oQP.CopyPageRanges($iIDMainDocument, '1') ; it will be first Page
		$oQP.SetOrigin($__eQPDF_SORIGIN_TopLeft) ;
		$oQP.SetMeasurementUnits($__eQPDF_MUNITS_Milimeters)
		$oQP.NormalizePage(0)

		;#CS
		$oQP.CopyPageRanges($iIDMainDocument, '1') ; it will be second Page
		$oQP.SetOrigin($__eQPDF_SORIGIN_TopLeft) ;
		$oQP.SetMeasurementUnits($__eQPDF_MUNITS_Milimeters)
		$oQP.NormalizePage(0)
		;#CE

		$oQP.DeletePages(1, 1) ; Remove the "NewDocument first" empty page.

		$oQP.NewPage() ; Top  ; it will be third Page
		$oQP.SetPageSize('A5 Landscape') ;
		$oQP.SetOrigin($__eQPDF_SORIGIN_TopLeft) ;
		$oQP.SetMeasurementUnits($__eQPDF_MUNITS_Milimeters)

		$oQP.NewPage() ; Top  ; it will be fourth Page
		$oQP.SetPageSize('A5 Landscape') ;
		$oQP.SetOrigin($__eQPDF_SORIGIN_TopLeft) ;
		$oQP.SetMeasurementUnits($__eQPDF_MUNITS_Milimeters)

		$oQP.SelectPage(1) ; yet, for a little while Page #1
		$oQP.SetPageBox($__eQPDF_BOXTYPE_CropBox, 0, 0, $__eQPDF_A4_WidthInMM, $__eQPDF_A4_HeightInMM / 2) ; Media Box - Set Region to Capture
		Local $iIDCapture1 = $oQP.CapturePageEx($oQP.SelectedPage(), $__eQPDF_BOXTYPE_CropBox - 1)
		; Remember Once a page has been captured it is removed from the document.
		$oQP.SelectPage(2) ; previously Page #3
		$oQP.DrawCapturedPage($iIDCapture1, 0, 0, $__eQPDF_A4_WidthInMM, $__eQPDF_A4_HeightInMM / 2) ; draw CaptuedPage to SelectedPage

		$oQP.SelectPage(1) ; previously Page #2
		$oQP.SetPageBox($__eQPDF_BOXTYPE_CropBox, 0, $__eQPDF_A4_HeightInMM / 2, $__eQPDF_A4_WidthInMM, $__eQPDF_A4_HeightInMM / 2) ; Media Box - Set Region to Capture
		Local $iIDCapture2 = $oQP.CapturePageEx($oQP.SelectedPage(), $__eQPDF_BOXTYPE_CropBox - 1)
		; Remember Once a page has been captured it is removed from the document.
		$oQP.SelectPage(2) ; previously Page #4
		$oQP.DrawCapturedPage($iIDCapture2, 0, 0, $__eQPDF_A4_WidthInMM, $__eQPDF_A4_HeightInMM / 2) ; draw CaptuedPage to SelectedPage

		$oQP.SaveToFile($sA5_UpperAndBottom) ;
		While _WinAPI_FileInUse($sA5_UpperAndBottom)
			Sleep(10)
		WEnd
		_QPDF_FileSplitEachPage($sA5_UpperAndBottom, '', @ScriptDir & '\')

		Local $aReturn[2]
		If $sPDF_A5_Upper <> Default And $sPDF_A5_Bottom <> Default Then
			FileMove(@ScriptDir & '\A5Format_p001.pdf', $sPDF_A5_Upper, $FC_OVERWRITE)
			FileMove(@ScriptDir & '\A5Format_p002.pdf', $sPDF_A5_Bottom, $FC_OVERWRITE)
			$aReturn[0] = $sPDF_A5_Upper
			$aReturn[1] = $sPDF_A5_Bottom
		Else
			$aReturn[0] = @ScriptDir & '\A5Format_p001.pdf'
			$aReturn[1] = @ScriptDir & '\A5Format_p001.pdf'
		EndIf
		FileDelete($sA5_UpperAndBottom)
		$oQP = Null ; CleanUp - destroy object
		Return $aReturn
	EndIf
	Return SetError(@error, 0, 0)
EndFunc   ;==>_QPDF_A4toA5

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_ExtractAllText
; Description ...: Extract text from all page
; Syntax ........: _QPDF_ExtractAllText(Byref $oQP[, $iExtractOptions = 8])
; Parameters ....: $oQP                 - [in/out] Reference to a QuickPDF object.
;                  $iExtractOptions     - [optional] An integer value. Default is 8.
; Return values .: Success: Extracted text
;                  Failure: Empty string and set @error
; Author ........: mLipok
; Modified ......:
; Remarks .......: Password is needed only if PDF File is encrypted.
; Related .......: _QPDF_ExtractTextFromStream, _QPDF_ExtractTextFromFile
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _QPDF_ExtractAllText(ByRef $oQP, $iExtractOptions = 8)
	If Not __QPDF_IsValidObject($oQP) Then Return SetError(@error, @extended, '')

	Local $sPDF_TXTContents = ''

	; get number of Page
	Local $iTotalPages = $oQP.PageCount

	; get text from all page
	For $iCurrentPage = 1 To $iTotalPages
		$oQP.SelectPage($iCurrentPage)
		$oQP.SetOrigin($__eQPDF_SORIGIN_TopLeft) ; needed for some $iExtractOptions
		$oQP.SetMeasurementUnits($__eQPDF_MUNITS_Milimeters) ; needed for some $iExtractOptions
		$oQP.NormalizePage(0)
		$sPDF_TXTContents &= $oQP.GetPageText($iExtractOptions) & @CRLF
	Next

	Return SetError(0, 0, $sPDF_TXTContents)

EndFunc   ;==>_QPDF_ExtractAllText

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_ExtractTextFromFile
; Description ...: Extract Text from all pages.
; Syntax ........: _QPDF_ExtractTextFromFile($sPDF_FileFullPath[, $sPDF_Password = ''[, $iExtractOptions = 7]])
; Parameters ....: $sPDF_FileFullPath   - A string value. PDF file full path.
;                  $sPDF_Password        - [optional] A string value. Default is ''.
;                  $iExtractOptions     - [optional] An integer value. Default is 7.
; Return values .: Success: Extracted text
;                  @Extended = $iTotalPages
;                  Failure: Empty string and set @error to 1
; Author ........: mLipok
; Modified ......:
; Remarks .......: Password is needed only if PDF File is encrypted.
; Related .......: _QPDF_ExtractTextFromStream, _QPDF_ExtractAllText
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _QPDF_ExtractTextFromFile($sPDF_FileFullPath, $sPDF_Password = '', $iExtractOptions = 7)
	Local $oQP
	If _QPDF_CreateObjectAndUnlock($oQP) = 1 Then
		Local $sPDF_TXTContents = ''
		Local $iTotalPages

		$iTotalPages = _QPDF_FileGetPageCount($sPDF_FileFullPath, $sPDF_Password)
		$oQP.SetOrigin($__eQPDF_SORIGIN_TopLeft) ; needed for some $iExtractOptions
		$oQP.SetMeasurementUnits($__eQPDF_MUNITS_Milimeters) ; needed for some $iExtractOptions

		; TODO load File to Object
		; TODO use _QPDF_ExtractAllText
		For $iCurrentPage = 1 To $iTotalPages
			$sPDF_TXTContents &= $oQP.ExtractFilePageText($sPDF_FileFullPath, $sPDF_Password, $iCurrentPage, $iExtractOptions)
		Next

		; CleanUp - destroy object
		$oQP = 0
		Return SetError(0, $iTotalPages, $sPDF_TXTContents)
	EndIf
	Return SetError($QPDF_ERR_INVALIDLICENSEKEY, 0, '')
EndFunc   ;==>_QPDF_ExtractTextFromFile

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_ExtractTextFromStream
; Description ...: Extract text from Stream ( Variant / Binary )
; Syntax ........: _QPDF_ExtractTextFromStream($dPDF_Stream[, $sPDF_Password = ''[, $iExtractOptions = 8]])
; Parameters ....: $dPDF_Stream         - Binary Stream
;                  $sPDF_Password       - [optional] A string value. Default is ''.
;                  $iExtractOptions     - [optional] An integer value. Default is 8.
; Return values .: Success: Extracted text
;                  Failure: Empty string and set @error
; Author ........: mLipok
; Modified ......:
; Remarks .......: you can use this function when you have data taken from Blob from SQL database
;                  Password is needed only if PDF File is encrypted.
; Related .......: _QPDF_ExtractAllText, _QPDF_ExtractTextFromFile
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _QPDF_ExtractTextFromStream($dPDF_Stream, $sPDF_Password = '', $iExtractOptions = 8)
	; chceck if is binary as string, and convert from string to binary
	If (Not IsBinary($dPDF_Stream)) And IsString($dPDF_Stream) And StringLeft($dPDF_Stream, 2) = '0x' Then
		$dPDF_Stream = Binary($dPDF_Stream)
	Else
		Return SetError($QPDF_ERR_STREAMISNOTBINARY, 0, '')

	EndIf

	; last chceck if is binary
	If Not IsBinary($dPDF_Stream) Then
		Return SetError($QPDF_ERR_STREAMISNOTBINARY, 0, '')
	EndIf

	Local $oQP
	If _QPDF_CreateObjectAndUnlock($oQP) = 1 Then
		; load PDF Stream to $oQP
		$oQP.LoadFromVariant($dPDF_Stream, $sPDF_Password)

		Local $sPDF_TXTContents = _QPDF_ExtractAllText($oQP, $iExtractOptions)
		Return SetError(@error, 0, $sPDF_TXTContents)
	EndIf

	Return SetError($QPDF_ERR_INVALIDLICENSEKEY, 0, '')
EndFunc   ;==>_QPDF_ExtractTextFromStream

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_FileGetPageCount
; Description ...: Get number of pages from PDF File.
; Syntax ........: _QPDF_FileGetPageCount(Byref $oQP, $sPDF_FileFullPath[, $sPDF_Password = ''])
; Parameters ....: $oQP                 - [in/out] Reference to a QuickPDF object.
;                  $sPDF_FileFullPath    - A string value. PDF file full path.
;                  $sPDF_Password        - [optional] A string value. Default is ''.
; Return values .: number of pages
; Author ........: mLipok
; Modified ......:
; Remarks .......: Password is needed only if PDF File is encrypted.
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _QPDF_FileGetPageCount($sPDF_FileFullPath, $sPDF_Password = '')
	Local $iPDF_PageCount = 0
	Local $hPDF
	Local $oQP
	If _QPDF_CreateObjectAndUnlock($oQP) = 1 Then
		$hPDF = $oQP.DAOpenFile($sPDF_FileFullPath, $sPDF_Password)
		; _QPDF_LastErrorCode($oQP)
		$iPDF_PageCount = $oQP.DAGetPageCount($hPDF)
		$oQP.DACloseFile($hPDF)
		$oQP = Null ; CleanUp - destroy object
		Return $iPDF_PageCount
	EndIf
	Return SetError($QPDF_ERR_INVALIDLICENSEKEY, 0, 0)
EndFunc   ;==>_QPDF_FileGetPageCount

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_FileSplitEachPage
; Description ...: Split each page of a selected PDF file to a separated file
; Syntax ........: _QPDF_FileSplitEachPage($sPDF_FileFullPath[, $sPDF_Password = ''[, $sDestinationDir = @ScriptDir & '\Extracted'[,
;                  $iNumberOfDigits = 3]]])
; Parameters ....: $sPDF_FileFullPath   - A string value. File full path to PDF file to split.
;                  $sPDF_Password       - [optional] A string value. Default is ''.
;                  $sDestinationDir     - [optional] A string value. Destination directory for splited pdf files. Default is @ScriptDir & '\Extracted'.
;                  $iNumberOfDigits     - [optional] An integer value. Specify how many digits will be used in Page Counter to the output file name. Default is 3.
; Return values .: $aPageFileList - Array with PDFFileFullPath for all splited pages
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _QPDF_FileSplitEachPage($sPDF_FileFullPath, $sPDF_Password = '', $sDestinationDir = Default, $iNumberOfDigits = 3)
	If $sDestinationDir = Default Then $sDestinationDir = @ScriptDir & '\Extracted'
	Local $oQP
	If _QPDF_CreateObjectAndUnlock($oQP) = 1 Then
		$oQP.LoadFromFile($sPDF_FileFullPath, $sPDF_Password)
		; _QPDF_LastErrorCode($oQP)
		Local $iTotalPages = _QPDF_FileGetPageCount($sPDF_FileFullPath, '')
		Local $sPDF_Destination = ''
		If Not FileExists($sDestinationDir) Then DirCreate($sDestinationDir)
		Local $aPageFileList[$iTotalPages + 1]
		$aPageFileList[0] = $iTotalPages

		For $n = 1 To $iTotalPages
			$sPDF_Destination = $sDestinationDir & '\' & StringRegExp($sPDF_FileFullPath, '(?i).*\\(.*?)\.pdf', 3)[0] & '_p' & __QPDF_AddLeadingZeros(String($n), $iNumberOfDigits) & ".pdf"
			$aPageFileList[$n] = $sPDF_Destination
			$oQP.ExtractFilePages($sPDF_FileFullPath, '', $sPDF_Destination, $n)
		Next
		Return SetError(0, 0, $aPageFileList)
	EndIf

	Return SetError($QPDF_ERR_INVALIDLICENSEKEY, 0, 0)
EndFunc   ;==>_QPDF_FileSplitEachPage

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_MergeFiles
; Description ...: Merge two PDF files
; Syntax ........: _QPDF_MergeFiles($sFirstFileFullPath, $sSecondFileFullPath[, $sOutputFileName = Default])
; Parameters ....: $sFirstFileFullPath - A string value. First PDF file full path.
;                  $sSecondFileFullPath - A string value. Second PDF file full path.
;                  $sOutputFileName - [optional] A string value. Default is Default. Output PDF file full path.
;                                     If Default is used then the first file will contain the result of the combination
; Return values .:
;                  0	The files could not be merged. Use the _QPDF_LastErrorCode() function to determine the cause of the failure.
;                  1	The files were merged successfully and the new merged document was created
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........: http://www.debenu.com/docs/pdf_library_reference/MergeFiles.php
; Example .......: No
; ===============================================================================================================================
Func _QPDF_MergeFiles($sFirstFileFullPath, $sSecondFileFullPath, $sOutputFileName = Default)
	Local $oQP
	If _QPDF_CreateObjectAndUnlock($oQP) = 1 Then
		Local $sPDF_FileFullPath_temp
		If $sOutputFileName = Default Then
			$sPDF_FileFullPath_temp = $sFirstFileFullPath & '_temp.pdf'
		Else
			$sPDF_FileFullPath_temp = $sOutputFileName
		EndIf

		; make a list with PDF File List
		If $oQP.MergeFiles($sFirstFileFullPath, $sSecondFileFullPath, $sPDF_FileFullPath_temp) Then

			; wait for complete save
			While _WinAPI_FileInUse($sPDF_FileFullPath_temp)
				Sleep(10)
			WEnd

			If $sOutputFileName = Default Then
				FileMove($sPDF_FileFullPath_temp, $sFirstFileFullPath, $FC_OVERWRITE + $FC_CREATEPATH)
			EndIf
			$oQP = Null ; CleanUp - destroy object
			Return 1
		EndIf
		$oQP = Null ; CleanUp - destroy object
		Return 0
	EndIf

	Return SetError($QPDF_ERR_INVALIDLICENSEKEY, 0, 0)
EndFunc   ;==>_QPDF_MergeFiles

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_PrintPDFFile
; Description ...: Print Selected File
; Syntax ........: _QPDF_PrintPDFFile([$sPDF_FileFullPath = Default[, $sPDFPassword = ''[, $iDuplex = 1 ]]])
; Parameters ....: $sPDF_FileFullPath   - [optional] A string value. Default is Default.
;                  $sPDFPassword        - [optional] A string value. Default is ''.
;                  $iDuplex             - [optional] An integer value. Default is 1 .
; Return values .: TODO
; Author ........: mLipok
; Modified ......:
; Remarks .......: If you not set $sPDF_FileFullPath the FileOpenDialog appears
; Related .......:
; Link ..........: http://www.debenu.com/docs/pdf_library_reference/RenderingAndPrinting.php
; Example .......: No
; ===============================================================================================================================
Func _QPDF_PrintPDFFile($sPDF_FileFullPath = Default, $sPDFPassword = '', $iDuplex = $__eQPDF_SetupCustomPrinter_Value_Duplex_Simplex, $sPrinterName = Default)
	If $sPDF_FileFullPath = Default Then
		$sPDF_FileFullPath = FileOpenDialog('Select PDF File', @ScriptDir, 'PDF File (*.pdf)')
	EndIf
	If @error Or Not FileExists($sPDF_FileFullPath) Then
		MsgBox($MB_SYSTEMMODAL, 'NOTE', 'File does not exist. or no file selected')
	Else
		Local $sFileName = StringRegExp($sPDF_FileFullPath, '(?i).+\\(.*)', 3)[0]
		Local $sCustomPrinter
		Local $iPrintOptions
		Local $oQP
		If _QPDF_CreateObjectAndUnlock($oQP) Then
			$oQP.LoadFromFile($sPDF_FileFullPath, $sPDFPassword)

			; using $sPrinterName if $sPrinterName = Default or not exist then use Default PrinterName
			If $sPrinterName = Default Or StringInStr($oQP.GetPrinterNames(), $sPrinterName) = 0 Then
				$sCustomPrinter = $oQP.NewCustomPrinter($oQP.GetDefaultPrinterName()) ;
			Else
				$sCustomPrinter = $oQP.NewCustomPrinter($sPrinterName) ;
			EndIf

			; setting Duplex Mode
			$oQP.SetupCustomPrinter($sCustomPrinter, $__eQPDF_SetupCustomPrinter_Setting_Duplex, $iDuplex) ;

;~ 			; setting Orientation
;~ 			If $oQP.GetPageWidth() = $__eQPDF_A4_WidthInMM_Landscape And $oQP.GetPageHeight() = $__eQPDF_A4_HeightInMM_Landscape Then
;~ 				$oQP.SetupCustomPrinter($sCustomPrinter, $__eQPDF_SetupCustomPrinter_Setting_Orientation, $iDuplex);
;~ 			EndIf

			$iPrintOptions = $oQP.PrintOptions(0, 1, $sFileName)
			$oQP.PrintDocument($sCustomPrinter, 1, $oQP.PageCount, $iPrintOptions) ;
		Else
			Return SetError($QPDF_ERR_INVALIDLICENSEKEY, 0, 0)
		EndIf
	EndIf
EndFunc   ;==>_QPDF_PrintPDFFile
#EndRegion QuickPDF.au3 - #FUNCTION#

#Region QuickPDF.au3 - #QuickPDF Lite#

; ===============================================================================================================================
; #QuickPDF Lite# ===============================================================================================================
; NOTE:
; now all the functions of "Lite" are simply wrapped, this will ultimately allow syntax highlighting and use of calltips guide
; It is possible that eventually will be partially extended - for example, see _QPDF_SaveToFile_Lite ()
;
; All functions of this group can be also used in the commercial version

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_AddLinkToWeb_Lite
; Description ...: Adds a clickable hotspot rectangle to the selected page which links to a URL on the internet. This can also be used to link to an e-mail address.
; Syntax ........: _QPDF_AddLinkToWeb_Lite(Byref $oQP, $iLeft, $iTop, $iWidth, $iHeight, $sLink[, $iOptions = 0])
; Parameters ....: $oQP                 - [in/out] Reference to a QuickPDF object.
;                  $iLeft               - An integer value.
;                  $iTop                - An integer value.
;                  $iWidth              - An integer value.
;                  $iHeight             - An integer value.
;                  $sLink               - A string value.
;                  $iOptions            - [optional] An integer value. Default is 0.
; Return values .: TODO
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........: http://www.debenu.com/docs/pdf_library_reference/AddLinkToWeb.php
; Example .......: No
; ===============================================================================================================================
Func _QPDF_AddLinkToWeb_Lite(ByRef $oQP, $iLeft, $iTop, $iWidth, $iHeight, $sLink, $iOptions = 0)
	If _QPDF_CreateObjectAndUnlock($oQP) = 1 Or _QPDF_CreateObjectAndUnlock($oQP) = 2 Then
		$oQP.AddLinkToWeb($iLeft, $iTop, $iWidth, $iHeight, $sLink, $iOptions) ;
		Return 1
	EndIf
	Return SetError($QPDF_ERR_INVALIDLICENSEKEY, 0, 0)
EndFunc   ;==>_QPDF_AddLinkToWeb_Lite

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_AddStandardFont_Lite
; Description ...: Adds a standard font to the document. These standard fonts will always be available on all PDF viewers.
; Syntax ........: _QPDF_AddStandardFont_Lite(Byref $oQP, $iFontID)
; Parameters ....: $oQP                 - [in/out] Reference to a QuickPDF object.
;                  $iFontID             - An integer value.
; Return values .: TODO
; Author ........: mLipok
; Modified ......:
; Remarks .......: See the definition of constants - Parameters for AddStandardFont, SelectFont
; Related .......:
; Link ..........: http://www.debenu.com/docs/pdf_library_reference/AddStandardFont.php
; Example .......: No
; ===============================================================================================================================
Func _QPDF_AddStandardFont_Lite(ByRef $oQP, $iFontID)
	If _QPDF_CreateObjectAndUnlock($oQP) = 1 Or _QPDF_CreateObjectAndUnlock($oQP) = 2 Then
		$oQP.AddStandardFont($iFontID) ;
	Else
		Return SetError($QPDF_ERR_INVALIDLICENSEKEY, 0, 0)
	EndIf
EndFunc   ;==>_QPDF_AddStandardFont_Lite

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_DrawText_Lite
; Description ...: Draws text on the selected page, using the selected font at the predetermined font size.
; Syntax ........: _QPDF_DrawText_Lite(Byref $oQP, $iXPos, $iYPos, $sText)
; Parameters ....: $oQP                 - [in/out] Reference to a QuickPDF object.
;                  $iXPos               - An integer value.
;                  $iYPos               - An integer value.
;                  $sText               - A string value.
; Return values .: TODO
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........: http://www.debenu.com/docs/pdf_library_reference/DrawText.php
; Example .......: No
; ===============================================================================================================================
Func _QPDF_DrawText_Lite(ByRef $oQP, $iXPos, $iYPos, $sText)
	If _QPDF_CreateObjectAndUnlock($oQP) = 1 Or _QPDF_CreateObjectAndUnlock($oQP) = 2 Then
		$oQP.NormalizePage(0)
		$oQP.DrawText($iXPos, $iYPos, $sText)
	Else
		Return SetError($QPDF_ERR_INVALIDLICENSEKEY, 0, 0)
	EndIf
EndFunc   ;==>_QPDF_DrawText_Lite

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_GetInformation_Lite
; Description ...: Get the properties of the selected document.
; Syntax ........: _QPDF_GetInformation_Lite(Byref $oQP, $iKey)
; Parameters ....: $oQP                 - [in/out] Reference to a QuickPDF object.
;                  $iKey                - An integer value. See remarks.
; Return values .: The extracted information according to the specified $iKey
; Author ........: mLipok
; Modified ......:
; Remarks .......: See the definition of constants - Parameters for SetInformation, GetInformation
; Related .......: SetInformation
; Link ..........: http://www.debenu.com/docs/pdf_library_reference/GetInformation.php
; Example .......: No
; ===============================================================================================================================
Func _QPDF_GetInformation_Lite(ByRef $oQP, $iKey)
	If _QPDF_CreateObjectAndUnlock($oQP) = 1 Or _QPDF_CreateObjectAndUnlock($oQP) = 2 Then
		Return $oQP.GetInformation($iKey) ;
	EndIf
	Return SetError($QPDF_ERR_INVALIDLICENSEKEY, 0, 0)
EndFunc   ;==>_QPDF_GetInformation_Lite

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_GetInformationEx_Lite
; Description ...: Get information from PDF File - wrapper for Lite Version
; Syntax ........: _QPDF_GetInformationEx_Lite($sPDF_FileFullPath[, $sPDF_Password = ''])
; Parameters ....: $sPDF_FileFullPath   - A string value.
;                  $sPDF_Password       - [optional] A string value. Default is ''.
; Return values .: succes: array with the following info:
;					0 = PDF Version
;					1 = Author
;					2 = Title
;					3 = Subject
;					4 = Keywords
;					5 = Creator
;					6 = Producer
;					7 = Creation date
;					8 = Modification date
; Author ........: mLipok
; Modified ......:
; Remarks .......: it works with Lite (free) version ie. DebenuPDFLibraryLite1114.dll
; Related .......:
; Link ..........:
; Example .......: Yes
; ===============================================================================================================================
Func _QPDF_GetInformationEx_Lite($sPDF_FileFullPath, $sPDF_Password = '')
	Return _QPDF_GetInformation($sPDF_FileFullPath, $sPDF_Password)
EndFunc   ;==>_QPDF_GetInformationEx_Lite

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_LastErrorCode_Lite
; Description ...: Use this function to determine the reason certain functions failed.
; Syntax ........: _QPDF_LastErrorCode_Lite(Byref $oQP)
; Parameters ....: $oQP                 - [in/out] Reference to a QuickPDF object.
; Return values .: Error number described in Debenu Function Reference
;    @error .....: 0 - if there was no error, 1 - If there was an error
;    @extended ..: Description talking about what is the Return Value
; Author ........: mLipok
; Modified ......:
; Remarks .......: this is wrapped _QPDF_LastErrorCode()
; Related .......:
; Link ..........: http://www.debenu.com/docs/pdf_library_reference/LastErrorCode.php
; Example .......: No
; ===============================================================================================================================
Func _QPDF_LastErrorCode_Lite(ByRef $oQP)
	Local $Return = _QPDF_LastErrorCode($oQP)
	Return SetError(@error, @extended, $Return)
EndFunc   ;==>_QPDF_LastErrorCode_Lite

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_LoadFromFile_Lite
; Description ...: Loads a PDF document from a file on disk.
; Syntax ........: _QPDF_LoadFromFile_Lite(Byref $oQP, $sPDF_FileFullPath[, $sPDF_Password = ''])
; Parameters ....: $oQP                 - [in/out] Reference to a QuickPDF object.
;                  $sPDF_FileFullPath   - A string value. PDF file full path.
;                  $sPDF_Password       - [optional] A string value. Default is ''.
; Return values .: TODO
; Author ........: mLipok
; Modified ......:
; Remarks .......:  If the function succeeds, the loaded document will be selected and its DocumentID can be retrieved using the SelectedDocument function.
; Related .......:
; Link ..........: http://www.debenu.com/docs/pdf_library_reference/LoadFromFile.php
; Example .......: No
; ===============================================================================================================================
Func _QPDF_LoadFromFile_Lite(ByRef $oQP, $sPDF_FileFullPath, $sPDF_Password = '')
	If _QPDF_CreateObjectAndUnlock($oQP) = 1 Or _QPDF_CreateObjectAndUnlock($oQP) = 2 Then
		$oQP.LoadFromFile($sPDF_FileFullPath, $sPDF_Password) ;
	Else
		Return SetError($QPDF_ERR_INVALIDLICENSEKEY, 0, 0)
	EndIf
EndFunc   ;==>_QPDF_LoadFromFile_Lite

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_MergeFiles_Lite
; Description ...: Combine together all pdf from selected folder, quickly and easy
; Syntax ........: _QPDF_MergeFiles_Lite($sDirFullPath, $sFileFullPath)
; Parameters ....: $sDirFullPath        - A string value.
;                  $sFileFullPath       - A string value.
; Return values .: TODO
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _QPDF_MergeFiles_Lite($sDirFullPath = Default, $sFileFullPath = Default)
	#forceref $sDirFullPath, $sFileFullPath
	; TODO $sDirFullPath, $sFileFullPath
	Local $sFileName = ""
	Local $sFolderWithPDFFiles = ""
	If $sDirFullPath = Default Then
		$sFolderWithPDFFiles = FileSelectFolder('Select Folder with PDF Files to Merge', "", 2 + 4)
	Else
		$sFolderWithPDFFiles = $sDirFullPath
	EndIf

	If $sFileFullPath = Default Then
		$sFileName = @ScriptDir & "\Example_MergedFileList.pdf"
	Else
		$sFileName = $sFileFullPath
	EndIf

	If @error Then
		MsgBox($MB_SYSTEMMODAL + $MB_OK + $MB_ICONERROR, 'Error', 'FileSecetFolder @error = ' & @error)
	Else
		Local $oQP
		If _QPDF_CreateObjectAndUnlock($oQP) = 2 Then
			; make an array with PDF File List
			Local $aPDFFileList = _FileListToArray($sFolderWithPDFFiles, '*.pdf', 1, True)

			; load first document
			$oQP.LoadFromFile($aPDFFileList[1], '')
			Local $iDocumentID_First = $oQP.SelectedDocument()

			; add each next PDF file from the Array to the QP File List
			Local $iDocumentID_Next
			For $iPDFFileID = 2 To $aPDFFileList[0]
				$oQP.LoadFromFile($aPDFFileList[$iPDFFileID], '')
				$iDocumentID_Next = $oQP.SelectedDocument()

				; Select first document
				$oQP.SelectDocument($iDocumentID_First)

				; Merge Next Document to First Document
				$oQP.MergeDocument($iDocumentID_Next)
			Next

			; Merge the list of files together.
			$oQP.SaveToFile($sFileName)

			; wait for complete save
			While _WinAPI_FileInUse($sFileName)
				Sleep(10)
			WEnd

		EndIf
	EndIf

	$oQP = Null ; CleanUp - destroy object
EndFunc   ;==>_QPDF_MergeFiles_Lite

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_NewLibraryPath_Lite
; Description ...: You can set a File full path to Lite library
; Syntax ........: _QPDF_NewLibraryPath_Lite($sLibrary_NewFileFullPath)
; Parameters ....: $sLibrary_NewFileFullPath- A string value.
; Return values .: 1 if File Exist , if not exist then Return 0 and sets the @error flag to non-zero.
; Author ........: mLipok
; Modified ......:
; Remarks .......: TODO WIP: If you use another dll version than DebenuPDFLibraryLite1114.dll then you need to set up CLSID .....
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _QPDF_NewLibraryPath_Lite($sLibrary_NewFileFullPath)
	If FileExists($sLibrary_NewFileFullPath) Then
		$__sDebenuPDFLibraryLite_FileFullPath = $sLibrary_NewFileFullPath
		Return 1
	EndIf
	Return SetError(1, 0, 0)
EndFunc   ;==>_QPDF_NewLibraryPath_Lite

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_NewPage_Lite
; Description ...: Create a new page.
; Syntax ........: _QPDF_NewPage_Lite(Byref $oQP)
; Parameters ....: $oQP                 - [in/out] Reference to a QuickPDF object.
; Return values .: Success: Non-zero 	The page number of the page that was added
;                  Failure: 0 	The page could not be added. This should never occur.
; Author ........: mLipok
; Modified ......:
; Remarks .......: The new page is added to the end of the document, and will have the same width and height as the selected page.
; Related .......:
; Link ..........: http://www.debenu.com/docs/pdf_library_reference/NewPage.php
; Example .......: No
; ===============================================================================================================================
Func _QPDF_NewPage_Lite(ByRef $oQP)
	If _QPDF_CreateObjectAndUnlock($oQP) = 1 Or _QPDF_CreateObjectAndUnlock($oQP) = 2 Then
		Return $oQP.NewPage()
	EndIf
	Return SetError($QPDF_ERR_INVALIDLICENSEKEY, 0, 0)
EndFunc   ;==>_QPDF_NewPage_Lite

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_PageCount_Lite
; Description ...: Reports the total number of pages in the selected document.
; Syntax ........: _QPDF_PageCount_Lite(Byref $oQP)
; Parameters ....: $oQP                 - [in/out] Reference to a QuickPDF object.
; Return values .: number of pages in the selected document
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........: http://www.debenu.com/docs/pdf_library_reference/PageCount.php
; Example .......: No
; ===============================================================================================================================
Func _QPDF_PageCount_Lite(ByRef $oQP)
	If _QPDF_CreateObjectAndUnlock($oQP) = 1 Or _QPDF_CreateObjectAndUnlock($oQP) = 2 Then
		Return $oQP.PageCount ;
	EndIf
	Return SetError($QPDF_ERR_INVALIDLICENSEKEY, 0, 0)
EndFunc   ;==>_QPDF_PageCount_Lite

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_Rotate_Lite
; Description ...: Rotate each page in document
; Syntax ........: _QPDF_Rotate_Lite(Byref $oQP[, $iPageRotation = 0])
; Parameters ....: $oQP                 - [in/out] Reference to a QuickPDF object.
;                  $iPageRotation       - [optional] An integer value. Default is 0.
; Return values .: TODO
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _QPDF_Rotate_Lite(ByRef $oQP, $iPageRotation = 0)
	If IsObj($oQP) Then
		;; todo CHECK if $oQP is DEBENU Object
		Local $iTotalPages = _QPDF_PageCount_Lite($oQP)
		For $n = 1 To $iTotalPages
			_QPDF_SelectPage_Lite($oQP, $n)
			_QPDF_RotatePage_Lite($oQP, $iPageRotation)
		Next
	Else
		Return SetError($QPDF_ERR_ISNOTOBJECT, 0, 0)
	EndIf
EndFunc   ;==>_QPDF_Rotate_Lite

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_RotateFile_Lite
; Description ...: Rotate all Pages in a file.
; Syntax ........: _QPDF_RotateFile_Lite($sPDF_FileFullPath[, $iPageRotation = 0])
; Parameters ....: $sPDF_FileFullPath   - A string value. PDF file full path.
;                  $iPageRotation       - [optional] An integer value. Default is 0.
; Return values .: TODO
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......: _QPDF_RotatePage_Lite
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _QPDF_RotateFile_Lite($sPDF_FileFullPath, $iPageRotation = 0)
	Local $oQP
	Local $iObjCreateResult = _QPDF_CreateObjectAndUnlock($oQP)
	If $iObjCreateResult = 1 Or $iObjCreateResult = 2 Then
		_QPDF_LoadFromFile_Lite($oQP, $sPDF_FileFullPath)
		Local $iTotalPages = _QPDF_PageCount_Lite($oQP)
		For $n = 1 To $iTotalPages
			_QPDF_SelectPage_Lite($oQP, $n)
			_QPDF_RotatePage_Lite($oQP, $iPageRotation)
		Next
		_QPDF_SaveToFile_Lite($oQP, $sPDF_FileFullPath)
		$oQP = Null ; CleanUp - destroy object
		Return SetError($QPDF_ERR_OK, 0, $QPDF_RET_DEFAULT)
	EndIf
	$oQP = Null ; CleanUp - destroy object
	Return SetError(@error, @exitCode, $QPDF_RET_FAILURE)
EndFunc   ;==>_QPDF_RotateFile_Lite

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_RotateFileLeft_Lite
; Description ...: Rotate entire PDF File to left (contrary to the clockwise)
; Syntax ........: _QPDF_RotateFileLeft_Lite($sPDF_FileFullPath)
; Parameters ....: $sPDF_FileFullPath   - A string value.
; Return values .: $iPageRotation
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _QPDF_RotateFileLeft_Lite($sPDF_FileFullPath)
	Local $oQP
	If _QPDF_CreateObjectAndUnlock($oQP) = 1 Or _QPDF_CreateObjectAndUnlock($oQP) = 2 Then
		_QPDF_LoadFromFile_Lite($oQP, $sPDF_FileFullPath)
		Local $iTotalPages = _QPDF_PageCount_Lite($oQP)
		Local $iPageRotation = 0
		For $n = 1 To $iTotalPages
			_QPDF_SelectPage_Lite($oQP, $n)
			$iPageRotation = $oQP.PageRotation()
			Switch $iPageRotation
				Case 0
					$iPageRotation = 270
				Case 270
					$iPageRotation = 180
				Case 180
					$iPageRotation = 90
				Case 90
					$iPageRotation = 0
			EndSwitch
			_QPDF_RotatePage_Lite($oQP, $iPageRotation)
		Next
		_QPDF_SaveToFile_Lite($oQP, $sPDF_FileFullPath)
		Return $iPageRotation
	EndIf
	Return SetError($QPDF_ERR_INVALIDLICENSEKEY, 0, 0)
EndFunc   ;==>_QPDF_RotateFileLeft_Lite

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_RotateFileRight_Lite
; Description ...: Rotate entire PDF File to right (clockwise)
; Syntax ........: _QPDF_RotateFileRight_Lite($sPDF_FileFullPath)
; Parameters ....: $sPDF_FileFullPath   - A string value.
; Return values .: $iPageRotation
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _QPDF_RotateFileRight_Lite($sPDF_FileFullPath)
	Local $oQP
	If _QPDF_CreateObjectAndUnlock($oQP) = 1 Or _QPDF_CreateObjectAndUnlock($oQP) = 2 Then
		_QPDF_LoadFromFile_Lite($oQP, $sPDF_FileFullPath)
		Local $iTotalPages = _QPDF_PageCount_Lite($oQP)
		Local $iPageRotation = 0
		For $n = 1 To $iTotalPages
			_QPDF_SelectPage_Lite($oQP, $n)
			$iPageRotation = $oQP.PageRotation()
			Switch $iPageRotation
				Case 0
					$iPageRotation = 90
				Case 90
					$iPageRotation = 180
				Case 180
					$iPageRotation = 270
				Case 270
					$iPageRotation = 0
			EndSwitch
			_QPDF_RotatePage_Lite($oQP, $iPageRotation)
		Next
		_QPDF_SaveToFile_Lite($oQP, $sPDF_FileFullPath)
		Return $iPageRotation
	EndIf
	Return SetError($QPDF_ERR_INVALIDLICENSEKEY, 0, 0)
EndFunc   ;==>_QPDF_RotateFileRight_Lite

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_RotatePage_Lite
; Description ...: Used to rotate the page by a multiple of 90 degrees.
; Syntax ........: _QPDF_RotatePage_Lite(Byref $oQP[, $iPageRotation = 0])
; Parameters ....: $oQP                 - [in/out] Reference to a QuickPDF object.
;                  $iPageRotation       - [optional] An integer value. Default is 0.
; Return values .: Returns the rotation of the selected page. This value should always be a multiple of 90 degrees.
; Author ........: mLipok
; Modified ......:
; Remarks .......: This will also rotate the co-ordinate system on the page so that it remains the same with respect to the orientation of the page.
;                  The rotation is absolute, for example calling the function twice with a parameter of 90 will result in a page rotated by 90 degrees, not 180 degrees.
; Related .......:
; Link ..........: http://www.debenu.com/docs/pdf_library_reference/RotatePage.php
; Example .......: No
; ===============================================================================================================================
Func _QPDF_RotatePage_Lite(ByRef $oQP, $iPageRotation = 0)
	If _QPDF_CreateObjectAndUnlock($oQP) = 1 Or _QPDF_CreateObjectAndUnlock($oQP) = 2 Then
		$oQP.RotatePage($iPageRotation) ;
		Return $oQP.PageRotation()
	EndIf
	Return SetError($QPDF_ERR_INVALIDLICENSEKEY, 0, 0)
EndFunc   ;==>_QPDF_RotatePage_Lite

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_SaveToFile_Lite
; Description ...: Saves the selected document to a file on disk.
; Syntax ........: _QPDF_SaveToFile_Lite(Byref $oQP, $sPDF_FileFullPath)
; Parameters ....: $oQP                 - [in/out] Reference to a QuickPDF object.
;                  $sPDF_FileFullPath   - A string value.
; Return values .: TODO
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........: http://www.debenu.com/docs/pdf_library_reference/SaveToFile.php
; Example .......: No
; ===============================================================================================================================
Func _QPDF_SaveToFile_Lite(ByRef $oQP, $sPDF_FileFullPath)
	If _QPDF_CreateObjectAndUnlock($oQP) = 1 Or _QPDF_CreateObjectAndUnlock($oQP) = 2 Then
		$oQP.SaveToFile($sPDF_FileFullPath)
		While _WinAPI_FileInUse($sPDF_FileFullPath)
			Sleep(10)
		WEnd
	Else
		Return SetError($QPDF_ERR_INVALIDLICENSEKEY, 0, 0)
	EndIf
EndFunc   ;==>_QPDF_SaveToFile_Lite

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_SelectFont_Lite
; Description ...: Select one of the fonts which have been added to the selected document. The FontID must be a valid ID as returned by one of the Add*Font functions.
; Syntax ........: _QPDF_SelectFont_Lite(Byref $oQP, $iFontID)
; Parameters ....: $oQP                 - [in/out] Reference to a QuickPDF object.
;                  $iFontID             - An integer value.
; Return values .: TODO
; Author ........: mLipok
; Modified ......:
; Remarks .......: See the definition of constants - Parameters for AddStandardFont, SelectFont
; Related .......: _QPDF_AddStandardFont_Lite
; Link ..........: http://www.debenu.com/docs/pdf_library_reference/SelectFont.php
; Example .......: No
; ===============================================================================================================================
Func _QPDF_SelectFont_Lite(ByRef $oQP, $iFontID)
	If IsObj($oQP) Then
		$oQP.SelectFont($iFontID) ;
	Else
		Return SetError($QPDF_ERR_ISNOTOBJECT, 0, 0)
	EndIf
EndFunc   ;==>_QPDF_SelectFont_Lite

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_SelectPage_Lite
; Description ...: Selects a page of the selected document.
; Syntax ........: _QPDF_SelectPage_Lite(Byref $oQP, $iPageNumber)
; Parameters ....: $oQP                 - [in/out] Reference to a QuickPDF object.
;                  $iPageNumber         - An integer value. The page to select.
; Return values .: 0	The specified page could not be found
;                  1	The page was selected successfully
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........: http://www.debenu.com/docs/pdf_library_reference/SelectPage.php
; Example .......: No
; ===============================================================================================================================
Func _QPDF_SelectPage_Lite(ByRef $oQP, $iPageNumber)
	If _QPDF_CreateObjectAndUnlock($oQP) = 1 Or _QPDF_CreateObjectAndUnlock($oQP) = 2 Then
		Return $oQP.SelectPage($iPageNumber) ;
	EndIf
	Return SetError($QPDF_ERR_INVALIDLICENSEKEY, 0, 0)
EndFunc   ;==>_QPDF_SelectPage_Lite

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_SetBaseURL_Lite
; Description ...: Sets the Base URL for all URL links in the document.
; Syntax ........: _QPDF_SetBaseURL_Lite(Byref $oQP, $sNewBaseURL)
; Parameters ....: $oQP                 - [in/out] Reference to a QuickPDF object.
;                  $sNewBaseURL         - A string value. The base URL to use for all URL link annotations in the document.
; Return values .: TODO
; Author ........: mLipok
; Modified ......:
; Remarks .......: Use the AddLinkToWeb function to add a URL link to the current page.
; Related .......: AddLinkToWeb
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _QPDF_SetBaseURL_Lite(ByRef $oQP, $sNewBaseURL)
	If _QPDF_CreateObjectAndUnlock($oQP) = 1 Or _QPDF_CreateObjectAndUnlock($oQP) = 2 Then
		$oQP.SetBaseURL($sNewBaseURL) ;
	Else
		Return SetError($QPDF_ERR_INVALIDLICENSEKEY, 0, 0)
	EndIf
EndFunc   ;==>_QPDF_SetBaseURL_Lite

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_SetInformation_Lite
; Description ...: Set the properties of the selected document.
; Syntax ........: _QPDF_SetInformation_Lite(Byref $oQP, $iKey, $sNewValue)
; Parameters ....: $oQP                 - [in/out] Reference to a QuickPDF object.
;                  $iKey                - An integer value. See remarks.
;                  $sNewValue           - A string value. See Link.
; Return values .: 0	The specified information could not be set. Use the _QPDF_LastErrorCode_Lite() function to determine the reason for failure.
;                  1	The specified information was set successfully
; Author ........: mLipok
; Modified ......:
; Remarks .......: See the definition of constants - Parameters for SetInformation, GetInformation
; Related .......: GetInformation
; Link ..........: http://www.debenu.com/docs/pdf_library_reference/SetInformation.php
; Example .......: No
; ===============================================================================================================================
Func _QPDF_SetInformation_Lite(ByRef $oQP, $iKey, $sNewValue)
	If _QPDF_CreateObjectAndUnlock($oQP) = 1 Or _QPDF_CreateObjectAndUnlock($oQP) = 2 Then
		Return $oQP.SetInformation($iKey, $sNewValue) ;
	EndIf
	Return SetError($QPDF_ERR_INVALIDLICENSEKEY, 0, 0)
EndFunc   ;==>_QPDF_SetInformation_Lite

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_SetMeasurementUnits_Lite
; Description ...: Set the units to use for all measurements given to and returned from the library.
; Syntax ........: _QPDF_SetMeasurementUnits_Lite(Byref $oQP[, $iMeasurementUnits = $__eQPDF_MUNITS_Milimeters])
; Parameters ....: $oQP                 - [in/out] Reference to a QuickPDF object.
;                  $iMeasurementUnits   - [optional] An integer value. Default is $__eQPDF_MUNITS_Milimeters.
; Return values .: TODO
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Remarks .......: See the definition of constants - Parameters for SetMeasurementUnits
; Related .......:
; Link ..........: http://www.debenu.com/docs/pdf_library_reference/SetMeasurementUnits.php
; Example .......: No
; ===============================================================================================================================
Func _QPDF_SetMeasurementUnits_Lite(ByRef $oQP, $iMeasurementUnits = $__eQPDF_MUNITS_Milimeters)
	If _QPDF_CreateObjectAndUnlock($oQP) = 1 Or _QPDF_CreateObjectAndUnlock($oQP) = 2 Then
		$oQP.SetMeasurementUnits($iMeasurementUnits)
	Else
		Return SetError($QPDF_ERR_INVALIDLICENSEKEY, 0, 0)
	EndIf
EndFunc   ;==>_QPDF_SetMeasurementUnits_Lite

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_SetOrigin_Lite
; Description ...: Sets the origin for all subsequent drawing operations.
; Syntax ........: _QPDF_SetOrigin_Lite(Byref $oQP[, $iOrigin = $__eQPDF_SORIGIN_TopLeft])
; Parameters ....: $oQP                 - [in/out] Reference to a QuickPDF object.
;                  $iOrigin             - [optional] An integer value. Default is $__eQPDF_SORIGIN_TopLeft.
; Return values .: TODO
; Author ........: mLipok
; Modified ......:
; Remarks .......: See the definition of constants - Parameters for SetOrigin
; Related .......:
; Link ..........: http://www.debenu.com/docs/pdf_library_reference/SetOrigin.php
; Example .......: No
; ===============================================================================================================================
Func _QPDF_SetOrigin_Lite(ByRef $oQP, $iOrigin = $__eQPDF_SORIGIN_TopLeft)
	Local $iObjCreateResult = _QPDF_CreateObjectAndUnlock($oQP)
	If $iObjCreateResult = 1 Or $iObjCreateResult = 2 Then
		$oQP.SetOrigin($iOrigin) ;
	Else
		Return SetError(@error, @extended, 0)
	EndIf
EndFunc   ;==>_QPDF_SetOrigin_Lite

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_SetPageBox_Lite
; Description ...: Sets the dimensions of the selected page's boundary rectangles.
; Syntax ........: _QPDF_SetPageBox_Lite(Byref $oQP, $iBoxType, $iLeft, $iTop, $iWidth, $iHeight)
; Parameters ....: $oQP                 - [in/out] Reference to a QuickPDF object.
;                  $iBoxType            - An integer value. See remarks.
;                  $iLeft               - An integer value. The horizontal co-ordinate of the left edge of the rectangle.
;                  $iTop                - An integer value. The vertical co-ordinate of the top edge of the rectangle.
;                  $iWidth              - An integer value. The width of the rectangle.
;                  $iHeight             - An integer value. The height of the rectangle.
; Return values .: TODO
; Author ........: mLipok
; Modified ......:
; Remarks .......: See the definition of constants - Parameters for SetPageBox, GetPageBox, DASetPageBox, DAGetPageBox
; Related .......:
; Link ..........: http://www.debenu.com/docs/pdf_library_reference/SetPageBox.php
; Example .......: No
; ===============================================================================================================================
Func _QPDF_SetPageBox_Lite(ByRef $oQP, $iBoxType, $iLeft, $iTop, $iWidth, $iHeight)
	If _QPDF_CreateObjectAndUnlock($oQP) = 1 Or _QPDF_CreateObjectAndUnlock($oQP) = 2 Then
		$oQP.SetPageBox($iBoxType, $iLeft, $iTop, $iWidth, $iHeight) ;
	Else
		Return SetError($QPDF_ERR_INVALIDLICENSEKEY, 0, 0)
	EndIf
EndFunc   ;==>_QPDF_SetPageBox_Lite

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_SetPageDimensions_Lite
; Description ...: This function updates the MediaBox entry which represents the physical medium of the page and will only affect content subsequently added to the page.
; Syntax ........: _QPDF_SetPageDimensions_Lite(Byref $oQP, $iNewPageWidth, $iNewPageHeigt)
; Parameters ....: $oQP                 - [in/out] Reference to a QuickPDF object.
;                  $iNewPageWidth       - An integer value. The new width of the page.
;                  $iNewPageHeigt       - An integer value. The new height of the page.
; Return values .: 0	The page size could not be set. This should never occur.
;                  1	The page was resized successfully
; Author ........: mLipok
; Modified ......:
; Remarks .......: This function does not resize the already existing content of the page.
; Related .......:
; Link ..........: http://www.debenu.com/docs/pdf_library_reference/SetPageDimensions.php
; Example .......: No
; ===============================================================================================================================
Func _QPDF_SetPageDimensions_Lite(ByRef $oQP, $iNewPageWidth, $iNewPageHeigt)
	If _QPDF_CreateObjectAndUnlock($oQP) = 1 Or _QPDF_CreateObjectAndUnlock($oQP) = 2 Then
		Return $oQP.SetPageDimensions($iNewPageWidth, $iNewPageHeigt) ;
	EndIf
	Return SetError($QPDF_ERR_INVALIDLICENSEKEY, 0, 0)
EndFunc   ;==>_QPDF_SetPageDimensions_Lite

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_SetPageLayout_Lite
; Description ...: Sets the initial page layout of the document.
; Syntax ........: _QPDF_SetPageLayout_Lite(Byref $oQP[, $iNewPageLayout = $__eQPDF_PAGELAYOUT_SinglePage])
; Parameters ....: $oQP                 - [in/out] Reference to a QuickPDF object.
;                  $iNewPageLayout      - [optional] An integer value. Default is $__eQPDF_PAGELAYOUT_SinglePage.
; Return values .: 0	The page layout could not be set
;                  1	The page layout was set successfully
; Author ........: mLipok
; Modified ......:
; Remarks .......: See the definition of constants - Parameters for SetPageLayout
; Related .......:
; Link ..........: http://www.debenu.com/docs/pdf_library_reference/SetPageLayout.php
; Example .......: No
; ===============================================================================================================================
Func _QPDF_SetPageLayout_Lite(ByRef $oQP, $iNewPageLayout = $__eQPDF_PAGELAYOUT_SinglePage)
	If _QPDF_CreateObjectAndUnlock($oQP) = 1 Or _QPDF_CreateObjectAndUnlock($oQP) = 2 Then
		Return $oQP.SetPageLayout($iNewPageLayout) ;
	EndIf
	Return SetError($QPDF_ERR_INVALIDLICENSEKEY, 0, 0)
EndFunc   ;==>_QPDF_SetPageLayout_Lite

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_SetPageMode_Lite
; Description ...: Sets the initial page mode of the document.
; Syntax ........: _QPDF_SetPageMode_Lite(Byref $oQP[, $iNewPageMode = $__eQPDF_PAGEMODE_NormalView])
; Parameters ....: $oQP                 - [in/out] Reference to a QuickPDF object.
;                  $iNewPageMode        - [optional] An integer value. Default is $__eQPDF_PAGEMODE_NormalView.
; Return values .: 0	The page mode could not be set
;                  1	The page mode was set successfully
; Author ........: mLipok
; Modified ......:
; Remarks .......: See the definition of constants - Parameters for SetPageMode
; Related .......:
; Link ..........: http://www.debenu.com/docs/pdf_library_reference/SetPageMode.php
; Example .......: No
; ===============================================================================================================================
Func _QPDF_SetPageMode_Lite(ByRef $oQP, $iNewPageMode = $__eQPDF_PAGEMODE_NormalView)
	If _QPDF_CreateObjectAndUnlock($oQP) = 1 Or _QPDF_CreateObjectAndUnlock($oQP) = 2 Then
		Return $oQP.SetPageMode($iNewPageMode) ;
	EndIf
	Return SetError($QPDF_ERR_INVALIDLICENSEKEY, 0, 0)
EndFunc   ;==>_QPDF_SetPageMode_Lite

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_SetPageSize_Lite
; Description ...: Use this function to set the current page to a named size, for example "A4" or "Letter Landscape".
; Syntax ........: _QPDF_SetPageSize_Lite(Byref $oQP[, $sPaperName = 'A4'])
; Parameters ....: $oQP                 - [in/out] Reference to a QuickPDF object.
;                  $sPaperName          - [optional] A string value. Default is 'A4'.
;                  The name of the paper, one of the following: A0 to A10, B0 to B10, ISOB0 to ISOB10, C0 to C7, DL, Letter, Legal, Statement, Tabloid, Ledger, Executive, Folio
; Return values .: 0	The specified paper name was not valid
;                  1	The page was resized successfully
; Author ........: mLipok
; Modified ......:
; Remarks .......: You can make a landscape page by adding the word Landscape after the paper name, for example "A3 Landscape".
; Related .......:
; Link ..........: http://www.debenu.com/docs/pdf_library_reference/SetPageSize.php
; Example .......: No
; ===============================================================================================================================
Func _QPDF_SetPageSize_Lite(ByRef $oQP, $sPaperName = 'A4')
	If _QPDF_CreateObjectAndUnlock($oQP) = 1 Or _QPDF_CreateObjectAndUnlock($oQP) = 2 Then
		Return $oQP.SetPageSize($sPaperName) ;
	EndIf
	Return SetError($QPDF_ERR_INVALIDLICENSEKEY, 0, 0)
EndFunc   ;==>_QPDF_SetPageSize_Lite

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_SetTextAlign_Lite
; Description ...: Set the alignment of subsequent text drawn with the DrawText, DrawWrappedText or DrawMultiLineText functions.
; Syntax ........: _QPDF_SetTextAlign_Lite(Byref $oQP[, $iTextAlign = $__eQPDF_TEXTALIGN_Left])
; Parameters ....: $oQP                 - [in/out] Reference to a QuickPDF object.
;                  $iTextAlign          - [optional] An integer value. Default is $__eQPDF_TEXTALIGN_Left.
; Return values .: TODO
; Author ........: mLipok
; Modified ......:
; Remarks .......: See the definition of constants - Parameters for SetTextAlign
; Related .......:
; Link ..........: http://www.debenu.com/docs/pdf_library_reference/SetTextAlign.php
; Example .......: No
; ===============================================================================================================================
Func _QPDF_SetTextAlign_Lite(ByRef $oQP, $iTextAlign = $__eQPDF_TEXTALIGN_Left)
	If _QPDF_CreateObjectAndUnlock($oQP) = 1 Or _QPDF_CreateObjectAndUnlock($oQP) = 2 Then
		$oQP.SetTextAlign($iTextAlign) ;
	Else
		Return SetError($QPDF_ERR_INVALIDLICENSEKEY, 0, 0)
	EndIf
EndFunc   ;==>_QPDF_SetTextAlign_Lite

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_SetTextColor_Lite
; Description ...: Sets the color for any subsequently drawn text.
; Syntax ........: _QPDF_SetTextColor_Lite(Byref $oQP, $iRed, $iGreen, $iBlue)
; Parameters ....: $oQP                 - [in/out] Reference to a QuickPDF object.
;                  $iRed                - An integer value. The red component of the color
;                  $iGreen              - An integer value. The green component of the color
;                  $iBlue               - An integer value. The blue component of the color
; Return values .: TODO
; Author ........: mLipok
; Modified ......:
; Remarks .......: The values of the color parameters range from 0 to 1, with 0 indicating 0% and 1 indicating 100% of the color.
; Related .......:
; Link ..........: http://www.debenu.com/docs/pdf_library_reference/SetTextColor.php
; Example .......: No
; ===============================================================================================================================
Func _QPDF_SetTextColor_Lite(ByRef $oQP, $iRed, $iGreen, $iBlue)
	If _QPDF_CreateObjectAndUnlock($oQP) = 1 Or _QPDF_CreateObjectAndUnlock($oQP) = 2 Then
		$oQP.SetTextColor($iRed, $iGreen, $iBlue) ;
	Else
		Return SetError($QPDF_ERR_INVALIDLICENSEKEY, 0, 0)
	EndIf
EndFunc   ;==>_QPDF_SetTextColor_Lite

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_SetTextSize_Lite
; Description ...: Set the size of the text to use for any subsequently draw text.
; Syntax ........: _QPDF_SetTextSize_Lite(Byref $oQP, $iTextSize)
; Parameters ....: $oQP                 - [in/out] Reference to a QuickPDF object.
;                  $iTextSize           - An integer value.
; Return values .: TODO
; Author ........: mLipok
; Modified ......:
; Remarks .......: The text size is always measured in points, even if the measurement units have been changed with SetMeasurementUnits.
; Related .......:
; Link ..........: http://www.debenu.com/docs/pdf_library_reference/SetTextSize.php
; Example .......: No
; ===============================================================================================================================
Func _QPDF_SetTextSize_Lite(ByRef $oQP, $iTextSize)
	If _QPDF_CreateObjectAndUnlock($oQP) = 1 Or _QPDF_CreateObjectAndUnlock($oQP) = 2 Then
		$oQP.SetTextSize($iTextSize) ;
	Else
		Return SetError($QPDF_ERR_INVALIDLICENSEKEY, 0, 0)
	EndIf
EndFunc   ;==>_QPDF_SetTextSize_Lite

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_SetTextUnderline_Lite
; Description ...: Sets the underline mode for subsequently drawn text.
; Syntax ........: _QPDF_SetTextUnderline_Lite(Byref $oQP[, $iUnderline = $__eQPDF_TEXTUNDERLINE_None])
; Parameters ....: $oQP                 - [in/out] Reference to a QuickPDF object.
;                  $iUnderline          - [optional] An integer value. Default is $__eQPDF_TEXTUNDERLINE_None.
; Return values .: TODO
; Author ........: mLipok
; Modified ......:
; Remarks .......: See the definition of constants - Parameters for SetTextUnderline
; Related .......:
; Link ..........: http://www.debenu.com/docs/pdf_library_reference/SetTextUnderline.php
; Example .......: No
; ===============================================================================================================================
Func _QPDF_SetTextUnderline_Lite(ByRef $oQP, $iUnderline = $__eQPDF_TEXTUNDERLINE_None)
	If _QPDF_CreateObjectAndUnlock($oQP) = 1 Or _QPDF_CreateObjectAndUnlock($oQP) = 2 Then
		$oQP.SetTextUnderline($iUnderline) ;
	Else
		Return SetError($QPDF_ERR_INVALIDLICENSEKEY, 0, 0)
	EndIf
EndFunc   ;==>_QPDF_SetTextUnderline_Lite

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_TXT_to_PDF_Lite
; Description ...: Change Text to PDF - wrapper for Lite Version
; Syntax ........: _QPDF_TXT_to_PDF_Lite(Byref $oQP, $sText[, $iLeftMargin = 20[, $iRighMargin = 10[, $iTopMargin = 10[,
;                  $iBottomMargin = 10[, $sTABtoSpace = 4]]]]])
; Parameters ....: $oQP                 - [in/out] Reference to a QuickPDF object.
;                  $sText               - A string value.
;                  $iLeftMargin         - [optional] An integer value. Default is 20.
;                  $iRighMargin         - [optional] An integer value. Default is 10.
;                  $iTopMargin          - [optional] An integer value. Default is 10.
;                  $iBottomMargin       - [optional] An integer value. Default is 10.
;                  $sTABtoSpace         - [optional] A string value. Default is 4.
; Return values .: TODO
; Author ........: mLipok
; Modified ......:
; Remarks .......: This Function is useful to change any TXT file to PDF. Begining from Debenu Quick PDF Library Lite 11.14  DrawHTMLText, DrawHTMLTextBox are included in Lite version
; Related .......: _QPDF_TXT_to_PDF
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _QPDF_TXT_to_PDF_Lite(ByRef $oQP, $sText, $iLeftMargin = 20, $iRighMargin = 10, $iTopMargin = 10, $iBottomMargin = 10, $sTABtoSpace = 4)
	Return _QPDF_TXT_to_PDF($oQP, $sText, $iLeftMargin, $iRighMargin, $iTopMargin, $iBottomMargin, $sTABtoSpace)
EndFunc   ;==>_QPDF_TXT_to_PDF_Lite
#EndRegion QuickPDF.au3 - #QuickPDF Lite#

#Region QuickPDF.au3 - NEW FUNC

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_Arrow
; Description ...: Draw Arrow with ArrowHeads
; Syntax ........: _QPDF_Arrow($iStartX, $iStartY, $iEndX, $iEndY[, $iArrowHeadLenPercent = 10[, $iArrowHeadAngleDegree = 10[,
;                  $iArrowThickness = 0.1[, $iArrowHeadThickness = 0.1]]]])
; Parameters ....: $iStartX                      - an integer value.
;                  $iStartY                      - an integer value.
;                  $iEndX                      - an integer value.
;                  $iEndY                      - an integer value.
;                  $iArrowHeadLenPercent     - [optional] an integer value. Default is 10. In relation to the length of the arrows.
;                  $iArrowHeadAngleDegree    - [optional] an integer value. Default is 10.
;                  $iArrowThickness          - [optional] an integer value. Default is 0.1.
;                  $iArrowHeadThickness      - [optional] an integer value. Default is 0.1.
; Return values .: None
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........: http://www.quickpdf.org/forum/drawing-of-the-arrowhead-on-the-end-of-drown-line_topic3155.html
; Example .......: No
; ===============================================================================================================================
Func _QPDF_Arrow($oQP, $iStartX, $iStartY, $iEndX, $iEndY, $iArrowHeadLenPercent = 10, $iArrowHeadAngleDegree = 10, $iArrowThickness = 0.1, $iArrowHeadThickness = 0.1)

	If Not __QPDF_IsValidObject($oQP) Then Return SetError(@error, @extended, 0)

	$oQP.SetOrigin($__eQPDF_SORIGIN_TopLeft)
	$oQP.SetMeasurementUnits($__eQPDF_MUNITS_Milimeters)

	$oQP.SetLineCap(1)
	$oQP.SetLineWidth($iArrowThickness)
	$oQP.Drawline($iStartX, $iStartY, $iEndX, $iEndY)

	Local $iDeltaX = $iEndX - $iStartX
	Local $iDeltaY = $iEndY - $iStartY

	; Assign a Local constant variable the approximate PI number.
	Local Const $PI = _Radian(180)

	Local $iArrowHeadAngleRadian = _Radian($iArrowHeadAngleDegree)

	; Tan(angle) = Y / X
	; Atan(X / Y) = angle
	Local $iArrowRadian = ATan($iDeltaY / $iDeltaX)
	Local $iReverseArrowRadian = $iArrowRadian + $PI

	Local $iArrowLength
	If $iDeltaY = 0 Then
		$iArrowLength = $iDeltaX
	Else
		; Sin(angle) = Y / Len
		$iArrowLength = $iDeltaY / Sin($iArrowRadian)
	EndIf

	Local $iArrowHeadLength = $iArrowLength * $iArrowHeadLenPercent / 100

	Local $iRadianTiltedToTheRight = $iReverseArrowRadian + $iArrowHeadAngleRadian
	Local $iRadianTiltedToTheLeft = $iReverseArrowRadian - $iArrowHeadAngleRadian

	; tg(angle) = Y / X
	; ctg(angle) = X / Y
	; sin(angle) = Y / $iArrowHeadLength
	; cos(angle) = X / $iArrowHeadLength

	$oQP.SetLineWidth($iArrowHeadThickness)

	$oQP.Drawline($iEndX, $iEndY, _
			$iEndX + Cos($iRadianTiltedToTheRight) * $iArrowHeadLength, _
			$iEndY + Sin($iRadianTiltedToTheRight) * $iArrowHeadLength _
			)
	$oQP.Drawline($iEndX, $iEndY, _
			$iEndX + Cos($iRadianTiltedToTheLeft) * $iArrowHeadLength, _
			$iEndY + Sin($iRadianTiltedToTheLeft) * $iArrowHeadLength _
			)

EndFunc   ;==>_QPDF_Arrow

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_Display
; Description ...: Display PDF Document
; Syntax ........: _QPDF_Display($oQP[, $sPDF_Display_Comment = ''[, $iLeft = -1[, $iTop = 0[, $iWidth = 800[, $iSelectPage = 1]]]]])
; Parameters ....: $oQP                 - [in/out] Reference to a QuickPDF object.
;                  $sPDF_Display_Comment- [optional] A string value. Default is ''.
;                  $iLeft               - [optional] An integer value. Default is -1.
;                  $iTop                - [optional] An integer value. Default is 0.
;                  $iWidth              - [optional] An integer value. Default is 800.
;                  $iSelectPage         - [optional] An integer value. Default is 1.
; Return values .: TODO
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _QPDF_Display($oQP, $sPDF_Display_Comment = '', $iLeft = -1, $iTop = 0, $iWidth = 800, $iSelectPage = 1)
	Local $sPDF_Display_Title = 'QuickPDF Test Display: ' & $sPDF_Display_Comment
	If Not IsObj($oQP) Then
		; TODO
	Else
		; select Page
		$oQP.SelectPage($iSelectPage) ;
		$oQP.SetOrigin(0)
		$oQP.SetMeasurementUnits(0)
		$oQP.NormalizePage(0)
		$oQP.CombineContentStreams()
		$oQP.SelectContentStream(1)
		; Local $sOutput
		; $sOutput &= BinaryToString($oQP.GetContentStreamToVariant()) & @CRLF
		; $oQP.SelectContentStream(1)

		; calculate DPI
		Local $iPageWidth = $oQP.PageWidth() ;
		Local $iPageHeight = $oQP.PageHeight() ;
		; Local $iInches = $iPageWidth / 72
		Local $iDisplayDPI = ($iWidth / $iPageWidth) * 72

		; create GUI
		Local $iHeight = ($iWidth * $iPageHeight) / $iPageWidth
		Local $hWND_QP_TestDisplay = GUICreate($sPDF_Display_Title, $iWidth, $iHeight, $iLeft, $iTop)
		GUISetState(@SW_SHOW)
		Local $hDC = _WinAPI_GetDC($hWND_QP_TestDisplay)

		; render QP object to Device Context
		$oQP.RenderPageToDC($iDisplayDPI, $iSelectPage, $hDC) ;

		While 1
			Switch GUIGetMsg()
				Case $GUI_EVENT_CLOSE
					ExitLoop
			EndSwitch
		WEnd
		_WinAPI_ReleaseDC($hWND_QP_TestDisplay, $hDC)
		GUIDelete($hWND_QP_TestDisplay) ; Deletes a GUI window and all controls that it contains.
	EndIf
EndFunc   ;==>_QPDF_Display

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_Display_PDFFile
; Description ...: Display PDF File
; Syntax ........: _QPDF_Display_PDFFile($sFileFullPath[, $sPDFPassword = ''[, $iLeft = -1[, $iTop = 0[, $iWidth = 800[,
;                  $iSelectPage = 1]]]]])
; Parameters ....: $sFileFullPath       - A string value.
;                  $sPDFPassword        - [optional] A string value. Default is ''.
;                  $iLeft               - [optional] An integer value. Default is -1.
;                  $iTop                - [optional] An integer value. Default is 0.
;                  $iWidth              - [optional] An integer value. Default is 800.
;                  $iSelectPage         - [optional] An integer value. Default is 1.
; Return values .: TODO
; Author ........: nLipok
; Modified ......:
; Remarks .......:
; Related .......: _QPDF_Display
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _QPDF_Display_PDFFile($sFileFullPath, $sPDFPassword = '', $iLeft = -1, $iTop = 0, $iWidth = 800, $iSelectPage = 1)
	; Object initialization
	Local $oQP
	If _QPDF_CreateObjectAndUnlock($oQP) = 1 Then
		; get Device Context
		; Load PDF File to QP Object
		$oQP.LoadFromFile($sFileFullPath, $sPDFPassword) ;
		Local $sPDF_Display_Comment = $sFileFullPath
		_QPDF_Display($oQP, $sPDF_Display_Comment, $iLeft, $iTop, $iWidth, $iSelectPage)
	EndIf
	$oQP = Null ; CleanUp - destroy object

EndFunc   ;==>_QPDF_Display_PDFFile

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_Example_ExtractImages
; Description ...:
; Syntax ........: _QPDF_Example_ExtractImages($sPDF_FileFullPath[, $sPDFPassword = ''[, $sOutputDir = @ScriptDir]])
; Parameters ....: $sPDF_FileFullPath   - a string value.
;                  $sPDFPassword        - [optional] a string value. Default is ''.
;                  $sOutputDir          - [optional] a string value. Default is @ScriptDir.
; Return values .: None
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _QPDF_Example_ExtractImages($sPDF_FileFullPath, $sPDFPassword = '', $sOutputDir = @ScriptDir)
	; This example can be used only in the commercial version of the library.
	Local $oQP
	If _QPDF_CreateObjectAndUnlock($oQP) = 1 Then
		$oQP.LoadFromFile($sPDF_FileFullPath, $sPDFPassword = '')
		$oQP.SetFindImagesMode(2)
		Local $iImageCount = $oQP.FindImages()
		Local $iImageID = 0
		For $iImage_idx = 1 To $iImageCount
			$iImageID = $oQP.GetImageID($iImage_idx)
			$oQP.SelectImage($iImageID)
			Switch $oQP.ImageType()
				Case 0
				Case 1
					$oQP.SaveImageToFile($sOutputDir & '\Image_' & $iImage_idx & '.jpeg')
				Case 2
					$oQP.SaveImageToFile($sOutputDir & '\Image_' & $iImage_idx & '.bmp')
				Case 3
					$oQP.SaveImageToFile($sOutputDir & '\Image_' & $iImage_idx & '.tiff')
			EndSwitch

		Next
	EndIf
EndFunc   ;==>_QPDF_Example_ExtractImages

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_FolderExtractText
; Description ...: Extract text from any PDF file in specified directory
; Syntax ........: _QPDF_FolderExtractText([$sDirFullPath = Default [, $sPDF_Password = ''[, $iExtractOptions = 7]]])
; Parameters ....: $sDirFullPath     - [optional] A string value. Default is Default .
;                  $sPDF_Password       - [optional] A string value. Default is ''.
;                  $iExtractOptions     - [optional] An integer value. Default is 7.
; Return values .: TODO
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......: _QPDF_ExtractTextFromFile
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _QPDF_FolderExtractText($sDirFullPath = Default, $sPDF_Password = '', $iExtractOptions = 7)
	If $sDirFullPath = Default Then $sDirFullPath = FileSelectFolder('Choose folder with PDF files', '', 4)
	If @error Then
		; TODO
	Else
		Local $aPDF_FileList = _FileListToArray($sDirFullPath, '*.pdf', 1, True)
		If UBound($aPDF_FileList) Then
			Local $sPDF_ExtractedText
			Local $hPDF_FileHandle
			For $iPDF = 1 To UBound($aPDF_FileList) - 1
				$sPDF_ExtractedText = _QPDF_ExtractTextFromFile($aPDF_FileList[$iPDF], $sPDF_Password, $iExtractOptions)
				If @error Then
					; TODO
				Else
					$hPDF_FileHandle = FileOpen(StringTrimRight($aPDF_FileList[$iPDF], 4) & '.txt', $FO_OVERWRITE + $FO_UTF8)
					FileWrite($hPDF_FileHandle, $sPDF_ExtractedText)
					FileClose($hPDF_FileHandle)
				EndIf
			Next
		EndIf
	EndIf
EndFunc   ;==>_QPDF_FolderExtractText

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_GetInformation
; Description ...: Get information from PDF File
; Syntax ........: _QPDF_GetInformation($sPDF_FileFullPath[, $sPDF_Password = ''])
; Parameters ....: $sPDF_FileFullPath   - A string value.
;                  $sPDF_Password       - [optional] A string value. Default is ''.
; Return values .: succes: array with the following info:
;					0 = PDF Version
;					1 = Author
;					2 = Title
;					3 = Subject
;					4 = Keywords
;					5 = Creator
;					6 = Producer
;					7 = Creation date
;					8 = Modification date
; Author ........: mLipok
; Modified ......:
; Remarks .......: it works with Lite (free) version ie. DebenuPDFLibraryLite1114.dll
; Related .......:
; Link ..........:
; Example .......: Yes
; ===============================================================================================================================
Func _QPDF_GetInformation($sPDF_FileFullPath, $sPDF_Password = '')
	Local $oQP
	If _QPDF_CreateObjectAndUnlock($oQP) = 1 Or _QPDF_CreateObjectAndUnlock($oQP) = 2 Then
		$oQP.LoadFromFile($sPDF_FileFullPath, $sPDF_Password)
		Local $aReturn[9] = [ _
				$oQP.GetInformation(0), _
				$oQP.GetInformation(1), _
				$oQP.GetInformation(2), _
				$oQP.GetInformation(3), _
				$oQP.GetInformation(4), _
				$oQP.GetInformation(5), _
				$oQP.GetInformation(6), _
				$oQP.GetInformation(7), _
				$oQP.GetInformation(8) _
				]
		Return $aReturn
	Else
		_QPDF_LastErrorCode($oQP)
	EndIf
	$oQP = Null ; CleanUp - destroy object
EndFunc   ;==>_QPDF_GetInformation

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_GetPageMetricsToString
; Description ...: Returns the dimensions (MediaBox and CropBox) and rotation of the specified page range in the document.
; Syntax ........: _QPDF_GetPageMetricsToString(Byref $oQP, $iStartPage, $iEndPage[, $iOptions = 2])
; Parameters ....: $oQP                 - [in/out] Reference to a QuickPDF object.
;                  $iStartPage          - An integer value. The first page in the range
;                  $iEndPage            - An integer value. The last page in the range
;                  $iOptions            - [optional] An integer value. Default is 2.
;						1 = Binary output - Nine double values per page are streamed in a continuous array. For each page there are the elements of the MediaBox, the elements of the CropBox and the value of the Rotation entry.
;						2 = Text output - The values are displayed in text format, separated by tab (char 9) characters and with CRLF after each page.
; Return values .: TODO
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........: http://www.debenu.com/docs/pdf_library_reference/GetPageMetricsToString.php
; Example .......: No
; ===============================================================================================================================
Func _QPDF_GetPageMetricsToString(ByRef $oQP, $iStartPage, $iEndPage, $iOptions = 2)
	If _QPDF_CreateObjectAndUnlock($oQP) = 1 Or _QPDF_CreateObjectAndUnlock($oQP) = 2 Then
		Return $oQP.GetPageMetricsToString($iStartPage, $iEndPage, $iOptions)
	Else
		Return SetError($QPDF_ERR_INVALIDLICENSEKEY, 0, 0)
	EndIf
EndFunc   ;==>_QPDF_GetPageMetricsToString

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_Page_2in1
; Description ...: TODO
; Syntax ........: _QPDF_Page_2in1(Byref $oQP[, $bAddSplitter = False])
; Parameters ....: $oQP                 - [in/out] Reference to a QuickPDF object.
;                  $bAddSplitter        - [optional] A binary value. Default is False.
; Return values .: TODO
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _QPDF_Page_2in1(ByRef $oQP, $bAddSplitter = False)
	; _QPDF_Display() - only for testing - This is my own function
	; _QPDF_Display($oQP, 'Loaded document 1')
	Local $iOrginalPageCount = $oQP.PageCount()

	Local $iNewPageCounter = 0
	Local $bNewPageHaveDrawedTopOfPage = False ; 1 = true ,  0 = false

	Local $iID_CapturedPage

	If Not $iOrginalPageCount > 1 Then Return SetError(1, 0, 0)

	For $iCurrentPage = 1 To $iOrginalPageCount
		; MsgBox() - only for testing
		; MsgBox(0, '$iCurrentPage', $iCurrentPage & ' / ' & $iOrginalPageCount)
		If Not $bNewPageHaveDrawedTopOfPage Then
			$oQP.NewPage()
			$iNewPageCounter += 1
			$oQP.MovePage($iNewPageCounter)
			$oQP.SetPageSize('A4')
			If $bAddSplitter Then
				$oQP.SetLineWidth(1)
				$oQP.SetLineColor(1, 0, 0)
				$oQP.SetMeasurementUnits($__eQPDF_MUNITS_Milimeters)
				$oQP.DrawLine(0, $__eQPDF_A4_HeightInMM / 2, $__eQPDF_A4_WidthInMM, $__eQPDF_A4_HeightInMM / 2)
				; MsgBox() - only for testing
				; MsgBox(0, '$oQP.GetOrigin', $oQP.GetOrigin())

			EndIf
		EndIf

		; _QPDF_Display() - only for testing - This is my own function
		; _QPDF_Display($oQP, 'Page: $iCurrentPage + $iNewPageCounter: ' & $iCurrentPage &'/' &$iNewPageCounter &'/' &$iNewPageCounter + 1, $iNewPageCounter + 1)
		$iID_CapturedPage = $oQP.CapturePage($iNewPageCounter + 1)

		; select Page to which you want Insert content - Draw Captutred Page
		$oQP.SelectPage($iNewPageCounter)

		If Not $bNewPageHaveDrawedTopOfPage Then
			; draw on top of page
			$oQP.DrawRotatedCapturedPage($iID_CapturedPage, 0, _
					$__eQPDF_A4_HeightInMM, _
					$__eQPDF_A4_HeightInMM / 2, $__eQPDF_A4_WidthInMM, 270)
			$bNewPageHaveDrawedTopOfPage = True
		Else
			; draw on bootom of page
			$oQP.DrawRotatedCapturedPage($iID_CapturedPage, 0, _
					$__eQPDF_A4_HeightInMM / 2, _
					$__eQPDF_A4_HeightInMM / 2, $__eQPDF_A4_WidthInMM, 270)
			$bNewPageHaveDrawedTopOfPage = False
		EndIf
	Next
	; _QPDF_Display() - only for testing - This is my own function
	; _QPDF_Display($oQP, 'After Change')
EndFunc   ;==>_QPDF_Page_2in1

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_Page_2in1_File
; Description ...: Merging two A4 pages in A5 format, and placing them on A4
; Syntax ........: _QPDF_Page_2in1_File([$sPDF_FileFullPath = Default[, $sPDFPassword = ''[, $bAddSplitter = True[,
;                  $bReplaceOrginalFile = True]]]])
; Parameters ....: $sPDF_FileFullPath   - [optional] A string value. Default is Default.
;                  $sPDFPassword        - [optional] A string value. Default is ''.
;                  $bAddSplitter        - [optional] A binary value. Default is True.
;                  $bReplaceOrginalFile - [optional] A binary value. Default is True.
; Return values .: TODO
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _QPDF_Page_2in1_File($sPDF_FileFullPath = Default, $sPDFPassword = '', $bAddSplitter = True, $bReplaceOrginalFile = True, $iRotation = Default)
	If $sPDF_FileFullPath = Default Then
		$sPDF_FileFullPath = FileOpenDialog('Select PDF File', @ScriptDir, 'PDF File (*.pdf)')
	EndIf
	If @error Or Not FileExists($sPDF_FileFullPath) Then
		MsgBox($MB_SYSTEMMODAL, 'NOTE', 'File does not exist. or no file selected')
	Else
		Local $oQP
		If _QPDF_CreateObjectAndUnlock($oQP) Then
			$oQP.LoadFromFile($sPDF_FileFullPath, $sPDFPassword) ;
			_QPDF_Page_2in1($oQP, $bAddSplitter)
			If Not @error Then
				If $iRotation <> Default Then _QPDF_Rotate_Lite($oQP, $iRotation)
			EndIf

			Local $sSAVE_FileFullPath = ''
			If $bReplaceOrginalFile Then
				$sSAVE_FileFullPath = $sPDF_FileFullPath
			Else
				$sSAVE_FileFullPath = $sPDF_FileFullPath & '_2in1.pdf'
			EndIf
			$oQP.SaveToFile($sSAVE_FileFullPath)

			; _QPDF_Display() - only for testing - This is my own function
			; _QPDF_Display($oQP, 'After Save')
			; $oQP.LoadFromFile($sPDF_FileFullPath & '_2.pdf', $sPDFPassword);
			; _QPDF_Display() - only for testing - This is my own function
			; _QPDF_Display($oQP, 'After ReLoad')
			Return $oQP
		Else
			Return SetError($QPDF_ERR_INVALIDLICENSEKEY, 0, $sSAVE_FileFullPath)
		EndIf
	EndIf

EndFunc   ;==>_QPDF_Page_2in1_File

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_PageEnumerator
; Description ...:
; Syntax ........: _QPDF_PageEnumerator(Byref $oQP[, $sFormat = 'Page: %d of %d'])
; Parameters ....: $oQP                 - [in/out] an object.
;                  $sFormat             - [optional] a string value. Default is 'Page: %d of %d'.
; Return values .: None
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _QPDF_PageEnumerator(ByRef $oQP, $sFormat = 'Page: %d of %d')
	Local $iX = 0
	Local $iY = $__eQPDF_A4_HeightInMM - 20

	Local $iCounter = $oQP.PageCount()
	Local $sText = ''
	Local $iTextWidth = 0

	For $iPage = 1 To $iCounter
		$oQP.SelectPage($iPage)
		$oQP.SetOrigin($__eQPDF_SORIGIN_TopLeft) ;
		$oQP.SetMeasurementUnits($__eQPDF_MUNITS_Milimeters)
		$sText = StringFormat($sFormat, $iPage, $iCounter)
		$oQP.SetTextSize(5)
		$iTextWidth = $oQP.GetTextWidth($sText)
		$iX = $__eQPDF_A4_WidthInMM - $iTextWidth - 10
		$oQP.DrawText($iX, $iY, $sText)
	Next

EndFunc   ;==>_QPDF_PageEnumerator

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_PrintFromStream
; Description ...: Printing from Binary Stream data
; Syntax ........: _QPDF_PrintFromStream($dPDF_Stream[, $sPDF_Password = ''[, $sTitle = 'PDF Document'[, $iDuplex = 1[,
;                  $iCopies = 1]]]])
; Parameters ....: $dPDF_Stream         - An unknown value.
;                  $sPDF_Password       - [optional] A string value. Default is ''.
;                  $sTitle              - [optional] A string value. Default is 'PDF Document'.
;                  $iDuplex             - [optional] An integer value. Default is 1.
;                  $iCopies             - [optional] An integer value. Default is 1.
; Return values .: TODO
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _QPDF_PrintFromStream($dPDF_Stream, $sPDF_Password = '', $sTitle = 'PDF Document', $iDuplex = 1, $iCopies = 1)
	Local $oQP
	_QPDF_CreateObjectFromStream($oQP, $dPDF_Stream, $sPDF_Password)
	If @error Then
		Return SetError(@error, 0, 0)
	Else
		$oQP.SetOrigin($__eQPDF_SORIGIN_TopLeft) ; needed for some $iExtractOptions
		$oQP.SetMeasurementUnits($__eQPDF_MUNITS_Milimeters) ; needed for some $iExtractOptions

		Local $sCustomPrinter = $oQP.NewCustomPrinter($oQP.GetDefaultPrinterName()) ;

		; setting Duplex Mode
		$oQP.SetupCustomPrinter($sCustomPrinter, 7, $iDuplex) ;

		; setting Number of Copies
		$oQP.SetupCustomPrinter($sCustomPrinter, 4, $iCopies) ;

		Local $iPrintOptions = $oQP.PrintOptions(0, 0, $sTitle)
		$oQP.PrintDocument($sCustomPrinter, 1, $oQP.PageCount, $iPrintOptions) ;

		; CleanUp
		$oQP = ''

		Return SetError($QPDF_ERR_OK, 0, 1)
	EndIf

EndFunc   ;==>_QPDF_PrintFromStream

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_ReplaceFonts_in_File
; Description ...: This function remove embended fonts from PDF File and use standard PDF Fonts. In this way you can in some cases, you can reduce the PDF file size.
; Syntax ........: _QPDF_ReplaceFonts_in_File([$sPDF_FileFullPath = Default [, $sPDFPassword = ''[, $sPDF_Display_Comment = '']]])
; Parameters ....: $sPDF_FileFullPath   - [optional] a string value. Default is Default .
;                  $sPDFPassword        - [optional] a string value. Default is ''.
;                  $sPDF_Display_Comment- [optional] a string value. Default is ''.
; Return values .: TODO
; Author ........: mLipok
; Modified ......:
; Remarks .......: If you pass a comment then function will display PDF - just for checking
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _QPDF_ReplaceFonts_in_File($sPDF_FileFullPath = Default, $sPDFPassword = '', $sPDF_Display_Comment = '')
	If $sPDF_FileFullPath = Default Then
		$sPDF_FileFullPath = FileOpenDialog('Select PDF File', @ScriptDir, 'PDF File (*.pdf)')
	EndIf
	If @error Or Not FileExists($sPDF_FileFullPath) Then
		MsgBox($MB_SYSTEMMODAL, 'NOTE', 'File does not exist. or no file selected')
	Else
		Local $oQP
		If _QPDF_CreateObjectAndUnlock($oQP) Then
			$oQP.LoadFromFile($sPDF_FileFullPath, $sPDFPassword) ;
			If $sPDF_Display_Comment <> '' Then _QPDF_Display($oQP, 'Before' & $sPDF_Display_Comment)
			$oQP.ReplaceFonts(10)
			$oQP.SaveToFile($sPDF_FileFullPath) ;
			If $sPDF_Display_Comment <> '' Then _QPDF_Display($oQP, 'After' & $sPDF_Display_Comment)
		Else
			Return SetError($QPDF_ERR_INVALIDLICENSEKEY, 0, 0)
		EndIf
	EndIf

EndFunc   ;==>_QPDF_ReplaceFonts_in_File

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_SaveAndOpen
; Description ...: Quick Dump QP object fo file and Open in default app to see what is going on
; Syntax ........: _QPDF_SaveAndOpen(Byref $oQP, $sPDFFileFullPath)
; Parameters ....: $oQP                 - [in/out] Reference to a QuickPDF object.
;                  $sPDFFileFullPath    - A string value.
;                  $sSomeComment        - [optional] A string value. Default is Default.
; Return values .: TODO
; Author ........: mLipok
; Modified ......:
; Remarks .......: if you specyfi $sSomeComment then you be have a possibility to pause script
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _QPDF_SaveAndOpen(ByRef $oQP, $sPDFFileFullPath, $sSomeComment = Default)
	$oQP.SaveToFile($sPDFFileFullPath)
	ShellExecute($sPDFFileFullPath)
	If $sSomeComment <> Default And IsString($sSomeComment) Then
		MsgBox(0, '_QPDF_SaveAndOpen: $sSomeComment', $sSomeComment)
	EndIf
EndFunc   ;==>_QPDF_SaveAndOpen

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_StringInPDFFile
; Description ...: Function similar to StringInStr
; Syntax ........: _QPDF_StringInPDFFile($sPDF_FileFullPath, $sStringToFind[, $sPDFPassword = ''[, $iExtractOptions = 7]])
; Parameters ....: $sPDF_FileFullPath   - A string value.
;                  $sStringToFind       - A string value.
;                  $sPDFPassword        - [optional] A string value. Default is ''.
;                  $iExtractOptions     - [optional] An integer value. Default is 7.
; Return values .: the same as in StringInStr
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......: _QPDF_ExtractTextFromFile
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _QPDF_StringInPDFFile($sPDF_FileFullPath, $sStringToFind, $sPDFPassword = '', $iExtractOptions = 7)
	Local $sPDF_TXTContents = _QPDF_ExtractTextFromFile($sPDF_FileFullPath, $sPDFPassword, $iExtractOptions)
	Return StringInStr($sPDF_TXTContents, $sStringToFind)
EndFunc   ;==>_QPDF_StringInPDFFile

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_StringInPDFStrem
; Description ...: Function similar to StringInStr, but text is taken from PDF Stream
; Syntax ........: _QPDF_StringInPDFStrem($dPDF_Stream, $sStringToFind[, $sPDFPassword = ''[, $iExtractOptions = 7]])
; Parameters ....: $dPDF_Stream         - An unknown value.
;                  $sStringToFind       - A string value.
;                  $sPDFPassword        - [optional] A string value. Default is ''.
;                  $iExtractOptions     - [optional] An integer value. Default is 7.
; Return values .: the same as in StringInStr
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _QPDF_StringInPDFStrem($dPDF_Stream, $sStringToFind, $sPDFPassword = '', $iExtractOptions = 7)
	Local $sPDF_TXTContents = _QPDF_ExtractTextFromStream($dPDF_Stream, $sPDFPassword, $iExtractOptions)
	Return StringInStr($sPDF_TXTContents, $sStringToFind)
EndFunc   ;==>_QPDF_StringInPDFStrem

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_TXT_to_PDF
; Description ...: Change Text to PDF
; Syntax ........: _QPDF_TXT_to_PDF(Byref $oQP, $sText[, $iLeftMargin = 20[, $iRighMargin = 10[, $iTopMargin = 10[,
;                  $iBottomMargin = 10[, $iTABtoSpace = 4[, $sStyle = Default]]]]]])
; Parameters ....: $oQP                 - [in/out] Reference to a QuickPDF object.
;                  $sText               - A string value.
;                  $iLeftMargin         - [optional] An integer value. Default is 20.
;                  $iRighMargin         - [optional] An integer value. Default is 10.
;                  $iTopMargin          - [optional] An integer value. Default is 10.
;                  $iBottomMargin       - [optional] An integer value. Default is 10.
;                  $iTABtoSpace         - [optional] A string value. Default is 4.
;                  $sStyle              - [optional] a string value. Default is Default.
; Return values .: PageCount
; Author ........: mLipok
; Modified ......:
; Remarks .......: This Function is useful to change any TXT file to PDF, You can set your own style before calling this function.
; Related .......: _QPDF_TXTFile_to_PDFFile
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _QPDF_TXT_to_PDF(ByRef $oQP, $sText, $iLeftMargin = 20, $iRighMargin = 10, $iTopMargin = 10, $iBottomMargin = 10, $iTABtoSpace = 4, $sStyle = Default)

	; Replace @TAB to spaces.
	$sText = StringReplace($sText, @TAB, _StringRepeat(Chr(160), $iTABtoSpace))

	Local $iTextWidth = $__eQPDF_A4_WidthInMM - $iLeftMargin - $iRighMargin
	Local $iTextHeight = $__eQPDF_A4_HeightInMM - $iTopMargin - $iBottomMargin

	If $sStyle = Default Then
		Local $iIDFont = $oQP.AddTrueTypeFont('Arial {1250}', 0)
		$oQP.SetOrigin($__eQPDF_SORIGIN_TopLeft) ;
		$oQP.SetMeasurementUnits($__eQPDF_MUNITS_Milimeters)
		$oQP.SetHTMLNormalFont('Default', $iIDFont)
		$sStyle = 'DefaultStyle'
		$oQP.SaveStyle($sStyle)
	ElseIf IsString($sStyle) And StringLen($sStyle) Then
		If $oQP.ApplyStyle($sStyle) = 0 Then
			Return SetError($QPDF_ERR_WRONGSTYLEPARAMETER, 0, 0)
		EndIf
	Else
		Return SetError($QPDF_ERR_WRONGSTYLEPARAMETER, 0, 0)
	EndIf

	Local $sOverFlowOutput = $oQP.DrawHTMLTextBox($iLeftMargin, $iTopMargin, $iTextWidth, $iTextHeight, $sText)
	While $sOverFlowOutput
		$oQP.NewPage()
		$oQP.ApplyStyle($sStyle)
		$sOverFlowOutput = $oQP.DrawHTMLTextBox($iLeftMargin, $iTopMargin, $iTextWidth, $iTextHeight, $sOverFlowOutput)
	WEnd
	Return SetError($QPDF_ERR_OK, 0, $oQP.PageCount())
EndFunc   ;==>_QPDF_TXT_to_PDF

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_TXTFile_to_PDFFile
; Description ...: Convert TXT File to PDF File
; Syntax ........: _QPDF_TXTFile_to_PDFFile($sTxtFileFullPath, $sPDFFileFullPath)
; Parameters ....: $sTxtFileFullPath    - a string value.
;                  $sPDFFileFullPath    - a string value.
; Return values .: TODO
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......: _QPDF_TXT_to_PDF
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _QPDF_TXTFile_to_PDFFile($sTxtFileFullPath, $sPDFFileFullPath)
	Local $oQP
	If _QPDF_CreateObjectAndUnlock($oQP) = 1 Or _QPDF_CreateObjectAndUnlock($oQP) = 2 Then
		Local $sText = FileRead($sTxtFileFullPath)
		$sText = StringRegExpReplace($sText, '\R', '<br>')
		_QPDF_TXT_to_PDF($oQP, $sText)

		FileDelete($sPDFFileFullPath)
		If $oQP.SaveToFile($sPDFFileFullPath) = 1 Then
			While _WinAPI_FileInUse($sPDFFileFullPath)
				Sleep(10)
			WEnd
		Else
			MsgBox($MB_SYSTEMMODAL + $MB_OK + $MB_ICONERROR, "Error", "File " & $sPDFFileFullPath & " could not be saved.")
		EndIf
	EndIf
	$oQP = Null ; CleanUp - destroy object
EndFunc   ;==>_QPDF_TXTFile_to_PDFFile
#EndRegion QuickPDF.au3 - NEW FUNC

#Region QuickPDF.au3 - HTML MiscFunction

Func _QPDF_Html_Font_BackgroundColor($sPlainTextToConvert, $iColor)
	Local $sHTMLString = '<font background="' & $iColor & '">' & $sPlainTextToConvert & '</font>'
	Return $sHTMLString
EndFunc   ;==>_QPDF_Html_Font_BackgroundColor

Func _QPDF_Html_Font_Green($sPlainTextToConvert)
	Local $sHTMLString = '<font color="#339933">' & $sPlainTextToConvert & '</font>'
	Return $sHTMLString
EndFunc   ;==>_QPDF_Html_Font_Green

Func _QPDF_Html_Font_Orange($sPlainTextToConvert)
	Local $sHTMLString = '<font color="Orange">' & $sPlainTextToConvert & '</font>'
	Return $sHTMLString
EndFunc   ;==>_QPDF_Html_Font_Orange

Func _QPDF_Html_Font_Red($sPlainTextToConvert)
	Local $sHTMLString = '<font color="#FF0000">' & $sPlainTextToConvert & '</font>'
	Return $sHTMLString
EndFunc   ;==>_QPDF_Html_Font_Red

Func _QPDF_Html_Font_Size($sPlainTextToConvert, $iSize)
	Local $sHTMLString = '<font size="' & $iSize & '">' & $sPlainTextToConvert & '</font>'
	Return $sHTMLString
EndFunc   ;==>_QPDF_Html_Font_Size

Func _QPDF_Html_Font_Underline($sPlainTextToConvert)
	Local $sHTMLString = '<u>' & $sPlainTextToConvert & '</u>'
	Return $sHTMLString
EndFunc   ;==>_QPDF_Html_Font_Underline

Func _QPDF_Html_Font_Underline_Double($sPlainTextToConvert)
	Local $sHTMLString = '<u style="double">' & $sPlainTextToConvert & '</u>'
	Return $sHTMLString
EndFunc   ;==>_QPDF_Html_Font_Underline_Double

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_TextToHtml
; Description ...: Convert plain text to compatibile with QPDF html
; Syntax ........: _QPDF_TextToHtml($sPlainTextToConvert)
; Parameters ....: $sPlainTextToConvert               - a string value.
; Return values .: $sHTMLString
; Author ........: mLipok
; Modified ......:
; Remarks .......: Appendix A: Supported HTML tags  http://www.debenu.com/docs/pdf_library_reference/AppendixA.php
; Related .......: related to all HTML text function in QPDF
; Link ..........: http://www.debenu.com/docs/pdf_library_reference/HTMLText.php
; Example .......: No
; ===============================================================================================================================
Func _QPDF_TextToHtml($sPlainTextToConvert)
	Local $sHTMLString = StringRegExpReplace($sPlainTextToConvert, '\R', '<br>')
	Return SetError(@error, @extended, $sHTMLString)
EndFunc   ;==>_QPDF_TextToHtml
#EndRegion QuickPDF.au3 - HTML MiscFunction

#Region QuickPDF.au3 - Function for Matrix management
; #FUNCTION# ====================================================================================================================
; Name ..........: _Matrix_Create
; Description ...: Create Array for matrix functions
; Syntax ........: _Matrix_Create()
; Parameters ....: None
; Return values .: $aMatrixTable
; Author ........: mLipok
; Modified ......:
; Remarks .......: [$iSy, $iR1, $iR2, $iSy, $iTx, $iTy]
; Related .......:
; Link ..........: http://www.adobe.com/content/dam/Adobe/en/devnet/acrobat/pdfs/pdf_reference_1-7.pdf  look in page #205
; Example .......: No
; ===============================================================================================================================
Func _Matrix_Create()
	Local $aMatrixTable[6] = [1, 0, 0, 1, 0, 0]
	Return $aMatrixTable
EndFunc   ;==>_Matrix_Create

; #FUNCTION# ====================================================================================================================
; Name ..........: _Matrix_Move
; Description ...: Change Translation parameters ($iTx, $iTy) in $aMatrixTable
; Syntax ........: _Matrix_Move(Byref $aMatrixTable, $iTx, $iTy)
; Parameters ....: $aMatrixTable        - [in/out] an array of unknowns.
;                  $iTx                 - an integer value.
;                  $iTy                 - an integer value.
; Return values .: None
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........: http://www.adobe.com/content/dam/Adobe/en/devnet/acrobat/pdfs/pdf_reference_1-7.pdf  look in page #205
; Example .......: No
; ===============================================================================================================================
Func _Matrix_Move(ByRef $aMatrixTable, $iTx, $iTy)
	$aMatrixTable[0] *= 1 ; do not change
	$aMatrixTable[1] *= 1 ; do not change
	$aMatrixTable[2] *= 1 ; do not change
	$aMatrixTable[3] *= 1 ; do not change
	$aMatrixTable[4] = $iTx
	$aMatrixTable[5] = $iTy
EndFunc   ;==>_Matrix_Move

; #FUNCTION# ====================================================================================================================
; Name ..........: _Matrix_Rotate
; Description ...: Change Rotation parameters ($iAngle) in $aMatrixTable
; Syntax ........: _Matrix_Rotate(Byref $aMatrixTable, $iAngle[, $bAsDegree = True[, $bAppendMode = False]])
; Parameters ....: $aMatrixTable        - [in/out] an array of unknowns.
;                  $iAngle              - an integer value.
;                  $bAsDegree           - [optional] a boolean value. Default is True.
;                  $bAppendMode         - [optional] a boolean value. Default is False.
; Return values .: None
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........: http://www.adobe.com/content/dam/Adobe/en/devnet/acrobat/pdfs/pdf_reference_1-7.pdf  look in page #205
; Example .......: No
; ===============================================================================================================================
Func _Matrix_Rotate(ByRef $aMatrixTable, $iAngle, $bAsDegree = True, $bAppendMode = False)
	Local Const $PI = 3.141592653589793
	Local $iRadian = 0

	; conversion Degree to Radian
	If $bAsDegree Then
		; 1° = pi / 180 radians.
		; http://www.purplemath.com/modules/radians.htm
		$iRadian = ($iAngle * $PI) / 180
	Else
		$iRadian = $iAngle
	EndIf

	; Matrix changing
	If $bAppendMode Then
		$aMatrixTable[0] *= Cos($iRadian)
		$aMatrixTable[1] *= Sin($iRadian)
		$aMatrixTable[2] *= -Sin($iRadian)
		$aMatrixTable[3] *= Cos($iRadian)
	Else
		$aMatrixTable[0] = Cos($iRadian)
		$aMatrixTable[1] = Sin($iRadian)
		$aMatrixTable[2] = -Sin($iRadian)
		$aMatrixTable[3] = Cos($iRadian)
	EndIf
	$aMatrixTable[4] *= 1 ; do not change
	$aMatrixTable[5] *= 1 ; do not change

EndFunc   ;==>_Matrix_Rotate

; #FUNCTION# ====================================================================================================================
; Name ..........: _Matrix_Skew
; Description ...: set Skewing transformation parameters ($iAngleAlpha, $iAngleBetha) in $aMatrixTable
; Syntax ........: _Matrix_Skew(Byref $aMatrixTable, $iAngleAlpha, $iAngleBetha[, $bAsDegree = True[, $bAppendMode = False]])
; Parameters ....: $aMatrixTable        - [in/out] an array of unknowns.
;                  $iAngleAlpha         - an integer value.
;                  $iAngleBetha         - an integer value.
;                  $bAsDegree           - [optional] a boolean value. Default is True.
;                  $bAppendMode         - [optional] a boolean value. Default is False.
; Return values .: None
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........: http://www.adobe.com/content/dam/Adobe/en/devnet/acrobat/pdfs/pdf_reference_1-7.pdf  look in page #205
; Example .......: No
; ===============================================================================================================================
Func _Matrix_Skew(ByRef $aMatrixTable, $iAngleAlpha, $iAngleBetha, $bAsDegree = True, $bAppendMode = False)
	Local Const $PI = 3.141592653589793
	Local $iRadianAlpha = 0
	Local $iRadianBetha = 0

	; conversion Degree to Radian
	If $bAsDegree Then
		; 1° = pi / 180 radians.
		; http://www.purplemath.com/modules/radians.htm
		$iRadianAlpha = ($iAngleAlpha * $PI) / 180
		$iRadianBetha = ($iAngleBetha * $PI) / 180
	Else
		$iRadianAlpha = $iAngleAlpha
		$iRadianBetha = $iAngleBetha
	EndIf

	; Matrix changing
	$aMatrixTable[0] *= 1 ; do not change
	If $bAppendMode Then
		$aMatrixTable[1] *= Tan($iRadianAlpha)
		$aMatrixTable[2] *= Tan($iRadianBetha)
	Else
		$aMatrixTable[1] = Tan($iRadianAlpha)
		$aMatrixTable[2] = Tan($iRadianBetha)
	EndIf
	$aMatrixTable[3] *= 1 ; do not change
	$aMatrixTable[4] *= 1 ; do not change
	$aMatrixTable[5] *= 1 ; do not change

EndFunc   ;==>_Matrix_Skew

; #FUNCTION# ====================================================================================================================
; Name ..........: _Matrix_Zoom
; Description ...: set Scale transformation parameters ($iSx, $iSy) in $aMatrixTable
; Syntax ........: _Matrix_Zoom(Byref $aMatrixTable, $iSx, $iSy)
; Parameters ....: $aMatrixTable        - [in/out] an array of unknowns.
;                  $iSx                 - an integer value.
;                  $iSy                 - an integer value.
; Return values .: None
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........: http://www.adobe.com/content/dam/Adobe/en/devnet/acrobat/pdfs/pdf_reference_1-7.pdf  look in page #205
; Example .......: No
; ===============================================================================================================================
Func _Matrix_Zoom(ByRef $aMatrixTable, $iSx, $iSy)
	$aMatrixTable[0] = $iSx
	$aMatrixTable[1] *= 1 ; do not change
	$aMatrixTable[2] *= 1 ; do not change
	$aMatrixTable[3] = $iSy
	$aMatrixTable[4] *= 1 ; do not change
	$aMatrixTable[5] *= 1 ; do not change
EndFunc   ;==>_Matrix_Zoom
#EndRegion QuickPDF.au3 - Function for Matrix management

#Region QuickPDF.au3 - TODO
;~ @COM_EventObj

#CS

#CE

#CS
	; This part is only temporaly
	;	http://www.autoitscript.com/wiki/UDF-spec
	;	http://www.debenu.com/docs/pdf_library_reference/FunctionGroups.php
	;	http://www.debenu.com/products/development/debenu-pdf-library/help/developer-guide/

	C:\Windows\SysWOW64>regsvr32 "C:\Program Files\Debenu\PDF Library\ActiveX\DebenuPDFLibraryAX1114.dll"
	C:\Windows\SysWOW64>regsvr32 "c:\Program Files (x86)\Debenu\PDF Library\ActiveX\DebenuPDFLibrary64AX1114.dll"
	regsvr32 "DebenuPDFLibraryLite1114.dll"
	[HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\SharedDLLs]
	[HKEY_CLASSES_ROOT\CLSID\uuid\LocalServer32]
#CE

#CS
	http://www.debenu.com/kb/default-page-size-new-page/
	Unless page size is otherwise specified, new pages created using Debenu Quick PDF Library will correspond to the Letter standard size. Respectively, this corresponds to:

	612.0 x 792.0 pt
	8.50 x 11.0 in
	215.9 x 297.4 mm
	21.857 x 27.937 cm
#CE

;~  http://www.debenu.com/kb/replace-text-pdf/

#EndRegion QuickPDF.au3 - TODO

#Region QuickPDF.au3 - HELP / DOC / INFO
;~ http://www.w3schools.com/tags/ref_colornames.asp
;~ http://partners.adobe.com/public/developer/en/ps/5002.EPSF_Spec.pdf
;~ http://www.tcm.phy.cam.ac.uk/~mjr/eps.pdf
;~ http://paulbourke.net/dataformats/postscript/
;~ http://www.ps2pdf.com/convert.cgi

#CS
	;~ http://paulbourke.net/dataformats/postscript/
	Paper Size                      Dimension (in points)
	------------------              ---------------------
	Comm #10 Envelope               297 x 684
	C5 Envelope                     461 x 648
	DL Envelope                     312 x 624
	Folio                           595 x 935
	Executive                       522 x 756
	Letter                          612 x 792
	Legal                           612 x 1008
	Ledger                          1224 x 792
	Tabloid                         792 x 1224
	A0                              2384 x 3370
	A1                              1684 x 2384
	A2                              1191 x 1684
	A3                              842 x 1191
	A4                              595 x 842
	A5                              420 x 595
	A6                              297 x 420
	A7                              210 x 297
	A8                              148 x 210
	A9                              105 x 148
	B0                              2920 x 4127
	B1                              2064 x 2920
	B2                              1460 x 2064
	B3                              1032 x 1460
	B4                              729 x 1032
	B5                              516 x 729
	B6                              363 x 516
	B7                              258 x 363
	B8                              181 x 258
	B9                              127 x 181
	B10                             91 x 127
#CE
#EndRegion QuickPDF.au3 - HELP / DOC / INFO
