#Tidy_Parameters=/sort_funcs /reel
#AutoIt3Wrapper_Run_Debug_Mode=Y

#Region Include
#Tidy_Parameters=/reel
#include-once
#include "QuickPDF.au3"
#EndRegion Include

_QPDF_NewLibraryPath_Commercial(@ScriptDir & '\DebenuPDFLibraryCPAX1211.dll')
_QPDF_UseErrorHandler()

; SET YOUR LICENSE KEY in your main script using _QPDF_SetLicenseKey()
; If you not set $__sLicenseKey_QPDF then DebenuPDFLibraryLite1114.dll will be used (Lite version).
_QPDF_SetLicenseKey('ENTER YOUR KEY HERE')

; or just copy "c:\Program Files (x86)\Debenu\PDF Library\TRIAL_LICENSE_KEY.TXT" to @ScriptDir & '\TRIAL_LICENSE_KEY.TXT'
If FileExists(@ScriptDir & '\TRIAL_LICENSE_KEY.TXT') Then _QPDF_SetLicenseKey(FileRead(@ScriptDir & '\TRIAL_LICENSE_KEY.TXT'))

; I (mLipok) use MyLicenseKey.txt file to prevent accidentally placed my license key in a public forum.
If FileExists(@ScriptDir & '\MyLicenseKey.txt') Then _QPDF_SetLicenseKey(FileRead(@ScriptDir & '\MyLicenseKey.txt'))

_QPDF_Example_BarCodes(10, 10, 15, '*12345abcde*')

Func _QPDF_Example_BarCodes($iBarcodeLeft, $iBarcodeTop, $iBarcodeHeight, $sText)
	Local $sFileName = @ScriptDir & "\Example_BarCodes.pdf"
	Local $oQP
	If _QPDF_CreateObjectAndUnlock($oQP) = 1 Then
		; this is modified example from:
		; http://www.quickpdf.org/forum/draw-text-under-a-barcode_topic1725.html

		$oQP.SetOrigin($__eQPDF_SORIGIN_TopLeft);
		$oQP.SetMeasurementUnits($__eQPDF_MUNITS_Milimeters)
		; Add the Helvetica standard font
;~ 		$oQP.AddStandardFont(4);

		; Get the width of the barcode With a bar width of 0,1 mm
		Local $iBarcodeWidth = $oQP.GetBarcodeWidth(0.1, $sText, 1);

		; Draw the barcode
		$oQP.DrawBarcode($iBarcodeLeft, $iBarcodeTop, $iBarcodeWidth, $iBarcodeHeight, $sText, 1, 0);

		$oQP.SetTextSize(11);
		Local $iTextWidth = $oQP.GetTextWidth($sText)
		Local $iTextHeight = $oQP.GetTextHeight()
		$oQP.SetFillColor(1, 1, 1);
		; Draw White Box
		$oQP.DrawBox($iBarcodeLeft + ($iBarcodeWidth - $iTextWidth) / 2, $iBarcodeTop + $iBarcodeHeight - $iTextHeight, $iTextWidth, $iTextHeight, 1)

		; Center the text
		$oQP.SetTextAlign($__eQPDF_TEXTALIGN_Center);

		; Draw the text
		$oQP.SetTextSize(10);
		$oQP.DrawText($iBarcodeLeft + $iBarcodeWidth / 2, $iBarcodeTop + $iBarcodeHeight, $sText);

		; Save PDF to file
		$oQP.SaveToFile($sFileName)
		While _WinAPI_FileInUse($sFileName)
			Sleep(10)
		WEnd

		; Open PDF
		ShellExecuteWait($sFileName)

	EndIf
	$oQP = 0 ; CleanUp - destroy object
EndFunc   ;==>_QPDF_Example_BarCodes
