#Tidy_Parameters=/sort_funcs /reel
;~ #AutoIt3Wrapper_Run_Debug_Mode=Y

#Region Include
#Tidy_Parameters=/reel
#include-once
#include "QuickPDF.au3"
#EndRegion Include

_QPDF_NewLibraryPath_Commercial(@ScriptDir & '\DebenuPDFLibraryCPAX1211.dll')
_QPDF_UseErrorHandler()

; SET YOUR LICENSE KEY in your main script using _QPDF_SetLicenseKey()
; If you not set $__sLicenseKey_QPDF then DebenuPDFLibraryLite1114.dll will be used (Lite version).
_QPDF_SetLicenseKey('ENTER YOUR KEY HERE')

; I (mLipok) use MyLicenseKey.txt file to prevent accidentally placed my license key in a public forum.
If FileExists(@ScriptDir & '\MyLicenseKey.txt') Then _QPDF_SetLicenseKey(FileRead(@ScriptDir & '\MyLicenseKey.txt'))

_QPDF_DeveloperGuide_DrawStyledText()

Func _QPDF_DeveloperGuide_DrawStyledText()
	; this is an aexample from:
	; Debenu Quick PDF Library 10.14 Developer Guide.pdf
	; "Draw styled text"

	Local $oQP
	If _QPDF_CreateObjectAndUnlock($oQP) = 1 Then
		; Draw a variety of different text on a new document */
		; Set the origin for the drawing co-ordinates. In this case
		; we'll draw the co-ordinates from the top left corner of the page.
		$oQP.SetOrigin(1);
		; Draw normal text
		$oQP.DrawText(25, 25, "This text was drawn using the DrawText function.");
		; Draw an arc of text
		$oQP.DrawTextArc(150, 150, 100, 280, "This text was drawn using the DrawTextArc function.", 0);
		; Draw text wrapped to a specified width
		$oQP.DrawWrappedText(400, 50, 200, "This text was drawn using the DrawWrappedText function. As you can see, the text automatically wraps when it exceeds the specified width.");
		; Set the alignment of the text that we'll draw next
		$oQP.SetTextAlign(2);
		; Draw text in a text box. Specify width and height
		; of the text box.
		$oQP.DrawTextBox(350, 150, 200, 200, "This text was drawn using the DrawTextBox function.  Similar To the DrawText function except that the alignment can be specified.", 1);
		; Change the alignment
		$oQP.SetTextAlign(0);
		; Draw rotated text
		$oQP.DrawRotatedTextBox(300, 200, 200, 200, 90, "This text was drawn using the 	DrawRotatedTextBox function.", 1);
		; Draw text where each character has a space between it
		$oQP.DrawSpacedText(15, 300, 10, "This text was drawn using the DrawSpacedText function.");
		; Draw some more text
		$oQP.DrawText(25, 25, "This text was drawn using the DrawText function.");
		; Save the new file to the output folder
		$oQP.SaveToFile("Example_DrawStyledText.pdf");
	EndIf
	$oQP = 0 ; CleanUp - destroy object

	ShellExecute('Example_DrawStyledText.pdf')
EndFunc   ;==>_QPDF_DeveloperGuide_DrawStyledText


