#AutoIt3Wrapper_Au3Check_Parameters=-q -d -w 1 -w 2 -w 3 -w- 4 -w 5 -w 6 -w- 7
#Tidy_Parameters=/sort_funcs /reel
;~ #AutoIt3Wrapper_Run_Debug_Mode=Y

#Region Include
#include-once
#include "QuickPDF.au3"
#EndRegion Include

_QPDF_NewLibraryPath_Commercial(@ScriptDir & '\DebenuPDFLibraryCPAX1211.dll')
_QPDF_UseErrorHandler()

; SET YOUR LICENSE KEY in your main script using _QPDF_SetLicenseKey()
; If you not set $__sLicenseKey_QPDF then DebenuPDFLibraryLite1114.dll will be used (Lite version).
_QPDF_SetLicenseKey('ENTER YOUR KEY HERE')

; or just copy "c:\Program Files (x86)\Debenu\PDF Library\TRIAL_LICENSE_KEY.TXT" to @ScriptDir & '\TRIAL_LICENSE_KEY.TXT'
If FileExists(@ScriptDir & '\TRIAL_LICENSE_KEY.TXT') Then _QPDF_SetLicenseKey(FileRead(@ScriptDir & '\TRIAL_LICENSE_KEY.TXT'))

; I (mLipok) use MyLicenseKey.txt file to prevent accidentally placed my license key in a public forum.
If FileExists(@ScriptDir & '\MyLicenseKey.txt') Then _QPDF_SetLicenseKey(FileRead(@ScriptDir & '\MyLicenseKey.txt'))

_QPDF_Example_DrawHTMLTextMatrix('ABCDE')

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_DrawHTMLTextMatrix
; Description ...:
; Syntax ........: _QPDF_DrawHTMLTextMatrix($oQP, $sHTML_Text, $aMatrixTable)
; Parameters ....: $oQP                 - an object.
;                  $sHTML_Text          - a string value.
;                  $aMatrixTable        - an array of unknowns.
; Return values .: None
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _QPDF_DrawHTMLTextMatrix($oQP, $sHTML_Text, $aMatrixTable)
	$oQP.DrawHTMLTextMatrix(100, $sHTML_Text, _
			$aMatrixTable[0], _
			$aMatrixTable[1], _
			$aMatrixTable[2], _
			$aMatrixTable[3], _
			$aMatrixTable[4], _
			$aMatrixTable[5])
EndFunc   ;==>_QPDF_DrawHTMLTextMatrix

Func _QPDF_Example_DrawHTMLTextMatrix($sHTML_Text)
	Local $oQP
	If _QPDF_CreateObjectAndUnlock($oQP) = 1 Then
		Local $sFileName = @ScriptDir & "\Example_DrawHTMLTextMatrix.pdf"

		$oQP.SetOrigin($__eQPDF_SORIGIN_TopLeft);
		$oQP.SetMeasurementUnits($__eQPDF_MUNITS_Milimeters)
		$sHTML_Text = '<font size="20">' & $sHTML_Text & '</font>'
		Local $sHTML_Temp = $sHTML_Text

		; normal drawn HTML text
		$sHTML_Text = '1. ' & $sHTML_Temp
		$oQP.DrawHTMLText(20, 20, 100, $sHTML_Text)

		Local $aMatrixTable = _Matrix_Create()
		; HTML text drawn with
		; moved matrix
		$sHTML_Text = '2. ' & $sHTML_Temp
		_Matrix_Move($aMatrixTable, 20, 100)
		_QPDF_DrawHTMLTextMatrix($oQP, $sHTML_Text, $aMatrixTable)

		; HTML text drawn with
		; moved zoomed
		$aMatrixTable = _Matrix_Create()
		$sHTML_Text = '3. ' & $sHTML_Temp
		_Matrix_Move($aMatrixTable, 40, 200)
		_Matrix_Zoom($aMatrixTable, 1.5, 1.5)
		_QPDF_DrawHTMLTextMatrix($oQP, $sHTML_Text, $aMatrixTable)

		; HTML text drawn with
		; moved zoomed
		; Rotated 15°
		$aMatrixTable = _Matrix_Create()
		$sHTML_Text = '4. ' & $sHTML_Temp
		_Matrix_Move($aMatrixTable, 150, 300)
		_Matrix_Zoom($aMatrixTable, 2, 2)
		_Matrix_Rotate($aMatrixTable, 15)
		_QPDF_DrawHTMLTextMatrix($oQP, $sHTML_Text, $aMatrixTable)

		; HTML text drawn with
		; moved zoomed
		; Rotated 45°
		; Skewing 15° for X-axis and -35° for Y-axis
		$aMatrixTable = _Matrix_Create()
		$sHTML_Text = '5. ' & $sHTML_Temp
		_Matrix_Move($aMatrixTable, 150, 400)
		_Matrix_Zoom($aMatrixTable, 2, 2)
		_Matrix_Rotate($aMatrixTable, 45)
		_Matrix_Skew($aMatrixTable, 15, -35, True, True)
		_QPDF_DrawHTMLTextMatrix($oQP, $sHTML_Text, $aMatrixTable)

		; HTML text drawn with
		; moved zoomed
		; Skewing 0° for X-axis and 45° for Y-axis
		$aMatrixTable = _Matrix_Create()
		$sHTML_Text = '6. ' & $sHTML_Temp
		_Matrix_Move($aMatrixTable, 150, 550)
		_Matrix_Zoom($aMatrixTable, 2, 2)
		_Matrix_Skew($aMatrixTable, 0, 45)
		_QPDF_DrawHTMLTextMatrix($oQP, $sHTML_Text, $aMatrixTable)

		; Save PDF to file
		$oQP.SaveToFile($sFileName)
		While _WinAPI_FileInUse($sFileName)
			Sleep(10)
		WEnd

		; Open PDF
		ShellExecuteWait($sFileName)

	EndIf
	$oQP = 0 ; CleanUp - destroy object
EndFunc   ;==>_QPDF_Example_DrawHTMLTextMatrix
