#Tidy_Parameters=/sort_funcs /reel
;~ #AutoIt3Wrapper_Run_Debug_Mode=Y

#Region QuickPDF_Examples.au3 - Include
#include-once
#include "QuickPDF.au3"
#include <String.au3>
#include <FileConstants.au3>
#include <File.au3>
#EndRegion QuickPDF_Examples.au3 - Include

#Region QuickPDF_Examples.au3 - Main
_main()

Func _main()
	; using own COM Error Handling
	_QPDF_UseErrorHandler()

	_Examples_Lite_Collection()
	_Examples_Lite_Collection_For_Lelikkeo()
	_Examples_Lite_Collection_For_HTML()

	_QPDF_Shutdown() ; if in the following part of the script you want to open a commercial library then you need to close the lite version

	_Examples_Commercial_Collection()
EndFunc   ;==>_main
#EndRegion QuickPDF_Examples.au3 - Main

#Region QuickPDF_Examples.au3 - Examples Collections

Func _Examples_Commercial_Collection()
	; use new library DebenuPDFLibraryAX1114.dll
	_QPDF_NewLibraryPath_Commercial(@ScriptDir & '\DebenuPDFLibraryAX1115.dll')

	; SET YOUR LICENSE KEY in your main script using _QPDF_SetLicenseKey()
	; If you not set $__sLicenseKey_QPDF then DebenuPDFLibraryLite1114.dll will be used (Lite version).
	_QPDF_SetLicenseKey('ENTER YOUR KEY HERE')

	; or just copy "c:\Program Files (x86)\Debenu\PDF Library\TRIAL_LICENSE_KEY.TXT" to @ScriptDir & '\TRIAL_LICENSE_KEY.TXT'
	If FileExists(@ScriptDir & '\TRIAL_LICENSE_KEY.TXT') Then _QPDF_SetLicenseKey(FileRead(@ScriptDir & '\TRIAL_LICENSE_KEY.TXT'))

	; I (mLipok) use MyLicenseKey.txt file to prevent accidentally placed my license key in a public forum.
	If FileExists(@ScriptDir & '\MyLicenseKey.txt') Then _QPDF_SetLicenseKey(FileRead(@ScriptDir & '\MyLicenseKey.txt'))

	; All the following examples relate to the commercial or evaluation version of the library - you have to have a LICENSE KEY and use it by using _QPDF_SetLicenseKey('ENTER YOUR KEY HERE')
	If $__sLicenseKey_QPDF <> '' And $__sLicenseKey_QPDF <> 'ENTER YOUR KEY HERE' Then
		_QPDF_Example_Commercial_1_ExtractText(@ScriptDir & "\Example_HelloWorld.pdf", 7)
		_QPDF_Example_Commercial_2_TextAdvance()
		_QPDF_Example_Commercial_3_Table()
		_QPDF_Example_Commercial_4_A4toA5()
		_QPDF_Example_Commercial_5_PrintDefault()
		_QPDF_Example_Commercial_6_MergeFiles()
		_QPDF_Example_Commercial_7_BarCodes(10, 10, 15, '*12345abcde*')
		_QPDF_Example_Commercial_8_DrawStyledText__from__Debenu_Developer_Guide()
		_QPDF_Example_Commercial_9_EmbedFile()
	EndIf

EndFunc   ;==>_Examples_Commercial_Collection

Func _Examples_Lite_Collection()

	; Example for Lite version
	_QPDF_Example_Lite_1_HelloWorld()
	_QPDF_Example_Lite_2_OneBigExample()
;~ 	_QPDF_Example_Lite_3_TXTFile_to_PDFFile()

	; this following is not example but a Function in UDF - but it can be used as an example
	_QPDF_MergeFiles_Lite()

EndFunc   ;==>_Examples_Lite_Collection

Func _Examples_Lite_Collection_For_HTML()

	#CS
		http://www.debenu.com/products/development/debenu-pdf-library-lite/updates/

		Release history
		Debenu Quick PDF Library Lite 11.14

		April 22, 2015
		What’s New

		New DeletePages function for deleting pages in a PDF
		New DrawHTMLText function for drawing HTML text on a page
		New DrawHTMLTextBox function drawing HTML text in a rectangular area
		New ExtractPages function for extract pages from a PDF
		New GetPageImageList function for getting a list of embedded images
		New GetImageListCount function for counting number of images in image list
		New GetImageListItemFormatDesc function for getting an image format description
		New PageHasFontResources function for checking if a page has any font resources
		Performance improvements
		Bug fixes


		REMARKS:
		See Appendix A for details of the supported HTML tags.
		http://www.debenu.com/docs/pdf_library_reference/AppendixA.php

	#CE

	_QPDF_UseErrorHandler()
	Local $oQP

	If _QPDF_CreateObjectAndUnlock($oQP) = 2 Then

		; Set the origin for the drawing co-ordinates. In this case we'll draw the co-ordinates from the top left corner of the page.
		; http://www.debenu.com/docs/pdf_library_reference/SetOrigin.php
		$oQP.SetOrigin($__eQPDF_SORIGIN_TopLeft);

		; http://www.debenu.com/docs/pdf_library_reference/SetMeasurementUnits.php
		$oQP.SetMeasurementUnits($__eQPDF_MUNITS_Milimeters)

		; Set Page Size to A3 Default Page orientation
		; http://www.debenu.com/docs/pdf_library_reference/SetPageSize.php
		$oQP.SetPageSize('A4')

		; http://www.debenu.com/docs/pdf_library_reference/SetTextSize.php
		$oQP.SetTextSize(10);

		Local $sTextToDrawn = 'This is first line of HTML Text' & @CRLF & 'This is second line of HTML Text'
		$sTextToDrawn = _QPDF_TextToHtml($sTextToDrawn)

		; Draws HTML text onto the page
		; http://www.debenu.com/docs/pdf_library_reference/DrawHTMLText.php
		$oQP.DrawHTMLText(20, 10, 100, $sTextToDrawn);

		; DrawHTMLTextBox
		; http://www.debenu.com/docs/pdf_library_reference/DrawHTMLTextBox.php
		$oQP.DrawHTMLText(20, 10, 100, 40, $sTextToDrawn);

		; http://www.debenu.com/docs/pdf_library_reference/SaveToFile.php
		$oQP.SaveToFile(@ScriptDir & '\QuickPDF_Lite_Exmaple_for_HTML.pdf');

		ShellExecute(@ScriptDir & '\QuickPDF_Lite_Exmaple_for_HTML.pdf')

	EndIf

EndFunc   ;==>_Examples_Lite_Collection_For_HTML

Func _Examples_Lite_Collection_For_Lelikkeo()

	#cs
		AuotIt member Lelikkeo ask for help:

		Help me please make a simple example using free library (Lite) and features:
		- create pdf file formats A4, A3, A2, A1, A0.
		- the change in the orientation of the sheet.
		- text entry indicating the size and the coordinate of the location of the text on the sheet.
		- drawing lines indicating the start and end of the line.
		- merge multiple pdf files into one.

		Request Link
		http://www.autoitscript.com/forum/topic/160875-debenu-quick-pdf-library-udf/page-2#entry1240977
	#ce

	_QPDF_UseErrorHandler()
	Local $oQP

	If _QPDF_CreateObjectAndUnlock($oQP) = 2 Then

		; Set the origin for the drawing co-ordinates. In this case we'll draw the co-ordinates from the top left corner of the page.
		; http://www.debenu.com/docs/pdf_library_reference/SetOrigin.php
		$oQP.SetOrigin($__eQPDF_SORIGIN_TopLeft);

		; http://www.debenu.com/docs/pdf_library_reference/SetMeasurementUnits.php
		$oQP.SetMeasurementUnits($__eQPDF_MUNITS_Milimeters)

		; Set Page Size to A3 with Landscape
		; http://www.debenu.com/docs/pdf_library_reference/SetPageSize.php
		$oQP.SetPageSize('A3 Landscape')

		; Set Page Size to A3 Default Page orientation
		; http://www.debenu.com/docs/pdf_library_reference/SetPageSize.php
		$oQP.SetPageSize('A4')

		; http://www.debenu.com/docs/pdf_library_reference/SetTextSize.php
		$oQP.SetTextSize(10);

		; Draw normal text
		; http://www.debenu.com/docs/pdf_library_reference/DrawText.php
		$oQP.DrawText(25, 25, "This is example for Lelikkeo Request");

		#cs
			Unfortunately SetLineWidth and  DrawLine  are not available in Lite version

			; http://www.debenu.com/docs/pdf_library_reference/SetLineWidth.php
			$oQP.SetLineWidth(1)

			; drawing lines indicating the start and end of the line.
			; http://www.debenu.com/docs/pdf_library_reference/DrawLine.php
			$oQP.DrawLine(20,50,200,80);
		#ce

		; http://www.debenu.com/docs/pdf_library_reference/SetTextSize.php
		$oQP.SetTextSize(10);

		; a work around for drawing simple lines in LiteVersion
		; http://www.debenu.com/docs/pdf_library_reference/DrawTextBox.php
		$oQP.SetTextUnderline(1)
		$oQP.DrawText(20, 50, _StringRepeat(Chr(160), 250))

		$oQP.SetTextUnderline(2)
		$oQP.DrawText(20, 70, _StringRepeat(Chr(160), 100))

		; http://www.debenu.com/docs/pdf_library_reference/SaveToFile.php
		$oQP.SaveToFile(@ScriptDir & '\QuickPDF_Lelikkeo_Exmaple.pdf');

		ShellExecute(@ScriptDir & '\QuickPDF_Lelikkeo_Exmaple.pdf')

		; this following is not example but a Function in UDF - but it can be used as an example
		_QPDF_MergeFiles_Lite()

	EndIf

EndFunc   ;==>_Examples_Lite_Collection_For_Lelikkeo
#EndRegion QuickPDF_Examples.au3 - Examples Collections

#Region QuickPDF_Examples.au3 - Examples

Func _QPDF_Example_Commercial_1_ExtractText($sPDF_FileFullPath, $sPDFPassword = '', $iExtractOptions = 0)
	; This example can be used only in the commercial version of the library.
	Local $sPDF_TXTContents = _QPDF_ExtractTextFromFile($sPDF_FileFullPath, $sPDFPassword, $iExtractOptions)
	Local $sTXT_FileFullPath = StringReplace($sPDF_FileFullPath, '.pdf', '.txt')
	ClipPut($sPDF_TXTContents)
	FileDelete($sTXT_FileFullPath)
	FileWrite($sTXT_FileFullPath, $sPDF_TXTContents)
	ShellExecute($sTXT_FileFullPath)
EndFunc   ;==>_QPDF_Example_Commercial_1_ExtractText

Func _QPDF_Example_Commercial_2_TextAdvance()
	; This example can be used only in the commercial version of the library.
	Local $sFileName = @ScriptDir & "\_QPDF_Example_Commercial_2_TextAdvance.pdf"
	Local $oQP
	If _QPDF_CreateObjectAndUnlock($oQP) = 1 Then
		$oQP.SetOrigin($__eQPDF_SORIGIN_TopLeft);
		$oQP.SetMeasurementUnits($__eQPDF_MUNITS_Milimeters)
		$oQP.AddPageLabels(1, 1, 10, '_QPDF_Example_Commercial_2_TextAdvance()')
		$oQP.AddStampAnnotation(0, 0, 210, 10, 1, 'Test Title', 'Test Contents', 0, 1.5, 0, 0)

		$oQP.SetTextSize(25);
		$oQP.DrawWrappedText(10, 150, 100, 'This Text will be wrapped to 100 milimeters')

		FileDelete($sFileName)
		If $oQP.SaveToFile($sFileName) = 1 Then
			While _WinAPI_FileInUse($sFileName)
				Sleep(10)
			WEnd
			ShellExecuteWait($sFileName)
		Else
			MsgBox($MB_SYSTEMMODAL, "Error", "File " & $sFileName & " could not be saved.")
		EndIf
	EndIf

	$oQP = 0 ; CleanUp - destroy object
EndFunc   ;==>_QPDF_Example_Commercial_2_TextAdvance

Func _QPDF_Example_Commercial_3_Table()
	; This example can be used only in the commercial version of the library.
	Local $oQP
	If _QPDF_CreateObjectAndUnlock($oQP) = 1 Then
		Local $sFileName = @ScriptDir & "\Example_Table.pdf"
		$oQP.SetOrigin($__eQPDF_SORIGIN_TopLeft);
		$oQP.SetMeasurementUnits($__eQPDF_MUNITS_Milimeters)
		$oQP.SetTextSize(10);

		Local $aTable[5][4] = _
				[ _
				['#', 'Singature', 'Name', 'Location'], _
				['1', '12345', 'This is name #1', 'Location #1'], _
				['2', '23456', 'This is name #2', 'Location #2'], _
				['3', '34567', 'This is name #3', 'Location #3'], _
				['4', '45678', 'This is name #4', 'Location #4'] _
				]

		; create table and setting all parameters
		Local $iTableID = $oQP.CreateTable(5, 4); 5 rows 4 columns
		$oQP.SetTableColumnWidth($iTableID, 1, 1, 10);
		$oQP.SetTableColumnWidth($iTableID, 2, 2, 30);
		$oQP.SetTableColumnWidth($iTableID, 3, 4, 70);
		$oQP.SetTableRowHeight($iTableID, 1, 5, 0);
		$oQP.SetTableCellPadding($iTableID, 1, 1, 5, 4, $__eQPDF_BORDERINDEX_All, 1);
		$oQP.SetTableCellBackgroundColor($iTableID, 1, 1, 1, 4, 3, 10, 0);
		$oQP.SetTableCellBackgroundColor($iTableID, 2, 1, 5, 4, 0, 10, 3);
		$oQP.SetTableCellBorderColor($iTableID, 1, 1, 5, 4, 0, 1, 0, 2);
		$oQP.SetTableCellBorderWidth($iTableID, 1, 1, 5, 4, $__eQPDF_BORDERINDEX_Top, 0.1);
		$oQP.SetTableCellBorderWidth($iTableID, 1, 1, 5, 4, $__eQPDF_BORDERINDEX_Left, 0.1);
		$oQP.SetTableCellBorderWidth($iTableID, 1, 4, 5, 4, $__eQPDF_BORDERINDEX_Right, 0.1);
		$oQP.SetTableCellBorderWidth($iTableID, 5, 4, 5, 4, $__eQPDF_BORDERINDEX_Bottom, 0.1);
		$oQP.SetTableCellAlignment($iTableID, 1, 1, 5, 1, $__eQPDF_CELLALIGNMENT_MiddleCenter);
		$oQP.SetTableCellTextSize($iTableID, 1, 1, 5, 1, 20);

		; fill a table with the contents of an array variable
		; used the $ sSufix is to show how changes in a table format, in the case of variable-length text inserted into the table.
		Local $sSufix = ''
		For $iRow = 0 To UBound($aTable, 1) - 1
			For $iCol = 0 To UBound($aTable, 2) - 1
				If $iCol > 1 And $iRow > 0 Then
					$sSufix = ' ' & _StringRepeat('<br>' & $aTable[$iRow][1], $iRow)
				Else
					$sSufix = ''
				EndIf
				$oQP.SetTableCellContent($iTableID, $iRow + 1, $iCol + 1, $aTable[$iRow][$iCol] & $sSufix)
			Next
		Next

		; finally draw the entire table in the document
		$oQP.DrawTableRows($iTableID, 20, 10, 200, 1, 0)

		; save created document to a PDF file
		If $oQP.SaveToFile($sFileName) = 1 Then
			While _WinAPI_FileInUse($sFileName)
				Sleep(10)
			WEnd
			ShellExecuteWait($sFileName)
		Else
			MsgBox($MB_SYSTEMMODAL, "Error", "File " & $sFileName & " could not be saved.")
		EndIf
	EndIf

	$oQP = 0 ; CleanUp - destroy object
EndFunc   ;==>_QPDF_Example_Commercial_3_Table

Func _QPDF_Example_Commercial_4_A4toA5()
	; This example can be used only in the commercial version of the library.
	Local $oQP
	If _QPDF_CreateObjectAndUnlock($oQP) = 1 Then
		Local $sA4_PDFFileFullPath = @ScriptDir & "\A4Format.pdf"
		Local $sA5_UpperAndBottom = @ScriptDir & "\A5Format.pdf"
		Local $sA5_Upper = @ScriptDir & "\A5Format_UPPER.pdf"
		Local $sA5_Bottom = @ScriptDir & "\A5Format_BOTTOM.pdf"

		; Here I create a test PDF
		$oQP.SetPageSize('A4')
		$oQP.SetOrigin($__eQPDF_SORIGIN_TopLeft);
		$oQP.SetMeasurementUnits($__eQPDF_MUNITS_Milimeters)
		$oQP.SetTextSize(10);
		Local $iTableID = $oQP.CreateTable(2, 1);
		$oQP.SetTableColumnWidth($iTableID, 1, 1, $__eQPDF_A4_WidthInMM);
		$oQP.SetTableRowHeight($iTableID, 1, 2, $__eQPDF_A4_HeightInMM / 2);
		$oQP.SetTableCellBorderColor($iTableID, 1, 1, 2, 1, 0, 1, 0, 2);
		$oQP.SetTableCellBorderWidth($iTableID, 1, 1, 2, 1, $__eQPDF_BORDERINDEX_All, 0.1);
		$oQP.SetTableCellTextSize($iTableID, 1, 1, 2, 1, 100); SetTableCellTextSize(TableID As Long, FirstRow As Long, FirstColumn As Long, LastRow As Long, LastColumn As Long,NewTextSize As Double) As Long
		$oQP.SetTableCellAlignment($iTableID, 1, 1, 2, 1, $__eQPDF_CELLALIGNMENT_MiddleCenter);
		$oQP.SetTableCellContent($iTableID, 1, 1, 'TOP')
		$oQP.SetTableCellContent($iTableID, 2, 1, 'BOTTOM')
		$oQP.DrawTableRows($iTableID, 0, 0, $__eQPDF_A4_HeightInMM, 1, 2)
		FileDelete($sA4_PDFFileFullPath)
		$oQP.SaveToFile($sA4_PDFFileFullPath);
		While _WinAPI_FileInUse($sA4_PDFFileFullPath)
			Sleep(10)
		WEnd
		$oQP = 0 ; CleanUp - destroy object

		; Here this PDF will be splitted horizontally to A5 format
		_QPDF_A4toA5($sA4_PDFFileFullPath, '', $sA5_Upper, $sA5_Bottom)

		FileDelete($sA5_Upper & '.txt')
		FileWrite($sA5_Upper & '.txt', _QPDF_ExtractTextFromFile($sA5_Upper))
		FileDelete($sA5_Bottom & '.txt')
		FileWrite($sA5_Bottom & '.txt', _QPDF_ExtractTextFromFile($sA5_Bottom))

		ShellExecute($sA5_Upper)
		ShellExecuteWait($sA5_Upper & '.txt')

		ShellExecute($sA5_Bottom)
		ShellExecuteWait($sA5_Bottom & '.txt')
	EndIf

EndFunc   ;==>_QPDF_Example_Commercial_4_A4toA5

Func _QPDF_Example_Commercial_5_PrintDefault()
	; This example can be used only in the commercial version of the library.
	Local $sFileName = @ScriptDir & "\Example_HelloWorld.pdf"
	Local $oQP
	If _QPDF_CreateObjectAndUnlock($oQP) = 1 Then
		$oQP.LoadFromFile($sFileName, '');
		_QPDF_LastErrorCode($oQP)

		$sCustomPrinter = $oQP.NewCustomPrinter($oQP.GetDefaultPrinterName());
		_QPDF_LastErrorCode($oQP)

		; setting Horizontal Duplex
		$oQP.SetupCustomPrinter($sCustomPrinter, 7, 3);
		_QPDF_LastErrorCode($oQP)

		$iPrintOptions = $oQP.PrintOptions(0, 0, "Printing Sample 1")
		_QPDF_LastErrorCode($oQP)
		$oQP.PrintDocument($sCustomPrinter, 1, 1, $iPrintOptions);
		_QPDF_LastErrorCode($oQP)

;~ 		$iPrintOptions = $oQP.PrintOptions(0, 0, "Printing Sample 2")
;~ 		$oQP.PrintDocument($sCustomPrinter, 1, 1, $iPrintOptions);
	EndIf

	$oQP = 0 ; CleanUp - destroy object
EndFunc   ;==>_QPDF_Example_Commercial_5_PrintDefault

Func _QPDF_Example_Commercial_6_MergeFiles()
	; Combine a list of PDFs together quickly
	; Add a range of files to a list.

	Local $sFileName = @ScriptDir & "\Example_MergedFileList.pdf"
	; select folder
	$sFolderWithPDFFiles = FileSelectFolder('Select Folder with PDF Files to Merge', "", 2 + 4)
	If Not @error Then
		Local $oQP
		If _QPDF_CreateObjectAndUnlock($oQP) = 1 Then
			; make an array with PDF File List
			Local $aPDFFileList = _FileListToArray($sFolderWithPDFFiles, '*.pdf', 1, True)

			; add each PDF file from the Array to the QP File List
			For $iPDFFileID = 1 To $aPDFFileList[0]
				$oQP.AddToFileList("FilesToMerge", $aPDFFileList[$iPDFFileID]);
				_QPDF_LastErrorCode($oQP)
			Next

			; Merge the list of files together.
			$oQP.MergeFileList("FilesToMerge", $sFileName)
;~ 			ConsoleWrite('! ' & $oQP.LastErrorCode() & @CRLF)
			_QPDF_LastErrorCode($oQP)
			; wait for complete save
			While _WinAPI_FileInUse($sFileName)
				Sleep(10)
			WEnd

			; Open PDF
			ShellExecuteWait($sFileName)
		EndIf
	EndIf

	$oQP = 0 ; CleanUp - destroy object
EndFunc   ;==>_QPDF_Example_Commercial_6_MergeFiles

Func _QPDF_Example_Commercial_7_BarCodes($iBarcodeLeft, $iBarcodeTop, $iBarcodeHeight, $sText)
	Local $sFileName = @ScriptDir & "\Example_BarCodes.pdf"
	Local $oQP
	If _QPDF_CreateObjectAndUnlock($oQP) = 1 Then
		; this is modified example from:
		; http://www.quickpdf.org/forum/draw-text-under-a-barcode_topic1725.html

		$oQP.SetOrigin($__eQPDF_SORIGIN_TopLeft);
		$oQP.SetMeasurementUnits($__eQPDF_MUNITS_Milimeters)
		; Add the Helvetica standard font
;~ 		$oQP.AddStandardFont(4);

		; Get the width of the barcode With a bar width of 0,1 mm
		Local $iBarcodeWidth = $oQP.GetBarcodeWidth(0.1, $sText, 1);

		; Draw the barcode
		$oQP.DrawBarcode($iBarcodeLeft, $iBarcodeTop, $iBarcodeWidth, $iBarcodeHeight, $sText, 1, 0);

		$oQP.SetTextSize(11);
		Local $iTextWidth = $oQP.GetTextWidth($sText)
		Local $iTextHeight = $oQP.GetTextHeight()
		$oQP.SetFillColor(1, 1, 1);
		; Draw White Box
		$oQP.DrawBox($iBarcodeLeft + ($iBarcodeWidth - $iTextWidth) / 2, $iBarcodeTop + $iBarcodeHeight - $iTextHeight, $iTextWidth, $iTextHeight, 1)

		; Center the text
		$oQP.SetTextAlign($__eQPDF_TEXTALIGN_Center);

		; Draw the text
		$oQP.SetTextSize(10);
		$oQP.DrawText($iBarcodeLeft + $iBarcodeWidth / 2, $iBarcodeTop + $iBarcodeHeight, $sText);

		; Save PDF to file
		$oQP.SaveToFile($sFileName)
		While _WinAPI_FileInUse($sFileName)
			Sleep(10)
		WEnd

		; Open PDF
		ShellExecuteWait($sFileName)

	EndIf
	$oQP = 0 ; CleanUp - destroy object
EndFunc   ;==>_QPDF_Example_Commercial_7_BarCodes

Func _QPDF_Example_Commercial_8_DrawStyledText__from__Debenu_Developer_Guide()

	Local $oQP
	If _QPDF_CreateObjectAndUnlock($oQP) = 1 Then

		; ================================================
		; this is an example from:
		; Debenu Quick PDF Library 10.14 Developer Guide.pdf
		; "Draw styled text"
		; Draw a variety of different text on a new document

		; Set the origin for the drawing co-ordinates. In this case we'll draw the co-ordinates from the top left corner of the page.
		$oQP.SetOrigin($__eQPDF_SORIGIN_TopLeft);
		; Draw normal text
		$oQP.DrawText(25, 25, "This text was drawn using the DrawText function.");
		; Draw an arc of text
		$oQP.DrawTextArc(150, 150, 100, 280, "This text was drawn using the DrawTextArc function.", 0);
		; Draw text wrapped to a specified width
		$oQP.DrawWrappedText(400, 50, 200, "This text was drawn using the DrawWrappedText function. As you can see, the text automatically wraps when it exceeds the specified width.");
		; Set the alignment of the text that we'll draw next
		$oQP.SetTextAlign($__eQPDF_TEXTALIGN_Right);
		; Draw text in a text box. Specify width and height of the text box.
		$oQP.DrawTextBox(350, 150, 200, 200, "This text was drawn using the DrawTextBox function.  Similar To the DrawText function except that the alignment can be specified.", 1);
		; Change the alignment
		$oQP.SetTextAlign($__eQPDF_TEXTALIGN_Left);
		; Draw rotated text
		$oQP.DrawRotatedTextBox(300, 200, 200, 200, 90, "This text was drawn using the 	DrawRotatedTextBox function.", 1);
		; Draw text where each character has a space between it
		$oQP.DrawSpacedText(15, 300, 10, "This text was drawn using the DrawSpacedText function.");
		; Draw some more text
		$oQP.DrawText(25, 25, "This text was drawn using the DrawText function.");
		; Save the new file to the output folder
		$oQP.SaveToFile("Example_DrawStyledText.pdf");
		; ================================================

		ShellExecuteWait("Example_DrawStyledText.pdf")
	EndIf
	$oQP = 0 ; CleanUp - destroy object
EndFunc   ;==>_QPDF_Example_Commercial_8_DrawStyledText__from__Debenu_Developer_Guide

Func _QPDF_Example_Commercial_9_EmbedFile()
	; This example can be used only in the commercial version of the library.
	Local $sFileName = @ScriptDir & "\_QPDF_Example_EmbedFile.pdf"
	Local $oQP
	Local $iObjCreateResult = _QPDF_CreateObjectAndUnlock($oQP)
	If $iObjCreateResult = 1 Then
		$oQP.SetOrigin($__eQPDF_SORIGIN_TopLeft);
		$oQP.SetMeasurementUnits($__eQPDF_MUNITS_Milimeters)
;~ 		$oQP.AddPageLabels(1, 1, 10, '_QPDF_Example_TextAdvance()')
;~ 		$oQP.AddStampAnnotation(0, 0, 210, 10, 1, 'Test Title', 'Test Contents', 0, 1.5, 0, 0)

		$oQP.SetTextSize(25);
		$oQP.DrawWrappedText(10, 10, 100, 'This is example PDF with Embededed File')
		$oQP.EmbedFile('Script', @ScriptFullPath, '')
		Local $i_EmbeddedFileID = $oQP.GetEmbeddedFileID(1)
		$oQP.AddLinkToEmbeddedFile(10, 30, 2, 5, $i_EmbeddedFileID, 'TITLE', 'Contents', 1, 50)

		FileDelete($sFileName)
		If $oQP.SaveToFile($sFileName) = 1 Then
			While _WinAPI_FileInUse($sFileName)
				Sleep(10)
			WEnd
			ShellExecuteWait($sFileName)
		Else
			MsgBox($MB_SYSTEMMODAL, "Error", "File " & $sFileName & " could not be saved.")
		EndIf
	Else
		MsgBox(0, 'Error', _QPDF_UDF_ErrorDescription(@error, @extended))
		Return SetError(@error, @extended, '')
	EndIf

	$oQP = 0 ; CleanUp - destroy object
EndFunc   ;==>_QPDF_Example_Commercial_9_EmbedFile

Func _QPDF_Example_Lite_1_HelloWorld()
	; This example can be used both in the Lite version as well as a commercial version of the library.
	Local $sFileName = @ScriptDir & "\Example_HelloWorld.pdf"
	Local $oQP
	Local $iObjCreateResult = _QPDF_CreateObjectAndUnlock($oQP)
	If $iObjCreateResult = 1 Or $iObjCreateResult = 2 Then
		$oQP.SetOrigin($__eQPDF_SORIGIN_TopLeft);
		$oQP.SetMeasurementUnits($__eQPDF_MUNITS_Milimeters)

;~ 		$oQP.SetTextSize(5);
;~ 		$oQP.DrawText(0, 20, "Hello world from AutoIt (Line 1)")

;~ 		$oQP.SetTextSize(10);
;~ 		$oQP.DrawText(5, 30, "Hello world from AutoIt (Line 2)")

;~ 		$oQP.SetTextSize(20);
;~ 		$oQP.SetTextColor(0, 0.5, 1);
;~ 		$oQP.DrawText(10, 45, "Hello world from AutoIt (Line 3)")

		$oQP.SetTextSize(10);
		$oQP.DrawText(10, 120, "Hello world from AutoIt (Line -------1)")

		$oQP.SetTextSize(10);
		$oQP.DrawText(20, 140, "Hello world from AutoIt (Line 2)")

		$oQP.SetTextSize(10);
		$oQP.SetTextColor(0, 0.5, 1);
		$oQP.DrawText(30, 160, "Hello world from AutoIt (Line 3)")

		FileDelete($sFileName)
		If $oQP.SaveToFile($sFileName) = 1 Then
			While _WinAPI_FileInUse($sFileName)
				Sleep(10)
			WEnd
			ShellExecuteWait($sFileName)
		Else
			MsgBox($MB_SYSTEMMODAL, "Error", "File " & $sFileName & " could not be saved.")
		EndIf
	Else
		MsgBox(0, 'Error', _QPDF_UDF_ErrorDescription(@error, @extended))
		Return SetError(@error, @extended, '')
	EndIf

	$oQP = 0 ; CleanUp - destroy object
EndFunc   ;==>_QPDF_Example_Lite_1_HelloWorld

Func _QPDF_Example_Lite_2_OneBigExample()
	; This example can be used both in the Lite version as well as a commercial version of the library.
	Local $sPDF_FileFullPath = @ScriptDir & '\Example_Lite_OneBigExample.pdf'
	Local $oQP

	Local $iObjCreateResult = _QPDF_CreateObjectAndUnlock($oQP)
	If $iObjCreateResult = 1 Or $iObjCreateResult = 2 Then
		; Page Setup
		_QPDF_SetOrigin_Lite($oQP)
		_QPDF_SetMeasurementUnits_Lite($oQP)

		; Draw first line
		_QPDF_DrawText_Lite($oQP, 15, 20, "Hello from AutoIt " & @AutoItVersion)

		; Draw second line with changed atribute
		_QPDF_SetTextSize_Lite($oQP, 20)
		_QPDF_SetTextUnderline_Lite($oQP, $__eQPDF_TEXTUNDERLINE_Double)
		_QPDF_DrawText_Lite($oQP, 15, 30, "Second line")

		; set Text color Red = 100%
		_QPDF_SetTextColor_Lite($oQP, 1, 0, 0)

		; Draw third line with changed atribute
		_QPDF_SetTextAlign_Lite($oQP, $__eQPDF_TEXTALIGN_Justified)
		_QPDF_AddStandardFont_Lite($oQP, $__eQPDF_StandardFontID_CourierOblique)
		_QPDF_SelectFont_Lite($oQP, $__eQPDF_StandardFontID_CourierOblique)
		_QPDF_DrawText_Lite($oQP, 15, 45, "Third Line")

		; set Text color Blue = 100%
		_QPDF_SetTextColor_Lite($oQP, 0, 0, 1)
		_QPDF_SetTextUnderline_Lite($oQP, $__eQPDF_TEXTUNDERLINE_Single)

		; Add a URL Link
		_QPDF_AddLinkToWeb_Lite($oQP, 15, 65, 100, 20, 'http://www.autoitscript.com/forum/')
		_QPDF_DrawText_Lite($oQP, 25, 75, 'http://www.autoitscript.com/forum/')

		; Add a @mail adress Link
		_QPDF_AddLinkToWeb_Lite($oQP, 15, 85, 100, 20, 'mailto:info@example.com', 1)
		_QPDF_DrawText_Lite($oQP, 40, 95, 'mailto:info@example.com')

		; add new Page - second
		_QPDF_NewPage_Lite($oQP)
		_QPDF_SetTextSize_Lite($oQP, 40)
		_QPDF_DrawText_Lite($oQP, 15, 30, "New (second) page.")

		; add new Page - third
		_QPDF_NewPage_Lite($oQP)
		_QPDF_SetPageSize_Lite($oQP, 'A5 Landscape')
		_QPDF_SetOrigin_Lite($oQP)
		_QPDF_SetTextSize_Lite($oQP, 50)
		_QPDF_DrawText_Lite($oQP, 15, 30, "New (third) page.")
		_QPDF_SetTextSize_Lite($oQP, 40)
		_QPDF_DrawText_Lite($oQP, 15, 50, "Format A5 Landscape")

		; sets the Initial Page Layout i Mode
		_QPDF_SetPageLayout_Lite($oQP, $__eQPDF_PAGELAYOUT_TwoPages_Left)
		_QPDF_SetPageMode_Lite($oQP, $__eQPDF_PAGEMODE_FullScreenMode)

		; save to PDF file
		If FileExists($sPDF_FileFullPath) Then FileDelete($sPDF_FileFullPath)
		_QPDF_SaveToFile_Lite($oQP, $sPDF_FileFullPath)

		$oQP = 0 ; CleanUp - destroy object
		ShellExecute($sPDF_FileFullPath)
	Else
		MsgBox(0, 'Error', _QPDF_UDF_ErrorDescription(@error, @extended))
		Return SetError(@error, @extended, '')
	EndIf

EndFunc   ;==>_QPDF_Example_Lite_2_OneBigExample

Func _QPDF_Example_Lite_3_TXTFile_to_PDFFile()
	_QPDF_TXTFile_to_PDFFile(@ScriptFullPath, StringReplace(@ScriptFullPath, '.au3', '.pdf'))
EndFunc   ;==>_QPDF_Example_Lite_3_TXTFile_to_PDFFile
#EndRegion QuickPDF_Examples.au3 - Examples
