;~ (?i)Function DebenuPDFLibrary1015.PDFLibrary::(\S+....)
;~ #AutoIt3Wrapper_Run_Debug_Mode=Y
#Tidy_Parameters=/sort_funcs /reel
#include-once
#include <File.au3>
#include "QuickPdf.au3"

_QPDF_NewLibraryPath_Commercial(@ScriptDir & '\DebenuPDFLibraryCPAX1211.dll')
;~ _QPDF_NewLibraryPath_Commercial(@ScriptDir & '\DebenuPDFLibraryAX1211.dll')
_QPDF_UseErrorHandler()

; SET YOUR LICENSE KEY in your main script using _QPDF_SetLicenseKey()
; If you not set $__sLicenseKey_QPDF then DebenuPDFLibraryLite1114.dll will be used (Lite version).
_QPDF_SetLicenseKey('ENTER YOUR KEY HERE')

; or just copy "c:\Program Files (x86)\Debenu\PDF Library\TRIAL_LICENSE_KEY.TXT" to @ScriptDir & '\TRIAL_LICENSE_KEY.TXT'
If FileExists(@ScriptDir & '\TRIAL_LICENSE_KEY.TXT') Then _QPDF_SetLicenseKey(FileRead(@ScriptDir & '\TRIAL_LICENSE_KEY.TXT'))

; I (mLipok) use MyLicenseKey.txt file to prevent accidentally placed my license key in a public forum.
If FileExists(@ScriptDir & '\MyLicenseKey.txt') Then _QPDF_SetLicenseKey(FileRead(@ScriptDir & '\MyLicenseKey.txt'))

_Example()

#Region Functions


Func _Example()
	Local $oQP

	Local $oQP
	If _QPDF_CreateObjectAndUnlock($oQP) = 1 Then
		; Create four new optional content groups
		$iOCG1 = $oQP.NewOptionalContentGroup("OCG 1");
		$iOCG2 = $oQP.NewOptionalContentGroup("OCG 2");
		$iOCG3 = $oQP.NewOptionalContentGroup("OCG 3");
		$iOCG4 = $oQP.NewOptionalContentGroup("OCG 4");

		; Select the page that you want the OCGs to be associated with.
		$oQP.SelectPage(1);

		; Specify top left corner for starting point of all drawing functions.
		$oQP.SetOrigin(1);

		; Add OCG 1
		$oQP.NewContentStream();
		$oQP.SelectContentStream(1);
		$oQP.DrawText(100, 100, "OCG 1");
		$oQP.SetContentStreamOptional($iOCG1);
		$oQP.SetOptionalContentGroupVisible($iOCG1, 1);

		; Add OCG 2
		$oQP.NewContentStream();
		$oQP.SelectContentStream(2);
		$oQP.DrawText(200, 100, "OCG 2");
		$oQP.SetContentStreamOptional($iOCG2);
		$oQP.SetOptionalContentGroupVisible($iOCG2, 1);

		; Add OCG 3
		$oQP.NewContentStream();
		$oQP.SelectContentStream(3);
		$oQP.DrawText(300, 100, "OCG 3");
		$oQP.SetContentStreamOptional($iOCG3);
		$oQP.SetOptionalContentGroupVisible($iOCG3, 1);

		; Add OCG 4
		$oQP.NewContentStream();
		$oQP.SelectContentStream(4);
		$oQP.DrawText(400, 100, "OCG 4");
		$oQP.SetContentStreamOptional($iOCG4);
		$oQP.SetOptionalContentGroupVisible($iOCG4, 1);

		; Save file to disk with new OCGs
		$oQP.SaveToFile(@ScriptDir + "\OCGs.pdf");

		; Load the new PDF in Adobe Reader
		ShellExecute(@ScriptDir + "\OCGs.pdf")
	EndIf
EndFunc   ;==>_Example
#EndRegion Functions
