#Tidy_Parameters=/sort_funcs /reel
;~ #AutoIt3Wrapper_Run_Debug_Mode=Y

#Region Include
#Tidy_Parameters=/reel
#include-once
#include <array.au3>
#include "QuickPDF.au3"
#EndRegion Include

; uncomment this followed linet to use commercial or trial license for last library version
; _QPDF_NewLibraryPath_Commercial(@ScriptDir & '\DebenuPDFLibraryAX1112.dll', 'DebenuPDFLibraryAX1112.PDFLibrary', '{AAC7EC02-5945-4ED6-A1E3-2FD000A8A6D2}', '{9CD13D3B-DB99-4D3F-ACAB-20D4F7898967}')

_QPDF_UseErrorHandler()

; set LicenseKey - blank for Lite = Free Debenu Version
_QPDF_SetLicenseKey('')

_QPDF_SecurityInfo_EXAMPLE()

Func _QPDF_SecurityInfo_EXAMPLE()
	; change @ScriptDir & '\Example_BarCodes.pdf' to your own PDF File
	Local $aResult = _QPDF_SecurityInfo(@ScriptDir & '\Example_BarCodes.pdf')
	If UBound($aResult) Then
		_ArrayDisplay($aResult)
	EndIf
EndFunc   ;==>_QPDF_SecurityInfo_EXAMPLE

; #FUNCTION# ====================================================================================================================
; Name ..........: _QPDF_SecurityInfo
; Description ...: Get information from PDF File
; Syntax ........: _QPDF_SecurityInfo($sPDF_FileFullPath[, $sPDF_Password = ''])
; Parameters ....: $sPDF_FileFullPath   - A string value.
;                  $sPDF_Password       - [optional] A string value. Default is ''.
; Return values .: succes: array with the following info:
;					0 = PDF Version
;					1 = Author
;					2 = Title
;					3 = Subject
;					4 = Keywords
;					5 = Creator
;					6 = Producer
;					7 = Creation date
;					8 = Modification date
; Author ........: mLipok
; Modified ......:
; Remarks .......: it works with Lite (free) version ie. DebenuPDFLibraryLite1112.dll
; Related .......:
; Link ..........:
; Example .......: Yes
; ===============================================================================================================================
Func _QPDF_SecurityInfo($sPDF_FileFullPath, $sPDF_Password = '')
	#CS
		Parameters
		SecurityItem 0 = Security Method
		1 = User Password
		2 = Owner Password
		3 = Printing
		4 = Changing the Document
		5 = Content Copying or Extraction
		6 = Authoring Comments and Form Fields
		7 = Form Field Fill-in or Signing
		8 = Content Accessibility Enabled
		9 = Document Assembly
		10 = Encryption Level
		11 = Opened with User password
		12 = Opened with Owner password
		13 = Variable Encryption Strength

		Return values
		0 None
		1 Adobe Standard Security
		2 No
		3 Yes
		4 Fully Allowed
		5 Not Allowed
		6 Allowed
		7 40-bit RC4 (Acrobat 3.x, 4.x)
		8 128-bit RC4 (Acrobat 5.x)
		9 Unknown
		10 Low resolution
		11 Blank
		12 128-bit AES (Acrobat 7)
		13 256-bit AES (Acrobat 9)
		14 Variable length RC4 (use SecurityItem=13 to determine the length)
		15 256-bit AES (Acrobat X)

	#CE

	Local $oQP
	If _QPDF_CreateObjectAndUnlock($oQP) = 1 Or _QPDF_CreateObjectAndUnlock($oQP) = 2 Then
		If $oQP.LoadFromFile($sPDF_FileFullPath, $sPDF_Password) Then
			Local $aReturn[14] = [ _
					$oQP.SecurityInfo(0), _
					$oQP.SecurityInfo(1), _
					$oQP.SecurityInfo(2), _
					$oQP.SecurityInfo(3), _
					$oQP.SecurityInfo(4), _
					$oQP.SecurityInfo(5), _
					$oQP.SecurityInfo(6), _
					$oQP.SecurityInfo(7), _
					$oQP.SecurityInfo(8), _
					$oQP.SecurityInfo(9), _
					$oQP.SecurityInfo(10), _
					$oQP.SecurityInfo(11), _
					$oQP.SecurityInfo(12), _
					$oQP.SecurityInfo(13) _
					]
			Return $aReturn
		Else
			_QPDF_LastErrorCode($oQP)
		EndIf
	Else
	EndIf

	$oQP = 0 ; CleanUp - destroy object
EndFunc   ;==>_QPDF_SecurityInfo
